@extends('app')

@section('system_backup_active', 'class="active"')

@section('content')
<div id="custom_alert"></div>
<input name="selected" id="selected" type="hidden" value="">
<input name="refresh_count" id="refresh_count" type="hidden" value="<?php echo $refresh_count; ?>">
<input name="refresh_last_id" id="refresh_last_id" type="hidden" value="<?php echo $refresh_last_id; ?>">
<h3><i class='fa fa-{{ $product_feature->glyph_name }}'></i>&nbsp;&nbsp;{{ $product_feature->label_plural }} &nbsp;&nbsp;<a href="/help/topics/#t=<?php echo $topicurl; ?>" target="_blank" class="btn btn-primary" role="button"><i class='fa fa-lg fa-question-circle'></i></a>
<br>
@can('create_system_backup')<button type="button" style="margin-top:10px; margin-right:10px;" name="createButton" id="createButton" class="btn btn-success" onclick="create_button()"><i class='fa fa-plus'></i> Create Backup</button>@endcan @can('delete_system_backup')<button type="button" style="margin-top:10px; margin-right:10px;"  name="deleteButton" id="deleteButton" class="btn btn-danger" onclick="delete_selected_button()"><i class='fa fa-trash'></i> Delete</button>@endcan @can('restore_system_backup')<button type="button" style="margin-top:10px; margin-right:10px;"  name="restoreButton" id="restoreButton" class="btn btn-primary" onclick="restore_selected_button()"><i class='fa fa-rotate-left'></i> Restore</button>@endcan @can('settings_system_backup')<button type="button" style="margin-top:10px; margin-right:10px;"  name="settingsButton" id="settingsButton" class="btn btn-primary" onClick="settings_button()"><i class='fa fa-list-ol'></i> Settings</button>@endcan @can('import_export_system_backup')<button type="button" style="margin-top:10px; margin-right:10px;"  name="exportButton" id="exportButton" class="btn btn-primary" onclick="export_selected_button()"><i class='fa fa-upload'></i> Export</button><button type="button" style="margin-top:10px; margin-right:10px;"  name="importButton" id="importButton" class="btn btn-primary" onclick="import_button()"><i class='fa fa-download'></i> Import</button>&nbsp;&nbsp;<font id="export_creation_text" hidden="YES"><i class="fa fa-refresh fa-spin fa-fw"></i>&nbsp;Creating export file ...</font><font id="export_progress_text" hidden="YES">Export Progress:&nbsp;&nbsp;</font><progress id="progressBar" value="0" hidden="YES"></progress>&nbsp;<font id="export_progress_precentage" hidden="YES"></font>@endcan</h3>
<strong>Backup Directory:</strong>&nbsp;&nbsp;<?php echo $backup_settings->backup_dir; ?>
<div id="status"></div>
<div class="row">
        <div class="col-md-8">
          <table id="system_backup_table" class="table table-striped">
            <thead>
              <tr>
                <th class="text-nowrap" data-align="center" data-width="50"></th>
                <th class="text-nowrap" data-align="center" data-width="50">Select</th>
                <th class="text-nowrap" data-align="center" data-width="50">Keep</th>
                <th class="text-nowrap" data-align="center"><div class="gray-background">Description</th>
                <th class="text-nowrap" data-align="center" data-field="date" data-sortable="true"  data-sort-name="_date_data" data-sorter="dateSorter">Date/Time</div></th>
			    <th class="text-nowrap" data-align="center" data-sortable="true"><div class="gray-background">Type</div></th>
              </tr>
            </thead>
            <tbody>
            @foreach ($system_backups as $system_backup)
              <tr>
              <td class="text-nowrap" data-align="center">
              @can('edit_system_backup')<a href="{{ action('SystemBackupController@edit', [$system_backup->id]) }}" class="btn btn-xs btn-primary" role="button"><i class='fa fa-pencil'></i></a> @endcan
              </td>
              <td class="text-nowrap" data-align="center">
                  @if(Gate::check('import_export_system_backup') || Gate::check('delete_system_backup') || Gate::check('restore_system_backup')) <button type="button" class="btn btn-default" id="checkbox{!! $system_backup->id !!}" name="checkbox{!! $system_backup->id !!}" onclick ="select_row({!! $system_backup->id !!})" value="0"><span id="button_glyph{!! $system_backup->id !!}"><i class='fa fa-square-o'></i></span></button>@endif
                    </td>
                   <td class="text-nowrap" data-align="center"><?php if($system_backup->keep==1){echo '<span class="label label-success">Yes</span>';}else{echo '<span class="label label-danger">No</span>';}?></td>
                <td class="text-nowrap" data-align="center"><?php if(strlen($system_backup->description)>30){ echo substr($system_backup->description, 0, 30).' ...'; } else { echo $system_backup->description; }?></td>
                <td class="text-nowrap" data-align="center"  data-fulldate="<?php echo strtotime($system_backup->date_time);?>"><?php echo date('M d, Y -  g:ia', strtotime( $system_backup->date_time)); ?></td>
                <td class="text-nowrap" data-align="center"><?php if($system_backup->file_type=='FULL'){echo 'SYSTEM'; } else { echo $system_backup->file_type; } ?></td>
              </tr>
              @endforeach
              
            </tbody>
          </table>
        </div>
        </div>
        
<!--  start delete modal -->
					<div class="modal bs-example-modal-sm modal-delete" tabindex="-1" role="dialog" aria-labelledby="modal-delete">
 						<div class="modal-dialog" data-backdrop="static" data-keyboard="false">
   						<div class="modal-content">
    							 <div class="modal-header">       							
                                <h4 class="modal-title"><p align="center">Delete</p></h4>
      							</div>
     							<div class="modal-body"><p align="center">
                                Are you sure you want to delete the selected backups?</p>
     							</div>
     							<div class="modal-footer">        							
                                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
        						<button type="button" name="deleteButtonModal" id="deleteButtonModal" class="btn btn-danger" onclick="delete_modal()"><i class='fa fa-trash'></i> Delete</button>
     							</div>
   						</div>  							
                        </div>
						</div>
<!--  end delete modal -->        
<!--  start restore modal -->
					<div class="modal bs-example-modal-sm modal-restore" tabindex="-1" role="dialog" aria-labelledby="modal-restore" data-backdrop="static" data-keyboard="false">
 						<div class="modal-dialog">
   						<div class="modal-content">
    							 <div class="modal-header">       							
                                <h4 class="modal-title"><p align="center">Restore</p></h4>
      							</div>
     							<div class="modal-body"><p align="center">Are you sure you want to restore this backup?
     							</p></div>
     							<div class="modal-footer">        							
                                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
        						<button type="button" name="restoreButtonModal" id="restoreButtonModal" class="btn btn-primary" onclick="restore_modal()"><i class='fa fa-rotate-left'></i> Restore</button>
     							</div>
   						</div>  							
                        </div>
						</div>
<!--  end restore modal -->

<!--  start import modal -->
					<div class="modal bs-example-modal-sm modal-import" tabindex="-1" role="dialog" aria-labelledby="modal-import" data-backdrop="static" data-keyboard="false">
 						<div class="modal-dialog">
   						<div class="modal-content">
    							 <div class="modal-header">       							
                                <h4 class="modal-title"><p align="center">Import</p></h4>
      							</div>
     							<form method="POST" action="/system_backup/import_file" class="form-horizontal" enctype="multipart/form-data">
        						<input type="hidden" name="_token" value="{{ csrf_token() }}">
                                    
                                <div align="center" class="modal-body">
                            	
                                    <div style="text-align:center; width:60%;">
                						<input id="fileupload" name="fileupload" type="file" class="filestyle" data-buttonName="btn-primary" data-buttonText="&nbsp;Choose file" data-size="sm" data-placeholder="No file selected">
                                    </div>
     						
                                </div>
     							<div class="modal-footer">        							
                                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
        						<button  type="submit" onclick="this.disabled=true;forms[0].submit();" name="importButtonModal" id="importButtonModal" class="btn btn-primary"><i class='fa fa-download'></i> Import</button>
     							</div>
                              </form>
   						</div>  							
                        </div>
						</div>
<!--  end import modal -->

<!--  start backup modal -->
					<div class="modal bs-example-modal-sm createModal" id="modal-restart-server" tabindex="-1" role="dialog" aria-labelledby="modal-restart-server" data-backdrop="static" data-keyboard="false">
 						<div class="modal-dialog">
   						<div class="modal-content">
    							 <div class="modal-header">       							
                                <h4 class="modal-title"><p align="center">Create Backup</p></h4>
      							</div>
                                <div align="center" class="modal-body">
                            	
                                    <div style="text-align:center; width:60%;">
                                    <a data-toggle="tooltip" title="Create a system backup."><i class='fa fa-lg fa-info-circle'></i></a><button  type="submit" name="systemButton" id="systemButton" onClick="system_backup('system')" class="btn btn-success" style="margin:10px;min-width:150px;"><i class='fa fa-plus'></i> System</button><br>
                                     <a data-toggle="tooltip" title="Create a voicemail backup."><i class='fa fa-lg fa-info-circle'></i></a><button  type="submit" name="voicemailButton" id="voicemailButton" onClick="system_backup('voicemail')" class="btn btn-success" style="margin:10px;min-width:150px;"><i class='fa fa-plus'></i> Voicemail</button><br>
                                     <a data-toggle="tooltip" title="Create a recordings backup."><i class='fa fa-lg fa-info-circle'></i></a><button  type="submit" name="recordingsButton" id="recordingsButton" onClick="system_backup('recordings')" class="btn btn-success" style="margin:10px;min-width:150px;"><i class='fa fa-plus'></i> Recordings</button>
                						
                                    </div>
                                </div>
     							<div class="modal-footer">        							
                                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
     							</div>
   						</div>  							
                        </div>
						</div>
<!--  end backup modal -->

<!--  start delete kept modal -->
					<div class="modal bs-example-modal-sm deleteKeptModal" tabindex="-1" role="dialog" aria-labelledby="deleteKeptModal">
 						<div class="modal-dialog" data-backdrop="static" data-keyboard="false">
   						<div class="modal-content">
    							 <div class="modal-header">       							
                                <h4 class="modal-title"><p align="center">Delete</p></h4>
      							</div>
     							<div class="modal-body"><p align="center">
                                Are you sure you want to delete the selected backups?<br>
									At least one of the backups is marked as Keep.</p>
     							</div>
     							<div class="modal-footer">        							
                                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
        						<button type="button" name="deleteButtonModal" id="deleteButtonModal" class="btn btn-danger" onclick="delete_modal()"><i class='fa fa-trash'></i> Delete</button>
     							</div>
   						</div>  							
                        </div>
						</div>
<!--  end delete kept modal -->  
@stop

@section('title')
	{{ $product_feature->label_plural }}

@stop

@section('footer')

<script>
// calculate the table height
 var document_height = window.innerHeight;
 var table_height = parseInt(document_height*0.8);
 
 $(document).ready(function() { 
													
	var refreshList = setInterval(refreshTimer, 5000);

	function refreshTimer() {
		var xmlhttp=new XMLHttpRequest();
    	xmlhttp.onreadystatechange=function() {
        	if (xmlhttp.readyState==4 && xmlhttp.status==200) {
				// success 
				//alert(xmlhttp.responseText);
				
				var refresh_count = document.getElementById("refresh_count");
				var refresh_last_id = document.getElementById("refresh_last_id");
			
				var str = xmlhttp.responseText;
				var dataArray = str.split("&");
				var array_count = dataArray[0];
				var last_record_id = dataArray[1];
				
				//alert(refresh_count.value + ',' + array_count + '--' + refresh_last_id.value + ',' + last_record_id);
				
				// see if systems_backup changed
				if(refresh_count.value==array_count && refresh_last_id.value==last_record_id){
					// do nothing
				} else {
					// refresh view
					window.location.href = '/system_backup';	
				}	
        	}
		}
	 	xmlhttp.open("GET","/system_backup/refresh_list/",true);
   		xmlhttp.send();
	}						
							
});
// create button
function create_button(){	
	$('.createModal').modal('show');
 }
// system_backup
function system_backup(type){
	
	$('.createModal').modal('hide');
	
	// start activitiy indicator
  	document.getElementById("status").innerHTML = '<br><h4><i class="fa fa-refresh fa-spin fa-fw margin-bottom"></i>&nbsp;Creating Backup ...</h4>';
		
	disableButtons();
	
	var xmlhttp=new XMLHttpRequest();
    	xmlhttp.onreadystatechange=function() {
        	if (xmlhttp.readyState==4 && xmlhttp.status==200) {
				// success 
				//console.log(xmlhttp.responseText);
				window.location.href = '/system_backup/error_message/4';
        	}
		}
	 	xmlhttp.open("GET","/system_backup/create_backup/" + type,true);
   		xmlhttp.send();        	
 }
// select button
function select_row(record_id) {
	var checkbox_on_off = document.getElementById("checkbox" + record_id).value;
	if(checkbox_on_off==0){
		document.getElementById("checkbox" + record_id).value = 1;
		document.getElementById("button_glyph" + record_id).innerHTML = '<i class=\'fa fa-check-square-o\'></i>';
		$("#checkbox" + record_id).removeClass("btn-default").addClass("btn-success");
	} else {
		document.getElementById("checkbox" + record_id).value = 0;
		document.getElementById("button_glyph" + record_id).innerHTML = '<i class=\'fa fa-square-o\'></i>';
		$("#checkbox" + record_id).removeClass("btn-success").addClass("btn-default");
	}
	var selected = document.getElementById("selected");
	var selectedArray = selected.value.split(",");
	var removed = '';
	var found = 0;
	var i = 0;
	var index = 0;
	for (var data in selectedArray) {
    	if(selectedArray[data]==record_id && selectedArray[data]>0){
			found = 1;
			index = i;
		}
		i++;
	}
	if(found==0){
		selectedArray.push(record_id);
	} else {
		removed = selectedArray.splice( index, 1 );
	}
	
	selected.value = selectedArray.toString();
	
	// remove comma in first position if exists
	if (selected.value.substring(0, 1) == ',') { 
  		selected.value = selected.value.substring(1);
	}
}
//delete selected button
function delete_selected_button() {
			
	var selected = document.getElementById("selected");
	var selectedArray = selected.value.split(",");
	var n = selectedArray.length;
	
	if(n>0 && selectedArray[0]>0){
		check_for_kept();
	} else {
		window.location.href = '/system_backup/error_message/1';
	}
}
// check for kept backups
function check_for_kept() {
	var selected = document.getElementById("selected");	
	var xmlhttp=new XMLHttpRequest();
    	xmlhttp.onreadystatechange=function() {
        	if (xmlhttp.readyState==4 && xmlhttp.status==200) {
				// success 
				//alert(xmlhttp.responseText);
				if(xmlhttp.responseText>0){
					// show modal
					$('.deleteKeptModal').modal('show');
				} else {
					$('.modal-delete').modal('show');	
				}
        	}
		}
	 	xmlhttp.open("GET","/system_backup/check_for_kept/" + selected.value,true);
   		xmlhttp.send();
}
// delete modal button
function delete_modal() {
	
	$('.modal-delete').modal('hide');
	
	disableButtons();
	
	// start activitiy indicator
  	document.getElementById("status").innerHTML = '<br><h4><i class="fa fa-refresh fa-spin fa-fw margin-bottom"></i>&nbsp;Deleting Backups ...</h4>';
		
	var selected = document.getElementById("selected");	
	window.location.href = '/system_backup/delete_selected/' + selected.value;

}
// restore selected button
function restore_selected_button() {
			
	var selected = document.getElementById("selected");
	var selectedArray = selected.value.split(",");
	var n = selectedArray.length;
	
	if(n==1 && selectedArray[0]>0){	
		$('.modal-restore').modal('show');
	} else {
		window.location.href = '/system_backup/error_message/2';
	} 
}
// restore modal button
function restore_modal() {
	
	$('.modal-restore').modal('hide');
	
	disableButtons();
	
	 // start activitiy indicator
  	document.getElementById("status").innerHTML = '<br><h4><i class="fa fa-refresh fa-spin fa-fw margin-bottom"></i>&nbsp;Restoring Backup ...</h4>';
	
	var selected = document.getElementById("selected");
	
	window.location.href = '/system_backup/restore_selected/' + selected.value;
}
// export selected button
function export_selected_button() {
	
	disableButtons();
			
	var selected = document.getElementById("selected");
	var selectedArray = selected.value.split(",");
	var n = selectedArray.length;
	
	if(n==1 && selectedArray[0]>0){	
		
		$('#export_creation_text').show();
		
		var xmlhttp=new XMLHttpRequest();
    	xmlhttp.onreadystatechange=function() {
        	if (xmlhttp.readyState==4 && xmlhttp.status==200) {
				// success 
				//alert(xmlhttp.responseText);
				
				$('#export_creation_text').hide();
				
				if(xmlhttp.responseText .substring(0, 5) == 'FILE:'){
					
					var filename = xmlhttp.responseText.substring(5);
					var filename2 = filename.substring(0,20);
					
					var xhr = new XMLHttpRequest();
					xhr.open("GET", '/exports/' + filename, true);
					xhr.responseType = "text";
					xhr.onprogress = function(e) {
						if (e.lengthComputable) {
							progressBar.max = e.total;
							progressBar.value = e.loaded;
							var percentage = e.loaded / e.total * 100; 
							var formatted = percentage.toFixed(0);
							//console.log(percentage);
							
							document.getElementById("export_progress_precentage").innerHTML = formatted + '%';
						}
					};
					xhr.onloadstart = function(e) {
						progressBar.value = 0;
				
						// show bar
						$('#progressBar').show();
						$('#export_progress_text').show();
						$('#export_progress_precentage').show();
						
					};
					xhr.onloadend = function(e) {
						progressBar.value = e.loaded;
						
						// hide bar
						$('#progressBar').hide();
						$('#export_progress_text').hide();
						$('#export_progress_precentage').hide();
						
						// send growl notification
						$.bootstrapGrowl("Export file " + filename + " downloaded.", {
						  ele: 'body', // which element to append to
						  type: 'success', // (null, 'info', 'error', 'success')
						  offset: {from: 'top', amount: 50}, // 'top', or 'bottom'
						  align: 'right', // ('left', 'right', or 'center')
						  width: 350, // (integer, or 'auto')
						  delay: 10000,
						  allow_dismiss: true,
						  stackup_spacing: 10 // spacing between consecutively stacked growls.
						}); 
						
						// download file
						window.location.href = '/exports/' + filename;
						
						// remove file from server
						remove_export_file(filename);
						
						// unselect all checkboxes / clear selection variable
						// $('input[type="checkbox"]').each(function(){ this.checked = false });
						// document.getElementById("selected").value = '';
						
						enableButtons();
					};
					xhr.send(null);
					
				} else if(xmlhttp.responseText == 'no_permission'){
					// send growl notification
					$.bootstrapGrowl("You no longer have permissions to import/export backups.", {
					  ele: 'body', // which element to append to
					  type: 'danger', // (null, 'info', 'error', 'success')
					  offset: {from: 'top', amount: 50}, // 'top', or 'bottom'
					  align: 'right', // ('left', 'right', or 'center')
					  width: 350, // (integer, or 'auto')
					  delay: 10000,
					  allow_dismiss: true,
					  stackup_spacing: 10 // spacing between consecutively stacked growls.
					}); 
					
					enableButtons();
				} else {			
					// send growl notification
					$.bootstrapGrowl("No export file downloaded.", {
					  ele: 'body', // which element to append to
					  type: 'danger', // (null, 'info', 'error', 'success')
					  offset: {from: 'top', amount: 50}, // 'top', or 'bottom'
					  align: 'right', // ('left', 'right', or 'center')
					  width: 350, // (integer, or 'auto')
					  delay: 10000,
					  allow_dismiss: true,
					  stackup_spacing: 10 // spacing between consecutively stacked growls.
					}); 
					
					enableButtons();
				}
        	}
		}
	 	xmlhttp.open("GET","/system_backup/export/" + selected.value,true);
   		xmlhttp.send();
		
	} else {
		window.location.href = '/system_backup/error_message/3';
		exportButton.disabled = false;
	} 
}

function remove_export_file(filename) {
	
	var xmlhttp=new XMLHttpRequest();
    	xmlhttp.onreadystatechange=function() {
        	if (xmlhttp.readyState==4 && xmlhttp.status==200) {
				// success 
				//alert(xmlhttp.responseText);
        	}
		}
	 	xmlhttp.open("GET","/system_backup/remove_export_file/" + filename,true);
   		xmlhttp.send();
}

// import button
function import_button() {
	
	$('.modal-import').modal('show');
}

function import_modal_button(){
	
	var fileupload = document.getElementById("fileupload").value;
	alert(fileupload);
}

// Flash message
$('div.alert').delay(5000).slideUp(300);
// tool tip
$(function () {
  $('[data-toggle="tooltip"]').tooltip()
});
// bootstrap-table settings
$('#system_backup_table').bootstrapTable({
    search: true,
	height: table_height,
	striped: false,
	classes: 'table',
	showToggle: true,
	trimOnSearch: false,
}).on('sort.bs.table', function (e, name, order) {
	
	var isMobile = navigator.userAgent.match(/(iPhone|iPad|Android)/);
	if(isMobile){
		setTimeout(function(){
			$('.tooltip').hide(); // hide tooltip when sorting											
		}, 3000);
	} else {
		$('.tooltip').hide(); // hide tooltip when sorting	
	}
}).on('all.bs.table', function (e, name, order) {
	tooltipExe() // reactivates tooltips after sorting or swithcing to cardview
}).on('click-row.bs.table', function (e, row, $element) { // change row color to blue on click
    		$('.info').removeClass('info');
    		$($element).addClass('info');
});

function tooltipExe(){
	$('[data-toggle="tooltip"]').tooltip()
};
function settings_button(){
		window.location.href ="/backup_settings/1/edit";
}
// disable buttons
function disableButtons(){
	if(document.getElementById('createButton')){
		createButton.disabled = true;
	}
	if(document.getElementById('deleteButton')){
		deleteButton.disabled = true;
	}
	if(document.getElementById('restoreButton')){
		restoreButton.disabled = true;
	}
	if(document.getElementById('settingsButton')){
		settingsButton.disabled = true;
	}
	if(document.getElementById('exportButton')){
		exportButton.disabled = true;
	}
	if(document.getElementById('importButton')){
		importButton.disabled = true;
	}
}
// enable buttons
function enableButtons(){
	if(document.getElementById('createButton')){
		createButton.disabled = false;
	}
	if(document.getElementById('deleteButton')){
		deleteButton.disabled = false;
	}
	if(document.getElementById('restoreButton')){
		restoreButton.disabled = false;
	}
	if(document.getElementById('settingsButton')){
		settingsButton.disabled = false;
	}
	if(document.getElementById('exportButton')){
		exportButton.disabled = false;
	}
	if(document.getElementById('importButton')){
		importButton.disabled = false;
	}
}
function dateSorter(a, b) {
    if (a.fulldate < b.fulldate) return -1;
    if (a.fulldate > b.fulldate) return 1;
    return 0;
}
</script>
@endsection

