<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use App\Http\Requests;
use App\Http\Controllers\Controller;
use App\System;
use App\System_help;
use App\Extensions_table;
use App\Ps_aors;
use App\Ps_auths;
use App\Ps_endpoint;
use App\Zone_sublist;
use App\Station;
use App\Product_feature;
use App\Tone;
use App\Queues;
use App\Queue_members;
use App\Timezones;
use App\Admin_group;
use App\Pagingzone;
use App\Multicast_rtp;
use App\User;
use App\Station_template;
use App\Voicemail;
use App\Trunk_priority_enum;
use App\Announcement;
use App\Call_state;
use App\Dashboard_msg;
use App\Outside_line;
use App\Sip_trunk;
use App\Cos;
use App\Role;
use App\Role_user;
use App\Permission_role;
use App\Playlists;
use App\Recording;
use App\Songs;
use App\Song_playlist;
use App\Schedule_announcements;
use App\Schedule_settings;
use App\Schedules;
use App\Schedule_exceptions;
use App\Schedule_events;
use App\Holidays;
use App\Paging_exclusion;
use App\Permission;
use App\Server;
use App\Gateway;
use App\Help;
use App\Call_details;
use App\Ctrl_rule;
use App\Io_contact_sched;
use App\Mixer_channel;
use App\Mixer_config;
use App\Analog_line;
use App\Maps;
use App\Map_button;
use App\Zones_queue;
use App\Zones_queue_subs;
use App\Amplifier;
use App\Intercom_config;
use App\Ans_listeners;
use App\Display;
use App\Message;
use App\Routine;
use App\Routine_trigger;
use App\Routine_action;
use App\Weather_alert_filter;
use Input;
use Gate;
use Auth;
use DB;

class SystemController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return Response
     */
    public function index()
    {	
		 // restricted by permission
		if(Gate::denies('view_systems') || Gate::denies('view_facilities')) {
			// send growl notification
			session()->flash('growl_notification.message','You no longer have permissions to view systems.');
			session()->flash('growl_notification.level','danger');
			return redirect('dashboard');
		} 
	
		$systems = System::
			leftJoin('tone', 'system.emergency_tone', '=', DB::raw('CONCAT("/var/lib/asterisk/sounds/pre/",  tone.file_name)'))
			->leftJoin('tone as tone2', 'system.all_call_tone', '=', DB::raw('CONCAT("/var/lib/asterisk/sounds/pre/", tone2.file_name)'))
			->leftJoin('tone as tone3', 'system.intercom_tone', '=', DB::raw('CONCAT("/var/lib/asterisk/sounds/pre/", tone3.file_name)'))
			->leftJoin('trunk_priority_enum', 'system.trunk_priority', '=', 'trunk_priority_enum.id')
			->leftJoin('cos', 'system.remote_facility_cos', '=', 'cos.id')
			->select('system.id as id', 'system.name as name', 'day_start', 'night_start', 'ip_multicast_rtp',  'ip_ntp_server','default_station_password', 'disable_preannounce_tone', 'dialing_length', 'emergency_tone', 'all_call_tone', 'privacy_beep',  'default_codecs_allowed', 'valid_codec_list', 'default_volume', 'intercom_tone', 'parking_lot', 'tone.file_name as emergency_tone_file_name', 'tone.name as emergency_tone_name','tone2.name as all_call_tone_name','tone2.file_name as all_call_tone_file_name', 'tone3.name as intercom_tone_name','tone3.file_name as intercom_tone_file_name','system.time_zone as time_zone', 'system.admin_queue_timeout as admin_queue_timeout','system.dhcp_override as dhcp_override', 'system.nightring_enabled as nightring_enabled', 'system.nightring_admin_extension as nightring_admin_extension', 'system.nightring_admin_group as nightring_admin_group','system.nightring_zonelist as nightring_zonelist','system.nightring_allstations as nightring_allstations','system.server_ipaddr as server_ipaddr','system.audiodist_multicast_ip as audiodist_multicast_ip','system.record_monitoring as record_monitoring','system.emergency_link as emergency_link','max_restricted_digits','call_log_length','trunk_priority','trunk_priority_enum.name as trunk_priority_name','bump_on_emergency','bump_on_911', 'auth_code','call_assurance_audio','ip_multicast_port','audiodist_multicast_port','remote_facility_cos','cos.name as remote_facility_cos_name','neighbor_secret','rtpstart','rtpend','rtpchecksums','icesupport','stunaddr','turnaddr','turnusername','turnpassword','allcall_multicast_ip','allcall_multicast_port','eallcall_volume','allcall_volume','audiodist_volume','retention_recordings','backup_retention_system','backup_retention_recordings','backup_retention_voicemail','appliance_ntp_source','ans_multicast_ip','ans_multicast_port','allow_local_eallcall_page_interrupt','allow_multisite_eallcall_page_interrupt','pin_multisite_emerg_all_call','pin_multisite_all_call','pin_facility_page','pin_emerg_all_call','pin_all_call','pin_emerg_announcement','pin_announcement','pin_zone_page','pin_alarm','pin_tone')
            ->get();
		$system_help = System_help::all();
		$product_feature = Product_feature::where('product_feature.class_name', 'like', 'system')->get()->first();
		$product_feature_admin = Product_feature::where('product_feature.name', 'like', 'admin')->get()->first();
		$nr_admin = Product_feature::where('product_feature.name', '=', 'nr_admin')->get()->first();
		$nr_admin_group = Product_feature::where('product_feature.name', '=', 'nr_admin_group')->get()->first();
		$nr_zones = Product_feature::where('product_feature.name', '=', 'nr_zones')->get()->first();
		$nr_all_stations = Product_feature::where('product_feature.name', '=', 'nr_all_stations')->get()->first();
		
		// help topics
		$topicurl = '';
		$help = Help::where('mapid','like','system')->get()->first();
		if(count($help)>0){
			$topicurl = $help->topicurl;
		}
		
		// run script for maximum concurrent calls limit
	    	$script_path1 = '/usr/local/bin/get-calls-info -m';
		$maximum_concurrent_calls_limit = shell_exec($script_path1);
		$maximum_concurrent_calls_limit = trim($maximum_concurrent_calls_limit);
		  
	 	// run script for current call count
		$script_path2 = '/usr/local/bin/get-calls-info -c';
		$current_call_count = shell_exec($script_path2);

		// Get limits from licinfo
		$script_path2 = '/usr/local/bin/licinfo -f';
		$licinfo_limits = shell_exec($script_path2);
		$lic_limits = explode(',',$licinfo_limits);

		if (count($lic_limits) > 1)
		{
			$maximum_intercom_calls = $lic_limits[0];
			$maximum_page_stacking_queues = $lic_limits[1];
			$station_limit = $lic_limits[2];
			$pagezone_limit = $lic_limits[3];
		}
		else
		{
			// run script for station limit
			$script_path = '/usr/local/bin/licinfo -s';
			$station_limit = shell_exec($script_path);
		
			// run script for page zone limit
			$script_path = '/usr/local/bin/licinfo -z';
			$pagezone_limit = shell_exec($script_path);

			// run script for maximum intercom calls allowed
			$script_path = '/usr/local/bin/licinfo -i';
			$maximum_intercom_calls = shell_exec($script_path);

			// run script for Maximum Page Stacking Queues
			$script_path = '/usr/local/bin/licinfo -q';
			$maximum_page_stacking_queues = shell_exec($script_path);
		}
		
		// get current page zone count
		$current_pagezone_count = Pagingzone::count();
			
		// get current station count
		$current_station_count = Station::whereNotIn('device_type', [14, 15])->whereNotIn('type', [27,28])->where('id','!=','1')->count();
		
		// Queue Count
		$queue_count = Zones_queue::count();
		
		$c4000_check = Product_feature::where('label','like', '%C4000%')->count();
		
        return view('system.index',compact('systems','system_help','product_feature','product_feature_admin','nr_admin','nr_admin_group','nr_zones','nr_all_stations','maximum_concurrent_calls_limit','current_call_count','station_limit','current_station_count','topicurl','pagezone_limit','current_pagezone_count','maximum_intercom_calls','queue_count','maximum_page_stacking_queues','c4000_check'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return Response
     */
    public function create()
    {
		 // restricted by permission
		if(Gate::denies('create_systems') || Gate::denies('view_facilities') || Gate::denies('view_systems')) {
			// send growl notification
			session()->flash('growl_notification.message','You no longer have permissions to create systems.');
			session()->flash('growl_notification.level','danger');
			return redirect('dashboard');
		} 
		
		$product_feature = Product_feature::where('product_feature.class_name', 'like', 'system')->get()->first();
		
     	return view('system.create', compact('product_feature'));   
    }

    /**
     * Store a newly created resource in storage.
     *
     * @return Response
     */
    public function store(Requests\SystemRequest $request)
    {
		// restricted by permission
		if(Gate::denies('create_systems') || Gate::denies('view_facilities') || Gate::denies('view_systems')) {
			// send growl notification
			session()->flash('growl_notification.message','You no longer have permissions to create systems.');
			session()->flash('growl_notification.level','danger');
			return redirect('dashboard');
		} 
		
		System::create($request->all());
		
		// send growl notification
		session()->flash('growl_notification.message',$request->name. ' Added.');
		session()->flash('growl_notification.level','success');
		return redirect('system');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return Response
     */
    public function show($id)
    {
        return redirect('dashboard');
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return Response
     */
    public function edit($id)
    {
		// restricted by permission
		if(Gate::denies('edit_systems') || Gate::denies('view_facilities') || Gate::denies('view_systems')) {
			// send growl notification
			session()->flash('growl_notification.message','You no longer have permissions to edit systems.');
			session()->flash('growl_notification.level','danger');
			return redirect('dashboard');
		} 
		
		$system = System::
			leftJoin('tone', 'system.emergency_tone', '=', DB::raw('CONCAT(tone.file_location, "/", tone.file_name, "_gsm")'))
			->leftJoin('tone as tone2', 'system.all_call_tone', '=', DB::raw('CONCAT(tone2.file_location, "/", tone2.file_name, "_gsm")'))
			->leftJoin('tone as tone3', 'system.intercom_tone', '=', DB::raw('CONCAT(tone3.file_location, "/", tone3.file_name, "_gsm")'))
			->leftJoin('trunk_priority_enum', 'system.trunk_priority', '=', 'trunk_priority_enum.id')
			->leftJoin('cos', 'system.remote_facility_cos', '=', 'cos.id')
			->select('system.id as id', 'system.name as name', 'day_start', 'night_start', 'ip_multicast_rtp', 'ip_ntp_server', 'default_station_password', 'default_codecs_allowed', 'valid_codec_list',  'disable_preannounce_tone', 'dialing_length', 'emergency_tone', 'all_call_tone', 'privacy_beep', 'default_volume', 'intercom_tone', 'tone.file_name as emergency_tone_file_name', 'tone.name as emergency_tone_name','tone2.file_name as all_call_tone_file_name', 'tone2.name as all_call_tone_name', 'tone3.file_name as intercom_tone_file_name', 'tone3.name as intercom_tone_name','system.time_zone as time_zone','system.admin_queue_timeout as admin_queue_timeout', 'system.dhcp_override as dhcp_override', 'system.nightring_enabled as nightring_enabled', 'system.nightring_admin_extension as nightring_admin_extension','system.nightring_admin_group as nightring_admin_group','system.nightring_zonelist as nightring_zonelist','system.nightring_allstations as nightring_allstations','server_ipaddr', 'audiodist_multicast_ip', 'parking_lot', 'record_monitoring','emergency_link', 'max_restricted_digits', 'disa_password','security_disa_password','call_log_length','trunk_priority','trunk_priority_enum.name as trunk_priority_name','bump_on_emergency','bump_on_911','auth_code','call_assurance_audio','ip_multicast_port','audiodist_multicast_port', 'neighbor_secret','remote_facility_cos','cos.name as remote_facility_cos_name','rtpstart','rtpend','rtpchecksums','icesupport','stunaddr','turnaddr','turnusername','turnpassword','allcall_multicast_ip','allcall_multicast_port','eallcall_volume','allcall_volume','audiodist_volume','retention_recordings','backup_retention_system','backup_retention_recordings','backup_retention_voicemail','system_password','appliance_ntp_source','ans_multicast_ip','ans_multicast_port','teamviewer_enabled','allow_local_eallcall_page_interrupt','allow_multisite_eallcall_page_interrupt','pin_multisite_emerg_all_call','pin_multisite_all_call','pin_facility_page','pin_emerg_all_call','pin_all_call','pin_emerg_announcement','pin_announcement','pin_zone_page','pin_alarm','pin_tone')
			->where('system.id', '=', $id)
            ->get()
			->first();
			
		// check to make sure there's a valid number in the url
		if(count($system)>0 && ctype_digit($id)){
		} else {
			return redirect('dashboard');
		}
				
		$nr_admin = Product_feature::where('product_feature.name', '=', 'nr_admin')->get()->first();
		$nr_admin_group = Product_feature::where('product_feature.name', '=', 'nr_admin_group')->get()->first();
		$nr_zones = Product_feature::where('product_feature.name', '=', 'nr_zones')->get()->first();
		$nr_all_stations = Product_feature::where('product_feature.name', '=', 'nr_all_stations')->get()->first();	
		$ip_address =  long2ip($system->ip_multicast_rtp);
		$allcall_ip_address =  long2ip($system->allcall_multicast_ip);
		$parts = explode(".", $ip_address);
		$allcall_parts = explode(".", $allcall_ip_address);
		$server_ip_address =  long2ip($system->server_ipaddr);
		$server_ipaddr_parts = explode(".", $server_ip_address);
		$audiodist_ip_address =  long2ip($system->audiodist_multicast_ip);
		$audiodist_ipaddr_parts = explode(".", $audiodist_ip_address);
		$ans_multicast_ip = $system->ans_multicast_ip;
		$ans_ip_address =  long2ip($system->ans_multicast_ip);
		$ans_ipaddr_parts = explode(".", $ans_ip_address);
		$product_feature = Product_feature::where('product_feature.class_name', 'like', 'system')->get()->first();
		$product_feature_zones = Product_feature::where('product_feature.class_name', 'like', 'paging-zones')->get()->first();
		$product_feature_admin = Product_feature::where('product_feature.name', 'like', 'admin')->get()->first();
		$tones = Tone::where('file_name','!=','pinknoise')->where('file_name','!=','whitenoise')->where('file_name','not like','%Line-Input%')->get();
		$system_help = System_help::all();
		$default_codecs_allowed = $system->default_codecs_allowed;
		$codecs = explode(';', $default_codecs_allowed);
		$valid_codec_list = $system->valid_codec_list;
		$codec_list = explode(';', $valid_codec_list);
		$nightring_zonelist = $system->nightring_zonelist;
		$selected_zones = explode(';', $nightring_zonelist);
		$timezones = Timezones::all();
		$trunk_priority_types = Trunk_priority_enum::get();
		$admins = Station::leftJoin('station_types_enum', 'station.type', '=', 'station_types_enum.id')
						->select('station.extension as extension','station.extension as extension','station.name as station_name', 'station_types_enum.id as type_id','station_types_enum.name as type_name','station_types_enum.help as type_help')
						->whereIn('station_types_enum.id', [1, 2, 3])
						->orderBy('station.extension','asc')
						->get();
		$admin_groups = Admin_group::orderBy('admin_group.name','asc')
						->get();
		$paging_zones = Pagingzone::whereIn('type',[1,3,5,6])->orderBy('zone_number','asc')
						->get();
		$cos_templates = Cos::get();
		
		// help topics
		$topicurl = '';
		$help = Help::where('mapid','like','system_edit')->get()->first();
		if(count($help)>0){
			$topicurl = $help->topicurl;
		}
		
		// get all stations
		$all_stations = Station::all();

		// get all day/night admin stations for those that are not type 1,2, or 3
		$day_night_admins = [];
		foreach($all_stations as $all_station){
			if(!in_array($all_station->type, [1,2,3])){
				$day_night_admins[] = $all_station->day_admin;
				$day_night_admins[] = $all_station->night_admin;
			}
		}
		// get stations for emergency_link drop down
		$emergency_link_stations = Station::select('station.extension as extension','station.name as station_name')
						->whereNotIn('station.extension', $day_night_admins)
						->whereNotIn('station.type', [6,13,17,19])
						->where('station.extension', '!=', '1')
						->orderBy('station.extension','asc')
						->get();
						
		// generate data for javascript buttons
		$clear_zones_text = '';
		$add_zones_text = '';
		$add_zones_val_text = '[';
		
		foreach($paging_zones as $paging_zone) {
    		$clear_zones_text = $clear_zones_text.'<option value="'.$paging_zone->zone_number.'">'.htmlentities($paging_zone->name,ENT_QUOTES).'</option>';
			$add_zones_text = $add_zones_text.'<option value="'.$paging_zone->zone_number.'" selected="selected">'.htmlentities($paging_zone->name,ENT_QUOTES).'</option>';
			$add_zones_val_text = $add_zones_val_text.''.$paging_zone->zone_number.','; 
		}
		$add_zones_val_text = $add_zones_val_text.']';
		
		// run script for maximum concurrent calls limit
		$script_path1 = '/usr/local/bin/get-calls-info -m';
		$maximum_concurrent_calls_limit = shell_exec($script_path1);
		$maximum_concurrent_calls_limit = trim($maximum_concurrent_calls_limit);
		  
		// run script for current call count
		$script_path2 = '/usr/local/bin/get-calls-info -c';
		$current_call_count = shell_exec($script_path2);	
		
		// Get limits from licinfo
		$script_path2 = '/usr/local/bin/licinfo -f';
		$licinfo_limits = shell_exec($script_path2);
		$lic_limits = explode(',',$licinfo_limits);

		if (count($lic_limits) > 1)
		{
			$maximum_intercom_calls = $lic_limits[0];
			$maximum_page_stacking_queues = $lic_limits[1];
			$station_limit = $lic_limits[2];
			$pagezone_limit = $lic_limits[3];
		}
		else
		{
			// run script for station limit
			$script_path = '/usr/local/bin/licinfo -s';
			$station_limit = shell_exec($script_path);

			// run script for page zone limit
			$script_path = '/usr/local/bin/licinfo -z';
			$pagezone_limit = shell_exec($script_path);
		
			// run script for maximum intercom calls allowed
			$script_path = '/usr/local/bin/licinfo -i';
			$maximum_intercom_calls = shell_exec($script_path);

			// run script for Maximum Page Stacking Queues
			$script_path = '/usr/local/bin/licinfo -q';
			$maximum_page_stacking_queues = shell_exec($script_path);
		}
		
		// get current station count
		$current_station_count = Station::whereNotIn('device_type', [14, 15])->whereNotIn('type', [27,28])->where('id','!=','1')->count();
		
		// get current page zone count
		$current_pagezone_count = Pagingzone::count();
		
		// Queue Count
		$queue_count = Zones_queue::count();
		
		  // DHCP Server Override switch - active/inactive
		  $dhcp_disabled = 0; 
		  $first_file_failed = 0;
		  $second_file_failed = 0;
		  $actual_file_name = '';
		  $filesArray = array();
		  
		  // get an array or file names
		  if(file_exists('/etc/NetworkManager/system-connections/')){
			  $directory = "/etc/NetworkManager/system-connections/";
			  $files = scandir($directory);
			  foreach($files as $file){
				  if(strpos($file, 'Wired connection') !== false) {
					  $file_mod_date = filemtime("/etc/NetworkManager/system-connections/".$file); // get mod date
					  array_push($filesArray, $file_mod_date.','.$file); // add time stamp to each name and save in array
				  }
			  }
		  }
		
		if(count($filesArray)>0){
			rsort($filesArray); // sort descending order
			$last_modified = $filesArray[0];
			$file_name_array = explode(",", $last_modified);
			$actual_file_name = $file_name_array[1]; // remove the time stamp
		}
		
		if($actual_file_name==''){
			  $first_file_failed = 1;
		  }
		
		  // check first config file
		  if(file_exists('/etc/NetworkManager/system-connections/'.$actual_file_name )){	
			  if(is_readable('/etc/NetworkManager/system-connections/'.$actual_file_name )){ // prevent crash, check to make sure the file is readable
				  $config_file1 = fopen("/etc/NetworkManager/system-connections/".$actual_file_name , "r");
				  
				 if(!$config_file1){
					 $first_file_failed = 1;
				 } else {
					 // go through the config file one line at a time
					 $found_ipv4 = 0;
						while(!feof($config_file1)) {
							$line_text = fgets($config_file1);
							if(strpos($line_text, 'ipv4') !== FALSE){
								$found_ipv4 = 1;
							} 
							if(strpos($line_text, 'method=manual') !== FALSE && $found_ipv4==1){
								$dhcp_disabled = 1;
							} 
						}
				 } 
				fclose($config_file1);
				} else {
					// return 'Does not exist';
					$first_file_failed = 1;
				}
			  } else {
				  
				  $first_file_failed = 1;
			  }
			 
		  // check second config file
		   if(file_exists('/etc/network/interfaces')){
		   	$config_file2 = fopen("/etc/network/interfaces", "r");
		   		if($first_file_failed==1 && !$config_file2){
					 $second_file_failed = 1;
	  	   		} else if($first_file_failed==1){ 
	  	   			// go through the config file one line at a time
		  			while(!feof($config_file2)) {
						$line_text = fgets($config_file2);
						if(strpos($line_text, 'inet static') !== FALSE){
							$dhcp_disabled = 1;
						} 
					}
				}
				fclose($config_file2);
		   } else {
			   // return 'Does not exist';
			   $second_file_failed = 1;
		   }
		
		// run script to grab server ip addresses
		 $script_path = 'hostname --all-ip-addresses';
		 $run_script = shell_exec($script_path);
		
		$ip_addresses = array();
		if(strlen($run_script)>0){
			$ip_addresses = explode(" ", $run_script );
			
		}
		
		// run script for Team Viewer ID
		$script_path = '/usr/bin/teamviewer -info';
		$teamviewer_info = shell_exec($script_path);
		
		$team_viewer_id = '';
		$target_key = 0;
		$tvArray = explode("[", $teamviewer_info);
		foreach($tvArray as $key => $value){
			if (strpos($value,'TeamViewer ID:') !== false) {
				$target_key = $key+1;
			}
		}
		
		if($target_key>0){
			$team_viewer_id = $tvArray[$target_key];
			$team_viewer_id = str_replace('0m','', $team_viewer_id);
			$team_viewer_id = trim($team_viewer_id);	
		}
		
		if($team_viewer_id>0){
		} else {
			$team_viewer_id = 'Not Available';
		}
		
		$c4000_check = Product_feature::where('label','like', '%C4000%')->count();
		
        return view('system.edit', compact('system','ip_address', 'parts', 'product_feature','tones','system_help','codecs','codec_list','timezones','admins','admin_groups','paging_zones','selected_zones','clear_zones_text','add_zones_text','product_feature_zones','product_feature_admin','add_zones_val_text','nr_admin','nr_admin_group','nr_zones','nr_all_stations','server_ip_address','server_ipaddr_parts','audiodist_ip_address','audiodist_ipaddr_parts','emergency_link_stations','trunk_priority_types','maximum_concurrent_calls_limit','current_call_count','cos_templates','allcall_ip_address','allcall_parts','dhcp_disabled','station_limit','current_station_count','topicurl','ip_addresses','pagezone_limit','current_pagezone_count','maximum_intercom_calls','queue_count','maximum_page_stacking_queues','ans_ip_address','ans_ipaddr_parts','team_viewer_id','c4000_check'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  int  $id
     * @return Response
     */
    public function update($id, Requests\SystemRequest $request)
    {	
		// restricted by permission
		if(Gate::denies('edit_systems') || Gate::denies('view_facilities') || Gate::denies('view_systems')) {
			// send growl notification
			session()->flash('growl_notification.message','You no longer have permissions to edit systems.');
			session()->flash('growl_notification.level','danger');
			return redirect('dashboard');
		} 
		
		$system = System::findOrFail($id);
		$name = $system->name;
		$old_audiodist_long = $system->audiodist_multicast_ip;
		$old_allcall_long = $system->allcall_multicast_ip;
		$old_multicast_long = $system->ip_multicast_rtp;
		$reboot = $request->input('reboot');
		$neighbor_secret = $system->neighbor_secret;
		$new_neighbor_secret = $request->input('neighbor_secret');
		$remote_facility_cos = $system->remote_facility_cos;
		$new_remote_facility_cos = $request->input('remote_facility_cos');
		$old_ans_long = $system->ans_multicast_ip;
		
		$ip_multicast_port = $system->ip_multicast_port;
		$new_ip_multicast_port = $request->input('ip_multicast_port');
		$audiodist_multicast_port = $system->audiodist_multicast_port;
		$new_audiodist_multicast_port = $request->input('audiodist_multicast_port');
		$allcall_multicast_port = $system->allcall_multicast_port;
		$new_allcall_multicast_port = $request->input('allcall_multicast_port');
		$ans_multicast_port = $system->ans_multicast_port;
		$new_ans_multicast_port = $request->input('ans_multicast_port');
		
		$eallcall_volume = $system->eallcall_volume;
		$new_eallcall_volume = $request->input('eallcall_volume');
		$allcall_volume = $system->allcall_volume;
		$new_allcall_volume = $request->input('allcall_volume');
		$audiodist_volume = $system->audiodist_volume;
		$new_audiodist_volume = $request->input('audiodist_volume');
			
		$disa_password = $request->input('disa_password');
		$security_disa_password = $request->input('security_disa_password');
		$auth_code = $request->input('auth_code');
		
		$rtpstart = $system->rtpstart;
		$rtpstart_new = $request->input('rtpstart');
		$rtpend = $system->rtpend;
		$rtpend_new = $request->input('rtpend');
		$rtpchecksums = $system->rtpchecksums;
		$rtpchecksums_new = $request->input('rtpchecksums');
		$icesupport = $system->icesupport;
		$icesupport_new = $request->input('icesupport');
		$stunaddr = $system->stunaddr;
		$stunaddr_new = $request->input('stunaddr');
		$turnaddr = $system->turnaddr;
		$turnaddr_new = $request->input('turnaddr');
		$turnusername = $system->turnusername;
		$turnusername_new = $request->input('turnusername');
		$turnpassword = $system->turnpassword;
		$turnpassword_new = $request->input('turnpassword');
		
		$day_start_hours = $request->input('day_start_hours');
		$day_start_minutes = $request->input('day_start_minutes');
		$night_start_hours = $request->input('night_start_hours');
		$night_start_minutes = $request->input('night_start_minutes');
		
		$pin_multisite_emerg_all_call = $request->input('pin_multisite_emerg_all_call');
		$pin_multisite_all_call = $request->input('pin_multisite_all_call');
		$pin_facility_page = $request->input('pin_facility_page');
		$pin_emerg_all_call = $request->input('pin_emerg_all_call');
		$pin_all_call = $request->input('pin_all_call');
		$pin_emerg_announcement = $request->input('pin_emerg_announcement');
		$pin_announcement = $request->input('pin_announcement');
		$pin_zone_page = $request->input('pin_zone_page');
		$pin_alarm = $request->input('pin_alarm');
		$pin_tone = $request->input('pin_tone');
		$privacy_beep = $request->input('privacy_beep');

		$system_password = $request->input('system_password');
		$allow_local_eallcall_page_interrupt_old = $request->input('allow_local_eallcall_page_interrupt_old');
		$allow_multisite_eallcall_page_interrupt_old = $request->input('allow_multisite_eallcall_page_interrupt_old');
		
		$eallcall_ipaddr = $request->input('multicast_rtp_ip_address_position_1'). '.' . $request->input('multicast_rtp_ip_address_position_2'). '.' . $request->input('multicast_rtp_ip_address_position_3') . '.' . $request->input('multicast_rtp_ip_address_position_4');
		$allcall_ipaddr = $request->input('allcall_ip_address_position_1'). '.' . $request->input('allcall_ip_address_position_2'). '.' . $request->input('allcall_ip_address_position_3') . '.' . $request->input('allcall_ip_address_position_4');
		$audio_distr_ipaddr = $request->input('audiodist_ipaddr_position_1'). '.' . $request->input('audiodist_ipaddr_position_2'). '.' . $request->input('audiodist_ipaddr_position_3') . '.' . $request->input('audiodist_ipaddr_position_4');
		$ans_ipaddr = $request->input('ans_ipaddr_position_1'). '.' . $request->input('ans_ipaddr_position_2'). '.' . $request->input('ans_ipaddr_position_3') . '.' . $request->input('ans_ipaddr_position_4');
		
		$parking_lot_old = $system->parking_lot;
		$parking_lot = $request->input('parking_lot');
		$parkingLotArray = [];
		$parkingLotArray = explode("-", $parking_lot);
		if(strpos($parking_lot, "-")!== FALSE){ // check for hyphen
		} else {
			// send growl notification
			session()->flash('growl_notification.message','The Parking Lot field should be formatted as 2 numbers seperated by a hyphen(-).');
			session()->flash('growl_notification.level','danger');
			return redirect()->back()->withInput();
		}
		
		if(count($parkingLotArray)<2){
			// send growl notification
			session()->flash('growl_notification.message','The Parking Lot field should be formatted as 2 numbers seperated by a hyphen(-).');
			session()->flash('growl_notification.level','danger');
			return redirect()->back()->withInput();
		} else if($parkingLotArray[0]<1 || $parkingLotArray[1]<1){
			// send growl notification
			session()->flash('growl_notification.message','The Parking Lot field should be formatted as 2 numbers seperated by a hyphen(-).');
			session()->flash('growl_notification.level','danger');
			return redirect()->back()->withInput();
		} else if(!ctype_digit($parkingLotArray[0]) || !ctype_digit($parkingLotArray[1])){
			// send growl notification
			session()->flash('growl_notification.message','The Parking Lot field should be formatted as 2 numbers seperated by a hyphen(-).');
			session()->flash('growl_notification.level','danger');
			return redirect()->back()->withInput();
		} else if($parkingLotArray[0]>$parkingLotArray[1]){
			// send growl notification
			session()->flash('growl_notification.message','The Parking Lot field should be formatted as 2 numbers seperated by a hyphen(-) with the first number less than the second.');
			session()->flash('growl_notification.level','danger');
			return redirect()->back()->withInput();
		} else if($parkingLotArray[0]==$parkingLotArray[1]){
			// send growl notification
			session()->flash('growl_notification.message','The Parking Lot start and end numbers may not be equal. The range needs to include at least 2 numbers.');
			session()->flash('growl_notification.level','danger');
			return redirect()->back()->withInput();
		} else if($parkingLotArray[0]<10 || $parkingLotArray[1]>99){
			// send growl notification
			session()->flash('growl_notification.message','The Parking Lot field range may only include 2 digit numbers starting with 10 and ending with 99.');
			session()->flash('growl_notification.level','danger');
			return redirect()->back()->withInput();
		}
		
		// auth_code requirements
		if(strlen($auth_code) < 4 || !ctype_digit($auth_code)){
			// send growl notification
			session()->flash('growl_notification.message','Auth code must be 4 digits.');
			session()->flash('growl_notification.level','danger');
			return redirect()->back()->withInput();
		}
		
		// DISA password and Security DISA password can not be 0000
		if($disa_password=='0000'){
			// send growl notification
			session()->flash('growl_notification.message','DISA Password 0000 is not permitted.');
			session()->flash('growl_notification.level','danger');
			return redirect()->back()->withInput();
		}
		if($security_disa_password=='0000'){	
			// send growl notification
			session()->flash('growl_notification.message','Security DISA password 0000 is not permitted.');
			session()->flash('growl_notification.level','danger');
			return redirect()->back()->withInput();
		}
		
		// make sure the night start time falls after the day start time
		$day_start = $day_start_hours . ':' . $day_start_minutes;
		$night_start = $night_start_hours . ':' . $night_start_minutes;
		
		if(strtotime($day_start) > strtotime($night_start) || strtotime($day_start) == strtotime($night_start)){
			// send growl notification
			session()->flash('growl_notification.message','The Night Start Time must fall after the Day Start Time.');
			session()->flash('growl_notification.level','danger');
			return redirect()->back()->withInput();
		}
		
		// check to make sure that the edited system name does not match any of the current Facilities names
		$facilities = Server::get();
		$system_name_match = str_replace(" ", "-", $request->input('name'));
		$server_ipaddr = $request->input('server_ipaddr_position_1'). '.' . $request->input('server_ipaddr_position_2'). '.' . $request->input('server_ipaddr_position_3') . '.' . $request->input('server_ipaddr_position_4');
		$matches = 0;
		$ip_match = 0;
		foreach($facilities as $facility){
			if($facility->name==$system_name_match){
				$matches++;
			}
			if($facility->host==$server_ipaddr){
				$ip_match++;
			}
		}
		if($matches>0){
			// send growl notification
			session()->flash('growl_notification.message','That name is already being used under Facilities.');
			session()->flash('growl_notification.level','danger');
			return redirect()->back()->withInput();
		}
		if($ip_match>0){
			// send growl notification
			session()->flash('growl_notification.message','That server IP address is already being used under Facilities.');
			session()->flash('growl_notification.level','danger');
			return redirect()->back()->withInput();
		}
		
		// call assurance file upload
		$clean_name = '';
		$call_assurance_audio_old = $request->input('call_assurance_audio_old');
		
		if (Input::hasFile('fileupload')){
		
		  $file = Input::file('fileupload');
		  $path = $file->getRealPath();
		  $size = $file->getSize();		
		  $mime = $file->getMimeType();
		  $name = $file->getClientOriginalName();
		  $extension = $file->getClientOriginalExtension();
		  	  
		  // show error if name is too long
		  if(strlen($name)>251){ // 255 max, 4 characters allowed for extension
			  	// send growl notification
				session()->flash('growl_notification.message','An imported call assurance audio file name must be 251 chracters or less.');
				session()->flash('growl_notification.level','danger');
		  		return redirect()->back()->withInput();  
		  }
		  
			$clean_name = strtolower(str_replace(' ', '', $name));
			$clean_name = strtolower(str_replace('.'. $extension, '', $clean_name)) . '_'.time();
			$name_no_extension = preg_replace('/[^a-z0-9 _]/', '', $clean_name);
			$clean_name = $name_no_extension . '.' . $extension;
			$new_file_path = '/var/lib/asterisk/sounds/'. $clean_name;
			$old_file_path1 = '/var/lib/asterisk/sounds/'. $call_assurance_audio_old .'.wav';
			$old_file_path2 = '/var/lib/asterisk/sounds/'. $call_assurance_audio_old .'.gsm';
				
			// upload the file
			if($file->move('/var/lib/asterisk/sounds/', $clean_name)){
				
				// unlink old file if it exists
				
				if(file_exists($old_file_path1))
				{
				  unlink($old_file_path1);
				}
				if(file_exists($old_file_path2))
				{
				  unlink($old_file_path2);
				}
				
				// run script to grab the song file data
				$script_path = '/usr/local/bin/audio_info /var/lib/asterisk/sounds/' . $clean_name . ' tags';
				$tags = shell_exec($script_path);
				
				$tags = preg_replace('/[^A-Za-z0-9 _\-\+\&\=\{\}\"\:\/\,\(\)\'\.]/','',$tags); // remove problem hidden characters
				
				$tagsArray = json_decode($tags, true);
					
				$format_name = '';
				$duration = '';
				$size  = '';
				$bit_rate = '';
				
				if(isset($tagsArray['format'])){
				  if(isset($tagsArray['format']['format_name'])){ // gsm or wav
					$format_name = $tagsArray['format']['format_name'];
				  }
				  if(isset($tagsArray['format']['duration'])){ // time in seconds
					$duration = $tagsArray['format']['duration'];
				  }
				  if(isset($tagsArray['format']['size'])){ // size in bytes
					$size = $tagsArray['format']['size'];
				  }
				  if(isset($tagsArray['format']['bit_rate'])){ // bit rate
					$bit_rate = $tagsArray['format']['bit_rate'];
				  }
				}
				
				// sample rate (8000) *  bits per sample (16) = 128085 bitrate
				// acceptable Asterisk WAV is 8 kHz, 16 bit, mono
						
				// show error if mime type is not wav or gsm
		  		if($format_name=='wav' || $format_name=='gsm'){ 
				
					if($format_name=='wav' && substr($bit_rate, 0, -3)!='128'){  
					
						// remove new file
						if(file_exists($new_file_path))
						{
							unlink($new_file_path);
						}
						
						// send growl notification
						session()->flash('growl_notification.message','Imported call assurance WAV files must be 8 kHz, 16 bit, mono.');
						session()->flash('growl_notification.level','danger');
						return redirect()->back()->withInput();
					}
	
					$system->update(['call_assurance_audio' => $name_no_extension]);
				
				} else {
					
					// remove new file
					if(file_exists($new_file_path))
					{
				  		unlink($new_file_path);
					}
				
					// send growl notification
					session()->flash('growl_notification.message','Imported call assurance audio files must be wav or gsm.');
					session()->flash('growl_notification.level','danger');
					return redirect()->back()->withInput();  
		  		}
				
			} else {
				// send growl notification
				session()->flash('growl_notification.message','Call assurance audio file upload failed.');
				session()->flash('growl_notification.level','danger');
			  	return redirect()->back()->withInput();  
			}
		}
		
		// get multicast_rtp data
		$multicasts = Multicast_rtp::whereNotIn('multicast_ip_address',[0])->get();
		
		// check to see if any of the multicast ip addresses match
		if($eallcall_ipaddr==$allcall_ipaddr || $eallcall_ipaddr==$audio_distr_ipaddr || $allcall_ipaddr==$audio_distr_ipaddr || $ans_ipaddr==$eallcall_ipaddr || $ans_ipaddr==$allcall_ipaddr  || $ans_ipaddr==$audio_distr_ipaddr ){
			// send growl notification
			session()->flash('growl_notification.message','The Multicast IP Addresses must be unique.');
			session()->flash('growl_notification.level','danger');
			return redirect()->back()->withInput();
		}
		
		// check to see if the multicast ip addresses match any ip address in the multicast_rtp table.
		foreach($multicasts as $multicast){
			$multicast_ip = long2ip($multicast->multicast_ip_address);
			if($multicast_ip==$eallcall_ipaddr){
				// send growl notification
				session()->flash('growl_notification.message','The Emergency-All-Call Multicast IP Address conflicts with a paging zone.');
				session()->flash('growl_notification.level','danger');
				return redirect()->back()->withInput();
			}
			if($multicast_ip==$allcall_ipaddr){
				// send growl notification
				session()->flash('growl_notification.message','The All-Call Multicast IP Address conflicts with a paging zone.');
				session()->flash('growl_notification.level','danger');
				return redirect()->back()->withInput();
			}
			if($multicast_ip==$audio_distr_ipaddr){
				// send growl notification
				session()->flash('growl_notification.message','The Audio Distribution Multicast IP Address conflicts with a paging zone.');
				session()->flash('growl_notification.level','danger');
				return redirect()->back()->withInput();
			}
			if($multicast_ip==$ans_ipaddr){
				// send growl notification
				session()->flash('growl_notification.message','The Ambient Noise Sensor Multicast IP Address conflicts with a paging zone.');
				session()->flash('growl_notification.level','danger');
				return redirect()->back()->withInput();
			}
		}
			
		// check to see if any if any of the multicast ports match
		if($new_ip_multicast_port == $new_allcall_multicast_port || $new_ip_multicast_port == $new_audiodist_multicast_port || $new_allcall_multicast_port == $new_audiodist_multicast_port || $new_ans_multicast_port == $new_ip_multicast_port || $new_ans_multicast_port == $new_allcall_multicast_port || $new_ans_multicast_port == $new_audiodist_multicast_port){
			// send growl notification
			session()->flash('growl_notification.message','Multicast Ports must be unique.');
			session()->flash('growl_notification.level','danger');
			return redirect()->back()->withInput(); 
		}
		
		// check to see if the Emergency-All-Call Multicast RTP Port is in a reserved range already taken
		$eallcall_found_match = 0;
		foreach($multicasts as $multicast){
			for ($x = 0; $x <= 3; $x++) {
				if($multicast->multicast_ip_port+$x==$new_ip_multicast_port){
					$eallcall_found_match++;
				}
			}
		}
		
		// check to see if the All-Call Multicast RTP Port is in a reserved range already taken
		$allcall_found_match = 0;
		foreach($multicasts as $multicast){
			for ($x = 0; $x <= 3; $x++) {
				if($multicast->multicast_ip_port+$x==$new_allcall_multicast_port){
					$allcall_found_match++;
				}
			}
		}
		
		// check to see if the Audio Distribution Multicast Port is in a reserved range already taken
		$audio_distr_found_match = 0;
		foreach($multicasts as $multicast){
			for ($x = 0; $x <= 3; $x++) {
				if($multicast->multicast_ip_port+$x==$new_audiodist_multicast_port){
					$audio_distr_found_match++;
				}
			}
		}
		
		// check to see if the Ambient Noise Sensor Multicast Port is in a reserved range already taken
		$ans_found_match = 0;
		foreach($multicasts as $multicast){
			for ($x = 0; $x <= 3; $x++) {
				if($multicast->multicast_ip_port+$x==$new_ans_multicast_port){
					$ans_found_match++;
				}
			}
		}
		
		if($eallcall_found_match>0){
			// send growl notification
			session()->flash('growl_notification.message','The Emergency-All-Call Multicast RTP Port is in a reserved range.');
			session()->flash('growl_notification.level','danger');
			return redirect()->back()->withInput();
		}
		
		if($allcall_found_match>0){
			// send growl notification
			session()->flash('growl_notification.message','The All-Call Multicast RTP Port is in a reserved range.');
			session()->flash('growl_notification.level','danger');
			return redirect()->back()->withInput();
		}
		
		if($audio_distr_found_match>0){
			// send growl notification
			session()->flash('growl_notification.message','The Audio Distribution Multicast Port is in a reserved range.');
			session()->flash('growl_notification.level','danger');
			return redirect()->back()->withInput();
		}
		
		if($ans_found_match>0){
			// send growl notification
			session()->flash('growl_notification.message','The Ambient Noise Sensor Multicast Port is in a reserved range.');
			session()->flash('growl_notification.level','danger');
			return redirect()->back()->withInput();
		}
		
		// check to see if the Emergency-All-Call, All-Call, or Ambient Noise Sensor Multicast Ports are in the Audio Distribution Multicast Port reserved range
		$range_found_match = 0;
		$multicasts = [$new_ip_multicast_port,$new_allcall_multicast_port,$new_ans_multicast_port];
		foreach($multicasts as $multicast){
			for ($x = 0; $x <= 3; $x++) {
				if($multicast==$new_audiodist_multicast_port+$x){
					$range_found_match++;
				}
			}
		}
		
		if($range_found_match>0){
			// send growl notification
			session()->flash('growl_notification.message','Multicast Ports can not be within a reserved range after the Audio Distribution Multicast Port.');
			session()->flash('growl_notification.level','danger');
			return redirect()->back()->withInput();
		}
		
		if(strlen($pin_multisite_emerg_all_call)<4 && ctype_digit($pin_multisite_emerg_all_call)){
			// send growl notification
			session()->flash('growl_notification.message','Multi-Site-Emergency-All-Call Password must be 4 numbers.');
			session()->flash('growl_notification.level','danger');
			return redirect()->back()->withInput();
		}
		if(strlen($pin_multisite_all_call)<4 && ctype_digit($pin_multisite_all_call)){
			// send growl notification
			session()->flash('growl_notification.message','Multi-Site-All-Call Password must be 4 numbers.');
			session()->flash('growl_notification.level','danger');
			return redirect()->back()->withInput();
		}
		if(strlen($pin_facility_page)<4 && ctype_digit($pin_facility_page)){
			// send growl notification
			session()->flash('growl_notification.message','Facility-Page Password must be 4 numbers.');
			session()->flash('growl_notification.level','danger');
			return redirect()->back()->withInput();
		}
		if(strlen($pin_emerg_all_call)<4 && ctype_digit($pin_emerg_all_call)){
			// send growl notification
			session()->flash('growl_notification.message','Emergency-All-Call Password must be 4 numbers.');
			session()->flash('growl_notification.level','danger');
			return redirect()->back()->withInput();
		}
		if(strlen($pin_all_call)<4 && ctype_digit($pin_all_call)){
			// send growl notification
			session()->flash('growl_notification.message','All-Call Password must be 4 numbers.');
			session()->flash('growl_notification.level','danger');
			return redirect()->back()->withInput();
		}
		if(strlen($pin_emerg_announcement)<4 && ctype_digit($pin_emerg_announcement)){
			// send growl notification
			session()->flash('growl_notification.message','Emergency-Announcement Password must be 4 numbers.');
			session()->flash('growl_notification.level','danger');
			return redirect()->back()->withInput();
		}
		if(strlen($pin_announcement)<4 && ctype_digit($pin_announcement)){
			// send growl notification
			session()->flash('growl_notification.message','Announcement Password must be 4 numbers.');
			session()->flash('growl_notification.level','danger');
			return redirect()->back()->withInput();
		}
		if(strlen($pin_zone_page)<4 && ctype_digit($pin_zone_page)){
			// send growl notification
			session()->flash('growl_notification.message','Zone Page Password must be 4 numbers.');
			session()->flash('growl_notification.level','danger');
			return redirect()->back()->withInput();
		}
		if(strlen($pin_alarm)<4 && ctype_digit($pin_alarm)){
			// send growl notification
			session()->flash('growl_notification.message','Alarm Password must be 4 numbers.');
			session()->flash('growl_notification.level','danger');
			return redirect()->back()->withInput();
		}
		if(strlen($pin_tone)<4 && ctype_digit($pin_tone)){
			// send growl notification
			session()->flash('growl_notification.message','Tone Password must be 4 numbers.');
			session()->flash('growl_notification.level','danger');
			return redirect()->back()->withInput();
		}

		if($allow_local_eallcall_page_interrupt_old=='1' && $system_password==''){
			// send growl notification
			session()->flash('growl_notification.message','System Password is required if Allow Local Emergency-All-Call Page Interrupt is set to Yes.');
			session()->flash('growl_notification.level','danger');
			return redirect()->back()->withInput();
		}

		if($allow_multisite_eallcall_page_interrupt_old=='1' && $system_password==''){
			// send growl notification
			session()->flash('growl_notification.message','System Password is required if Allow Multi-Site-Emergency-All-Call Page Interrupt is set to Yes.');
			session()->flash('growl_notification.level','danger');
			return redirect()->back()->withInput();
		}
			
		// update all system fields
		$system->update($request->all());
		
		// check for reset call assurance audio
		
		if($request->input('call_assurance_audio_name')=='call-placed' && $request->input('call_assurance_audio_old')!='call-placed'){
			$system->update(['call_assurance_audio' => 'call-placed']);
			
			// remove old audio files
			$old_file_path1 = '/var/lib/asterisk/sounds/'. $call_assurance_audio_old .'.wav';
			$old_file_path2 = '/var/lib/asterisk/sounds/'. $call_assurance_audio_old .'.gsm';
			
			if(file_exists($old_file_path1))
			{
				 unlink($old_file_path1);
			}
			if(file_exists($old_file_path2))
			{
				 unlink($old_file_path2);
			}
		}
		
		$new_name = $system->name;
		$emergency_link = $system->emergency_link;	
		
		// save selected codecs to default_codecs_allowed
		$codecs = $request->input('codecs');
		
		$audiodist_ip_address = $request->input('audiodist_ipaddr_position_1'). '.' . $request->input('audiodist_ipaddr_position_2'). '.' . $request->input('audiodist_ipaddr_position_3') . '.' . $request->input('audiodist_ipaddr_position_4');
		$audiodist_long = ip2long($audiodist_ip_address);
		
		$multicast_rtp_address = $request->input('multicast_rtp_ip_address_position_1'). '.' . $request->input('multicast_rtp_ip_address_position_2'). '.' . $request->input('multicast_rtp_ip_address_position_3') . '.' . $request->input('multicast_rtp_ip_address_position_4');
		$multicast_long = ip2long($multicast_rtp_address);
		
		$allcall_rtp_address = $request->input('allcall_ip_address_position_1'). '.' . $request->input('allcall_ip_address_position_2'). '.' . $request->input('allcall_ip_address_position_3') . '.' . $request->input('allcall_ip_address_position_4');
		$allcall_long = ip2long($allcall_rtp_address);
		
		$ans_ip_address = $request->input('ans_ipaddr_position_1'). '.' . $request->input('ans_ipaddr_position_2'). '.' . $request->input('ans_ipaddr_position_3') . '.' . $request->input('ans_ipaddr_position_4');
		$ans_long = ip2long($ans_ip_address);
			 
		$default_codecs_allowed = '';
		$i = 0;
		if(count($codecs)>0) {
		  foreach($codecs as $codec) {
			  if($i==0) {
				  $default_codecs_allowed = $codec;
			  } else {
				  $default_codecs_allowed = $default_codecs_allowed .';'. $codec;
			  }
			  $i++;
		  }
		} 
			
		$zones = $request->input('zones');
		$nightring_zonelist = '';
		$i = 0;
		if(count($zones)>0) {
		  foreach($zones as $zone) {
			  if($i==0) {
				  $nightring_zonelist = $zone;
			  } else {
				  $nightring_zonelist = $nightring_zonelist .';'. $zone;
			  }
			  $i++;
		  }
		} 
		
		$disabled_privacy_beep = 0;
		if($privacy_beep==0){
			$disabled_privacy_beep = 1;
		}
			
		// update system fields
		$system->update(['day_start' => $day_start, 'night_start' => $night_start, 'default_codecs_allowed' => $default_codecs_allowed , 'nightring_zonelist' => $nightring_zonelist , 'privacy_beep' => $disabled_privacy_beep]);
		
		$dialing_length_start = $request->input('dialing_length_start');
		$dialing_length = $request->input('dialing_length');
		$dialing_length_change = $request->input('dialing_length_change');
		$x_format = "";
		
		// copy admin_queue_timeout to all the matching queues records
		// Queues::where('queues.timeoutpriority', 'LIKE', 'app')->update(['timeout' => $system->admin_queue_timeout]);
		
		// if system name changed run linux script
		if($name!=$new_name){
			// run php script
		  	$script_path = '/usr/local/bin/create-syscontacts > /var/lib/asterisk/digium_phones/syscontacts.xml';
		  	$run_script = shell_exec($script_path);
		}
		
		// if reboot set yes
		$reboot_text = '';
		if($reboot==1){
		  $reboot_text = 'reboot';
		}
			
		// if audiodist ip, multicast ip, ip_multicast_port, audiodist_multicast_port, allcall_multicast_port, callcall_multicast_port, eallcall_volume, allcall_volume, or audiodist_volume change - run scripts with reboot option
		if($old_audiodist_long != $audiodist_long || $old_multicast_long != $multicast_long || $ip_multicast_port != $new_ip_multicast_port || $audiodist_multicast_port != $new_audiodist_multicast_port || $old_allcall_long !=  $allcall_long || $allcall_multicast_port != $new_allcall_multicast_port || $eallcall_volume != $new_eallcall_volume || $allcall_volume != $new_allcall_volume || $audiodist_volume != $new_audiodist_volume || $old_ans_long != $ans_long || $ans_multicast_port != $new_ans_multicast_port){
				
		  // reboot snom phones
		  $script_path1 = '/usr/local/bin/update-all-snom-phones ' . $reboot_text;
		  $run_script1 = shell_exec($script_path1);
		  
		  // reboot yealink phones
		  $script_path2 = '/usr/local/bin/update-all-yealink-phones '. $reboot_text;
		  $run_script2 = shell_exec($script_path2);
		  
		  // nyquist devices update
		  $script_path3 = '/usr/local/bin/update-all-nyquist-devices '. $reboot_text;
		  $run_script3 = shell_exec($script_path3);
		  
		}
		
		// if parking_lot changes - run script
		if($parking_lot_old != $parking_lot){
		  $script_path = '/usr/local/bin/update-parking-lot reboot';
		  $run_script = shell_exec($script_path);
		}
		
		// if remote_facility_cos changes 
		if($remote_facility_cos != $new_remote_facility_cos){
			
			Station::where('extension', '=', '1')->update(['day_cos' => $new_remote_facility_cos, 'night_cos' => $new_remote_facility_cos]);
		}
		
		// if name or neighbor_secret changes - run script
		if($name != $new_name || $neighbor_secret != $new_neighbor_secret){
		  $script_path = '/usr/local/bin/update-iax';
		  $run_script = shell_exec($script_path);
		}
		
		// run script if any of the ICE or TURN fields change
		if(($rtpstart!=$rtpstart_new) || ($rtpend!=$rtpend_new) || ($rtpchecksums!=$rtpchecksums_new) || ($icesupport!=$icesupport_new) || ($stunaddr!=$stunaddr_new) || ($turnaddr!=$turnaddr_new) || ($turnusername!=$turnusername_new) || ($turnpassword!=$turnpassword_new)){
			$script_path = '/usr/local/bin/update-rtp-conf';
		  	$run_script = shell_exec($script_path);
		}
		
		$old_server_ipaddr = $system->server_ipaddr;
		$new_server_ipaddr = ip2long($server_ipaddr);
			
		// get gateway data
		$gateways = Gateway::get();
		
		// run script on all gateways if any ip addresses, ports, or volumes change
		if($old_audiodist_long != $audiodist_long || $old_multicast_long != $multicast_long || $ip_multicast_port != $new_ip_multicast_port || $audiodist_multicast_port != $new_audiodist_multicast_port || $old_allcall_long !=  $allcall_long || $allcall_multicast_port != $new_allcall_multicast_port || $eallcall_volume != $new_eallcall_volume || $allcall_volume != $new_allcall_volume || $audiodist_volume != $new_audiodist_volume || $old_server_ipaddr != $new_server_ipaddr || $eallcall_volume != $new_eallcall_volume || $allcall_volume != $new_allcall_volume || $audiodist_volume != $new_audiodist_volume || $old_ans_long != $ans_long || $ans_multicast_port != $new_ans_multicast_port){
			foreach($gateways as $gateway){
				$script_path = '/usr/local/bin/create-gateway-cfg add '. $gateway->id;
		  		$run_script = shell_exec($script_path);
			}
		}
		
		// send growl notification
		session()->flash('growl_notification.message',$new_name. ' Updated.');
		session()->flash('growl_notification.level','success');
		return redirect('system');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return Response
     */
    public function destroy($id)
    {
		// restricted by permission
		if(Gate::denies('delete_systems') || Gate::denies('view_facilities') || Gate::denies('view_systems')) {
			// send growl notification
			session()->flash('growl_notification.message','You no longer have permissions to delete systems.');
			session()->flash('growl_notification.level','danger');
			return redirect('dashboard');
		} 
		
        $system = System::findOrFail($id);
		$name = $system->name;
		$system->delete();
		
		// run linux script
			$script_path = '/usr/local/bin/create-syscontacts';
			$run_script = shell_exec($script_path);
		
		// send growl notification
		session()->flash('growl_notification.message',$name.' Deleted.');
		session()->flash('growl_notification.level','success');
		return redirect('system');
    }
	
	public function ntp($data)
	{	
		// restricted by permission
		if(Gate::denies('edit_systems') || Gate::denies('view_facilities') || Gate::denies('view_systems')) {
			return redirect('dashboard');
		} 
		
		$dataArray = explode('&', $data);
		
		$server_address = $dataArray[0];
		$system_id = $dataArray[1];
		
		// clock_set(ntp man)
		// For NTP:
		//  ntp 24.56.178.140	
			
		$arg1 = 'ntp'; // flag
		$arg2 = $server_address; // server address
		
		$script_path = '/usr/local/bin/clock_set';
		$timeserver = shell_exec( $script_path . ' ' . escapeshellarg($arg1). ' ' . escapeshellarg($arg2));
		$response = '';
		$level = 'danger';
		
		if(strpos($timeserver, 'Time set correctly from NTP server') !== FALSE){
			
			$response = 'Server changed and time updated';
			$level = 'success';
			
			// update server address in system table
			
			System::where('id', '=', $system_id)->update(['ip_ntp_server' => $server_address]);
			
		} else if(strpos($timeserver, 'SNTP Error -- Operation Failed') !== FALSE){
			
			$response = 'Operation Failed';
			$level = 'danger';
			
		} else if(strpos($timeserver, 'SNTP Parameter Error') !== FALSE){
			
			$response = 'Parameter Error';
			$level = 'danger';
			
		} else if(strpos($timeserver, 'SNTP Unknown Error') !== FALSE){
		
			$response = 'Unknown Error';	
			$level = 'danger';
		}
		
		// send growl notification
		session()->flash('growl_notification.message',$response.'. NTP Server: ' . $arg2);
		session()->flash('growl_notification.level', $level);
			
		return redirect()->action('SystemController@edit', [1]);
	}
	public function ntp_appliance($data){
		
		// restricted by permission
		if(Gate::denies('edit_systems') || Gate::denies('view_facilities') || Gate::denies('view_systems')) {
			return redirect('dashboard');
		} 
		
		// update appliance_ntp_source 
		System::where('system.id', '=', '1')->update([ 'appliance_ntp_source' => $data]);
		
		// run script
		$script_path = '/usr/local/bin/update-all-nyquist-devices';
		$run_script = shell_exec($script_path);
		
		return $data;
	}
	
	 public function serverdate($datetime)
    {
		// restricted by permission
		if(Gate::denies('edit_systems') || Gate::denies('view_facilities') || Gate::denies('view_systems')) {
			return redirect('dashboard');
		} 
		
		// clock_set(ntp man)
	
		// For MAN
		// man <dd> <month> <yyyy> <hh> <mm> <ss>

		// The month parameter must be:
		//  JAN, FEB, MAR, APR, MAY, JUN, JUL, AUG, SEP, OCT, NOV, DEC
		// sudo date --set="19 AUG 2015 13:33:00"
		
		if($datetime==0){
		  	// send growl notification
			session()->flash('growl_notification.message','Choose a date and time before changing.');
			session()->flash('growl_notification.level','danger');
		  	return redirect()->action('SystemController@edit', [1]);
		  
		} else {
			
			// remove underscore
		  $new_date_string =  str_replace("_"," ", $datetime);
		  $new_date = strtotime($new_date_string);
		  $arg1 = 'man';  // flag
		  $arg2 = date('d', $new_date);   // day
		  $arg3 = strtoupper(date('M', $new_date)); // month
		  $arg4 = date('Y', $new_date); // year
		  $arg5 = date('H', $new_date); // hour
		  $arg6 = date('i', $new_date); // min
		  $arg7 = '00'; // sec
  
		  $script_path = '/usr/local/bin/clock_set';
		  
		  $timeserver = shell_exec( $script_path . ' ' . escapeshellarg($arg1). ' ' . escapeshellarg($arg2) . ' ' . escapeshellarg($arg3) . ' ' . escapeshellarg($arg4) . ' ' . escapeshellarg($arg5) . ' ' . escapeshellarg($arg6) . ' ' . escapeshellarg($arg7));
		  
		  	// send growl notification
			session()->flash('growl_notification.message','Server Date updated.&nbsp;&nbsp;&nbsp;Response:&nbsp;' . $timeserver);
			session()->flash('growl_notification.level','success');
			return redirect()->action('SystemController@edit', [1]);
		}
		
	}
	public function timezone($data)
    {
		// restricted by permission
		if(Gate::denies('edit_systems') || Gate::denies('view_facilities') || Gate::denies('view_systems')) {
			return redirect('dashboard');
		} 
		
		$dataArray = explode('&', $data);
		
		$timezone = $dataArray[0];
		$system_id = $dataArray[1];
		
		if($timezone ==='0'){
			
			return '0';
		  
		} else {
			
			$arg1 = 'timezone';  // flag
			$arg2 = str_replace("|","/", $timezone);
			$arg3 = str_replace("_"," ", $arg2);
			
			$script_path = '/usr/local/bin/clock_set';
			$timeserver = shell_exec( $script_path . ' ' . escapeshellarg($arg1). ' ' . escapeshellarg($arg2));
			
			// update time_zone in system table
			System::where('id', '=', $system_id)->update(['time_zone' => $arg2]);
			
			// time zone changed - run script
		  	$script_path = '/usr/local/bin/update-phones --tz system';
		  	$run_script = shell_exec($script_path);
			
			// run script
		  	$script_path2 = '/usr/local/bin/update-all-nyquist-devices reboot';
		  	$run_script2 = shell_exec($script_path2);
			
			return $arg3;
		}
		
	}
	public function dhcp_override($data)
    {
		// restricted by permission
		if(Gate::denies('edit_systems') || Gate::denies('view_facilities') || Gate::denies('view_systems')) {
			return redirect('dashboard');
		} 
		
		$dataArray = explode('&', $data);
		
		$enable_disable = $dataArray[0];
		$system_id = $dataArray[1];
		
		
		$arg1 = 'dhcp_override';
		$arg2 = $enable_disable; // enable or disable
		$response = '';
		$level = 'danger';
		
		$script_path = '/usr/local/bin/clock_set';
		$run_script = shell_exec( $script_path . ' ' . escapeshellarg($arg1). ' ' . escapeshellarg($arg2));
		
		if(strpos($run_script, 'NTP servers are already being configured via DHCP') !== FALSE){
			
			$response = 'NTP servers are configured via DHCP.';
			$level = 'success';
			
			// set dhcp_override to yes
			System::where('id', '=', $system_id)->update(['dhcp_override' => '1']);
			
		} else if(strpos($run_script, 'Adding ntp-servers to') !== FALSE){
			
			$response = 'NTP servers are configured via DHCP.';
			$level = 'success';
			
			// set dhcp_override to yes
			System::where('id', '=', $system_id)->update(['dhcp_override' => '1']);
			
		} else if(strpos($run_script, 'Removing ntp-servers from') !== FALSE){
			
			$response = 'NTP servers are no longer configured via DHCP.';
			$level = 'success';
			
			// set dhcp_override to no
			System::where('id', '=', $system_id)->update(['dhcp_override' => '0']);
			
		} else if(strpos($run_script, 'First argument must be ntp, man, timezone, or dhcp_override') !== FALSE){
			
			$response = 'There was a problem with the DHCP Server change.';
			$level = 'danger';
			
			// don't change the dhcp_override status
		} else {
			
			$response = 'There was a problem with the DHCP Server change.';
			$level = 'danger';
		}
		
		// send growl notification
		session()->flash('growl_notification.message',$response);
		session()->flash('growl_notification.level',$level);
		return redirect()->action('SystemController@edit', [1]);
		
	}
	
	public function ntp_ip_address()
    {	
		// restricted by permission
		if(Gate::denies('edit_systems') || Gate::denies('view_facilities') || Gate::denies('view_systems')) {
			return redirect('dashboard');
		} 
		
		$arg1 = 'current';
		$response = '';
		
		$script_path = '/usr/local/bin/clock_set';
		$run_script = shell_exec( $script_path . ' ' . escapeshellarg($arg1));
		
		if(strpos($run_script, 'Current NTP Server:') !== FALSE){
			
			$response = $run_script;
			
		} else {
			
			$response = 'Retrieving NTP Server ...';
			
		}
		
		return $response;
		
	}
	
	public function process_extension($extension, $change){
		
		  if($change==1) {
			  $extension = '0'.$extension;
		  }
		  if($change==2) {
			  $extension = '00'.$extension;
		  }
		  if($change==3) {
			  $extension = '000'.$extension;
		  }
		  // removing 
		  if($change==-1) {
			  $extension = substr($extension, 1);
		  }
		  if($change==-2) {
			  $extension = substr($extension, 2);
		  }
		  if($change==-3) {
			  $extension = substr($extension, 3);
		  }
		
		return $extension;
	}
	
	public function checkForDuplicateExtensions($data){
		
		// restricted by permission
		if(Gate::denies('edit_systems') || Gate::denies('view_facilities') || Gate::denies('view_systems')) {
			return redirect('dashboard');
		} 
		
		$dataArray = explode('&', $data);
		
		$dialing_length_start = $dataArray[0];
		$dialing_length = $dataArray[1];
		$trim_error = 0;
		
		$change = $dialing_length - $dialing_length_start;
		
		if($dialing_length < $dialing_length_start ){
			
			$extensionsArray = array();
				
			$station_check = Station::where('extension', '!=', '1')->get();
			foreach($station_check as $record) {
				$extension = $record->extension;
			  	 // removing 
				if($change==-1) {
					$extension = substr($extension, 1);
				}
				if($change==-2) {
					$extension = substr($extension, 2);
				}
				if($change==-3) {
					$extension = substr($extension, 3);
				}
			  $extensionsArray[] = $extension;
				
				if(in_array($extension,[000,0000,00000,001,0001,00001])){
					$trim_error = 1;
				}
			 }
			
			if(count($extensionsArray) !== count(array_unique($extensionsArray))){
				return '1';
			} else if($trim_error==1){
				return '2';
			} else {
				return '0';
			}
		} else {
			return '0';	
		}
	}
	
	public function process_dialing_length($data){
		
		// restricted by permission
		if(Gate::denies('edit_systems') || Gate::denies('view_facilities') || Gate::denies('view_systems')) {
			return redirect('dashboard');
		} 
		
		// first create a system backup
		$script_path = '/usr/local/bin/create-backup System';
		$run_script = shell_exec($script_path);

		$script_path = '/usr/local/bin/reboot-all-devices';
		$run_script = shell_exec($script_path);

		sleep(10);

		$script_path = '/usr/local/bin/run_server_cmd stop';
		$run_script = shell_exec($script_path);
		
		$dataArray = explode('&', $data);
		
		$dialing_length_start = $dataArray[0];
		$dialing_length = $dataArray[1];
		$dialing_length_change = $dataArray[2];
		$emergency_link = $dataArray[3];
		$nightring_admin_extension = $dataArray[4];
		
		$change_array = array('front','rear');
		$change = $dialing_length - $dialing_length_start;
		$x_format = "";
		
		// start dialing length
		if($change != 0 && in_array($dialing_length_change, $change_array )) { 
		
		//return $dialing_length . ' ' . $dialing_length_start . ' ' . $dialing_length_change . ' '. $emergency_link;
		
		 // update emergency_link
		  // adding zeros
		  if($emergency_link!='999'){ // do not change if emergency_link is 999
			$emergency_link = $this->process_extension($emergency_link, $change);
			System::where('id', '=', '1')->update(['emergency_link' => $emergency_link]);
		  }
		  
		   // update nightring_admin_extension
		  // adding zeros
		  if(strlen($nightring_admin_extension)>0){ // see if nightring_admin_extension exists
			$nightring_admin_extension = $this->process_extension($nightring_admin_extension, $change);
			  
			System::where('id', '=', '1')->update(['nightring_admin_extension' => $nightring_admin_extension]);
		  }
		 
		  // update station table
		  $nyquistDevicesArray = array();
		  $station = Station::where('extension', '!=', '1')->get();
		  foreach($station as $record) {
			  $extension = $record->extension;
			  $day_admin = $record->day_admin;
			  $night_admin = $record->night_admin;
			  $spkr_ext = $record->spkr_ext;
			  $type = $record->type;
			  $gateway_id = $record->gateway_id;
			  
			  $extension = $this->process_extension($extension, $change);
			  $day_admin = $this->process_extension($day_admin, $change);
			  $night_admin = $this->process_extension($night_admin, $change);
			  if($spkr_ext!=''){ 
				  $spkr_ext = $this->process_extension($spkr_ext, $change);
			  }
			  
			  Station::where('extension', '=', $record->extension)->update(['extension' => $extension, 'day_admin' => $day_admin, 'night_admin' => $night_admin, 'spkr_ext' => $spkr_ext]);
			  
			  if(in_array($type,[7,10,11,21,22,23,24,25,26,27,28]) && $gateway_id==0){
				  array_push($nyquistDevicesArray, $extension);
			  }
		  }
			
		   // update outside_line table
	
		  $outside_line = Outside_line::get();
		  foreach($outside_line as $record) {
			  $extension = $record->extension;
			  $day_admin = $record->day_admin;
			  $night_admin = $record->night_admin;
			  
			  $extension = $this->process_extension($extension, $change);
			  $day_admin = $this->process_extension($day_admin, $change);
			  $night_admin = $this->process_extension($night_admin, $change);
			  
			  Outside_line::where('extension', '=', $record->extension)->update(['extension' => $extension, 'day_admin' => $day_admin, 'night_admin' => $night_admin]);
		  }
		  
		  // update sip_trunk table
	
		  $sip_trunk = Sip_trunk::get();
		  foreach($sip_trunk as $record) {
			  $extension = $record->extension;
			  $day_admin = $record->day_admin;
			  $night_admin = $record->night_admin;
			  
			  $extension = $this->process_extension($extension, $change);
			  $day_admin = $this->process_extension($day_admin, $change);
			  $night_admin = $this->process_extension($night_admin, $change);
			  
			  Sip_trunk::where('extension', '=', $record->extension)->update(['extension' => $extension, 'day_admin' => $day_admin, 'night_admin' => $night_admin]);
		  }
		  
		  // update the ps_aors table
		  $ps_aors = Ps_aors::get();
		  foreach($ps_aors as $record) {
			  $extension = $record->id;
			  if(ctype_digit($extension)){ // don't update SIP Trunk IDs that contain letters
				  
				  $extension = $this->process_extension($extension, $change);
				  
				  Ps_aors::where('id', '=', $record->id)->update(['id' => $extension, 'mailboxes' => $extension.'@default']);  
			  }
		  }
		  
		  // update the ps_auths table
		  $ps_auths = Ps_auths::get();
		  foreach($ps_auths as $record) {
			  $extension = $record->id;
			  if(ctype_digit($extension)){ // don't update SIP Trunk IDs that contain letters
				  
				  $extension = $this->process_extension($extension, $change);
				  
				  Ps_auths::where('id', '=', $record->id)->update(['id' => $extension, 'username' => $extension]);
			  }
		  }
		  
		  // update the ps_endpoint table 
		  $ps_endpoint = Ps_endpoint::get();
		  foreach($ps_endpoint as $record) {
			  $extension = $record->id;
			  if(ctype_digit($extension)){ // don't update SIP Trunk IDs that contain letters
				  
				  $extension = $this->process_extension($extension, $change);
				  
				  Ps_endpoint::whereNotIn('id', ['dpma_endpoint'])->where('id', '=', $record->id)->update(['id' => $extension, 'aors' => $extension, 'auth' => $extension]);
			  }
		  }
		  
		  // update the zone_sublist table
		  
		  $zone_sublist = Zone_sublist::get();
		  foreach($zone_sublist as $record) {
			  $extension = $record->station;
			  
			  $extension = $this->process_extension($extension, $change);
			  
			  Zone_sublist::where('station', '=', $record->station)->update(['station' => $extension]);
		  }
		  
		   // update the announcements table
		  
		  $announcements = Announcement::get();
		  foreach($announcements as $record) {
			  $extension = $record->creator_ext;
			  
			  $extension = $this->process_extension($extension, $change);
			  
			  if(intval($record->creator_ext)!=0){
				  Announcement::where('creator_ext', '=', $record->creator_ext)->update(['creator_ext' => $extension]);
			  }
		  }
		  
		    // update the call_state table
		  
		  $call_state = Call_state::get();
		  foreach($call_state as $record) {
			  $extension = $record->extension;
			  
			  $extension = $this->process_extension($extension, $change);
			  
			  Call_state::where('extension', '=', $record->extension)->update(['extension' => $extension]);
		  }
		  
		   // update the dashboard_msg table for Admin scope
		  
		  $dashboard_msg = Dashboard_msg::get();
		  foreach($dashboard_msg as $record) {
			  $extension = $record->extension;
			  $actionDataArray = array();
			  $extension2 = '0';
			  if($record->action=='Activate'){
				  $actionDataArray = explode(" ", $record->action_data);
				  $extension2 = $actionDataArray[0];
			  }
			  
			  $extension = $this->process_extension($extension, $change);
			  $extension2 = $this->process_extension($extension2, $change);
			  
			  $extension_old = $record->extension;
			  $text = $record->text;
			  $text_new = '';
			  $action_data = $record->action_data;
			  $action_data_new = '';
			  
			  if($record->action=='Activate'){
				  $action_data_new = $extension2 . ' ' . $actionDataArray[1] . ' ' . $actionDataArray[2] . ' ' . $actionDataArray[3];
				  $text_new = $record->text;
			  } else {
				  $action_data_new = str_replace($extension_old, $extension, $action_data);
				  $text_new = str_replace($extension_old, $extension, $text);
			  }
			  
			  Dashboard_msg::where('extension', '=', $record->extension)->update(['text' => $text_new, 'action_data' => $action_data_new, 'extension' => $extension]);
		  }
		  
		  // update the Queues table
		  
		  $queues = Queues::where('timeoutpriority', 'like', 'app')->whereNotIn('name', ['admin'])->get();
		  foreach($queues as $record) {
			  $extension = $record->name;
			  
			  $extension = $this->process_extension($extension, $change);
			  
			  Queues::where('name', 'LIKE', $record->name)->update(['name' => $extension]);
		  }
		  
		   // update the Queue_members table
		   
		  $queue_members = Queue_members::get();
		  foreach($queue_members as $record) {
			  $extension = $record->membername;
			  
			  $extension = $this->process_extension($extension, $change);
			  
			  Queue_members::where('membername', 'LIKE', $record->membername)->where('queue_name', 'LIKE', $record->membername)->whereNotIn('queue_name', ['admin'])->update(['queue_name' => $extension, 'interface' => 'PJSIP/'. $extension,  'membername' => $extension]);
			  
			  Queue_members::where('membername', 'LIKE', $record->membername)->whereIn('queue_name', ['admin'])->update([ 'interface' => 'PJSIP/'. $extension,  'membername' => $extension]);
			  
			  Queue_members::where('membername', 'LIKE', $record->membername)->where('queue_name', 'LIKE', $record->queue_name)->update([ 'interface' => 'PJSIP/'. $extension,  'membername' => $extension]);
		  }
		  
		  // update the User table
		  
		  $users = User::get();
		  foreach($users as $record) {
			  $extension = $record->extension;
			  $valid_extensions = $record->valid_extensions;
			  $extensionsArray = explode(";", $valid_extensions);
			  $new_valid_extensions = '';
			  if(count($extensionsArray)>0 && strlen($valid_extensions)>2){
				  $i = 1;
				  foreach($extensionsArray as $extension_number){
					 if($i<count($extensionsArray) ){
					  	$semi = ';';
				 	 } else {
					  	$semi = '';
				  	 }
					  $new_extension = $this->process_extension($extension_number, $change);
					  $new_valid_extensions = $new_valid_extensions.''.$new_extension.''.$semi;
					  $i++;
				  }
				  User::where('id', '=', $record->id)->update(['valid_extensions' => $new_valid_extensions]);
			  }
			  
			  $extension = $this->process_extension($extension, $change);
			  
			  if($record->extension>0){
			  	User::where('id', '=', $record->id)->update(['extension' => $extension]);
			  }
		  }
		  
		  // update the Voicemail table
		  
		  $voicemails = Voicemail::get()->all();
		  foreach($voicemails as $voicemail) {
			  $mailbox = $voicemail->mailbox;
			  $password = $voicemail->password;
			  
			   $mailbox = $this->process_extension($mailbox, $change);
			   $password = $this->process_extension($password, $change);
			   
			  // update the password if the original mailbox and password are equal 
			  if($voicemail->mailbox == $voicemail->password){
			  } else {
				  $password = $voicemail->password;
			  }
			  
			  Voicemail::where('mailbox', 'LIKE', $voicemail->mailbox)->update(['mailbox' => $mailbox, 'password' => $password]);
		  }
		  
		  // update the Station_template table
		  
		  $station_template = Station_template::get()->first();
		  
		  $st_day_admin = $station_template->day_admin;
		  if($st_day_admin>0){
			  $st_day_admin = $this->process_extension($st_day_admin, $change);
		  }
		  $st_night_admin = $station_template->night_admin;
		  if($st_night_admin>0){
			  $st_night_admin = $this->process_extension($st_night_admin, $change);
		  }
		  Station_template::where('id', '=', $station_template->id)->update(['day_admin' => $st_day_admin, 'night_admin' => $st_night_admin]);
		  
		   // update the paging_exclusions table
		  
		  $paging_exclusion = Paging_exclusion::get();
		  foreach($paging_exclusion as $record) {
			  $extension = $record->extension;
			  
			  $extension = $this->process_extension($extension, $change);
			  		  
			  $extension_old = $record->extension;
			  
			  Paging_exclusion::where('extension', '=', $extension_old)->update(['extension' => $extension]);
		  }
				
		 // update the gateway table
		  
		  $gateway = Gateway::get();
		  foreach($gateway as $record) {
			  $day_admin = $record->day_admin;
			  $night_admin = $record->night_admin;
			  $gateway_id = $record->id;
			  
			  $day_admin = $this->process_extension($day_admin, $change);
			  $night_admin = $this->process_extension($night_admin, $change);
			  
			  $day_admin_old = $record->day_admin;
			  $night_admin_old = $record->night_admin;
			  
			  Gateway::where('day_admin', '=', $day_admin_old)->update(['day_admin' => $day_admin]);
			  Gateway::where('night_admin', '=', $night_admin_old)->update(['night_admin' => $night_admin]);
			  
			  // run script to create a new config file for each bridge device
			  $script_path = '/usr/local/bin/create-gateway-cfg add ' . $gateway_id;
			  $run_script = shell_exec($script_path);
		  }
			
			// update the redording table
		  
		  $recording = Recording::get();
		  foreach($recording as $record) {
			  $caller_ext = $record->caller_ext;
			  $called_ext = $record->called_ext;
			  
			  $caller_ext = $this->process_extension($caller_ext, $change);
			  $called_ext = $this->process_extension($called_ext, $change);
			  
			  $caller_ext_old = $record->caller_ext;
			  $called_ext_old = $record->called_ext;
			  
			  Recording::where('caller_ext', '=', $caller_ext_old)->update(['caller_ext' => $caller_ext]);
			  Recording::where('called_ext', '=', $called_ext_old)->update(['called_ext' => $called_ext]);
		  }
			
		 // update the ctrl_rule table
		  
		  $ctrl_rule = Ctrl_rule::get();
		  foreach($ctrl_rule as $record) {
			  $extension = $record->extension;
			  $close_ext = $record->close_ext;
			  
			  $extension = $this->process_extension($extension, $change);
			  $close_ext = $this->process_extension($close_ext, $change);
			   
			  $extension_old = $record->extension;
			  $close_ext_old = $record->close_ext;
			  
			  Ctrl_rule::where('extension', '=', $extension_old)->update(['extension' => $extension]);
			  Ctrl_rule::where('close_ext', '=', $close_ext_old)->update(['close_ext' => $close_ext]);
		  }
			
			// ctrl_rule.control_stations
			foreach($ctrl_rule as $record) {
			  $control_stations = $record->control_stations;
			  $controlStationsArray = explode(",",  $control_stations);
			  $control_stations_new = '';
			  if(count($controlStationsArray)>0){
				  $i=1;
				  foreach($controlStationsArray as $extension){
					  
					  $extension = $this->process_extension($extension, $change);
					  
					  $comma = '';
					  if(count($controlStationsArray)>0 && $i<count($controlStationsArray)){
						  $comma = ','; 
					  } 

					 $control_stations_new = $control_stations_new . '' . $extension . $comma;
					  
					  $i++;
				  }
			  }
			  Ctrl_rule::where('control_stations', '=', $control_stations)->update(['control_stations' => $control_stations_new ]);
		  }
			
			// update the io_contact_sched table
		  
		  $io_contact_sched = Io_contact_sched::get();
		  foreach($io_contact_sched as $record) {
			  $extension = $record->extension;
			  
			  $extension = $this->process_extension($extension, $change);
			   
			  $extension_old = $record->extension;
			  
			  Io_contact_sched::where('extension', '=', $extension_old)->update(['extension' => $extension]);
		  }
				
			// update the mixer_channel table
		  
		  $mixer_channel = Mixer_channel::get();
		  foreach($mixer_channel as $record) {
			  $extension = $record->extension;
			  
			  $extension = $this->process_extension($extension, $change);
			  
			  $extension_old = $record->extension;
			  
			  Mixer_channel::where('extension', '=', $extension_old)->update(['extension' => $extension]);
		  }
			
			// update the mixer_config table
		  
		  $mixer_config = Mixer_config::get();
		  foreach($mixer_config as $record) {
			  $extension = $record->extension;
			  
			  $extension = $this->process_extension($extension, $change);
			   
			  $extension_old = $record->extension;
			  
			  Mixer_config::where('extension', '=', $extension_old)->update(['extension' => $extension]);
		  }
			
			// update the schedule_events table
		  
		  $schedule_events = Schedule_events::get();
		  foreach($schedule_events as $record) {
			  $extension = $record->input_extension;
			  
			  $extension = $this->process_extension($extension, $change);
			  
			  $extension_old = $record->input_extension;
			  
			  Schedule_events::where('input_extension', '=', $extension_old)->update(['input_extension' => $extension]);
		  }
			
		  // update the tone table
		  
		  $tones = Tone::get();
		  foreach($tones as $record) {
			  $file_name = $record->file_name;
			  $old_file_name = $record->file_name;
			  $extension = '';
			  $old_extension = '';
			  if(substr($file_name, 0, 10)=='Line-Input'){
				  $file_name_parts = explode(":", $file_name);
				  if(count($file_name_parts)==3){
					 $old_extension =  $file_name_parts[1]; 
					 $extension = $file_name_parts[1];
					  $channel = $file_name_parts[2];
					  
					  $extension = $this->process_extension($extension, $change);
					  
					  $file_name = 'Line-Input:'.$extension.':'.$channel;
					  
					  Tone::where('file_name', '=', $old_file_name)->update(['file_name' => $file_name]);
				  }
			  }
		  }
			
		// update the analog_line table
		$analog_lines = Analog_line::get();
		  foreach($analog_lines as $record) {
			  $extension = $record->extension;
			  
			  $extension = $this->process_extension($extension, $change);
			    
			  $extension_old = $record->extension;
			  
			  Analog_line::where('extension', 'like', $extension_old)->where('extension','!=','')->update(['extension' => $extension]);
		  }
			
		// update the map_button table
		  
		  $map_button = Map_button::where('action','LIKE','call')->get();
		  foreach($map_button as $record) {
			  $extension = $record->data;
			  
			  $extension = $this->process_extension($extension, $change);
			  			  
			  $extension_old = $record->data;
			  
			  Map_button::where('data', 'LIKE', $extension_old)->update(['data' => $extension]);
		  }
			
		// update the intercom_config table
		$intercom_config = Intercom_config::get();
		  foreach($intercom_config as $record) {
			  $extension = $record->extension;
			  
			  $extension = $this->process_extension($extension, $change);
			  
			  $extension_old = $record->extension;
			  
			  Intercom_config::where('extension', 'like', $extension_old)->where('extension','!=','')->update(['extension' => $extension]);
		  }
			
			// update the ans_listeners table
			$ans_listeners = Ans_listeners::get();
			  foreach($ans_listeners as $record) {
				  $extension = $record->ans_ext;
				  
				  $extension = $this->process_extension($extension, $change);
				  
				  $extension_old = $record->ans_ext;

				  Ans_listeners::where('ans_ext', 'like', $extension_old)->where('ans_ext','!=','')->update(['ans_ext' => $extension]);
			  }
			
			// update the ans_listeners table
			$ans_listeners = Ans_listeners::get();
			  foreach($ans_listeners as $record) {
				  $extension = $record->listener_ext;
				  
				  $extension = $this->process_extension($extension, $change);
				  
				  $extension_old = $record->listener_ext;

				  Ans_listeners::where('listener_ext', 'like', $extension_old)->where('listener_ext','!=','')->update(['listener_ext' => $extension]);
			  }
			
			// update the display table
			$displays = Display::get();
			  foreach($displays as $record) {
				  $extension = $record->extension;
				  
				  $extension = $this->process_extension($extension, $change);
				  
				  $extension_old = $record->extension;

				  Display::where('extension', 'like', $extension_old)->where('extension','!=','')->update(['extension' => $extension]);
			  }
			
			// update the message table
			$messages = Message::get();
			  foreach($messages as $record) {
				  $extension = $record->creator;
				  
				  $extension = $this->process_extension($extension, $change);
				  
				  $extension_old = $record->creator;

				  Message::where('creator', 'like', $extension_old)->where('creator','!=','')->update(['creator' => $extension]);
			  }
			
			// update routine trigger extensions
			$routine_trigger = Routine_trigger::get();
			foreach($routine_trigger as $trigger){
				if($trigger->type=='check-in' && $trigger->param2!=''){
					$new_extension = $this->process_extension($trigger->param2, $change);
					Routine_trigger::where('id', '=', $trigger->id)->update(['param2' => $new_extension]);
				}
				if($trigger->type=='emergency-call' && $trigger->param1!=''){
					$param_array = explode(",",$trigger->param1);
					$new_param_array= array();
					foreach($param_array as $param_item){
						$new_extension = $this->process_extension($param_item, $change);
						array_push($new_param_array, $new_extension);
					}
					$new_param_text = implode(",",$new_param_array);
					Routine_trigger::where('id', '=', $trigger->id)->update(['param1' => $new_param_text]);
				}
				if($trigger->type=='emergency-call' && $trigger->param2!=''){
					$param_array = explode(",",$trigger->param2);
					$new_param_array= array();
					foreach($param_array as $param_item){
						$new_extension = $this->process_extension($param_item, $change);
						array_push($new_param_array, $new_extension);
					}
					$new_param_text = implode(",",$new_param_array);
					Routine_trigger::where('id', '=', $trigger->id)->update(['param2' => $new_param_text]);
				}
				if($trigger->type=='intercom-call' && $trigger->param1!=''){
					$param_array = explode(",",$trigger->param1);
					$new_param_array= array();
					foreach($param_array as $param_item){
						$new_extension = $this->process_extension($param_item, $change);
						array_push($new_param_array, $new_extension);
					}
					$new_param_text = implode(",",$new_param_array);
					Routine_trigger::where('id', '=', $trigger->id)->update(['param1' => $new_param_text]);
				}
				if($trigger->type=='intercom-call' && $trigger->param2!=''){
					$param_array = explode(",",$trigger->param2);
					$new_param_array= array();
					foreach($param_array as $param_item){
						$new_extension = $this->process_extension($param_item, $change);
						array_push($new_param_array, $new_extension);
					}
					$new_param_text = implode(",",$new_param_array);
					Routine_trigger::where('id', '=', $trigger->id)->update(['param2' => $new_param_text]);
				}
				if($trigger->type=='station-status-up' && $trigger->param1!=''){
					$param_array = explode(",",$trigger->param1);
					$new_param_array= array();
					foreach($param_array as $param_item){
						$new_extension = $this->process_extension($param_item, $change);
						array_push($new_param_array, $new_extension);
					}
					$new_param_text = implode(",",$new_param_array);
					Routine_trigger::where('id', '=', $trigger->id)->update(['param1' => $new_param_text]);
				}
				if($trigger->type=='station-status-down' && $trigger->param1!=''){
					$param_array = explode(",",$trigger->param1);
					$new_param_array= array();
					foreach($param_array as $param_item){
						$new_extension = $this->process_extension($param_item, $change);
						array_push($new_param_array, $new_extension);
					}
					$new_param_text = implode(",",$new_param_array);
					Routine_trigger::where('id', '=', $trigger->id)->update(['param1' => $new_param_text]);
				}
				if($trigger->type=='urgent-call' && $trigger->param1!=''){
					$param_array = explode(",",$trigger->param1);
					$new_param_array= array();
					foreach($param_array as $param_item){
						$new_extension = $this->process_extension($param_item, $change);
						array_push($new_param_array, $new_extension);
					}
					$new_param_text = implode(",",$new_param_array);
					Routine_trigger::where('id', '=', $trigger->id)->update(['param1' => $new_param_text]);
				}
				if($trigger->type=='urgent-call' && $trigger->param2!=''){
					$param_array = explode(",",$trigger->param2);
					$new_param_array= array();
					foreach($param_array as $param_item){
						$new_extension = $this->process_extension($param_item, $change);
						array_push($new_param_array, $new_extension);
					}
					$new_param_text = implode(",",$new_param_array);
					Routine_trigger::where('id', '=', $trigger->id)->update(['param2' => $new_param_text]);
				}
			}
			
			// update routine action extensions
			$routine_action = Routine_action::get();
			foreach($routine_action as $action){
				if($action->type=='check-in' && $action->param2!=''){
					$param_array = explode(",",$action->param2);
					$new_param_array= array();
					foreach($param_array as $param_item){
						$new_extension = $this->process_extension($param_item, $change);
						array_push($new_param_array, $new_extension);
					}
					$new_param_text = implode(",",$new_param_array);
					Routine_action::where('id', '=', $action->id)->update(['param2' => $new_param_text]);
				}
				if($action->type=='display-msg' && $action->param3!=''){
					$param_array = explode(",",$action->param3);
					$new_param_array= array();
					foreach($param_array as $param_item){
						$new_extension = $this->process_extension($param_item, $change);
						array_push($new_param_array, $new_extension);
					}
					$new_param_text = implode(",",$new_param_array);
					Routine_action::where('id', '=', $action->id)->update(['param3' => $new_param_text]);
				}
				if($action->type=='display-msg-delete' && $action->param4!=''){
					$param_array = explode(",",$action->param4);
					$new_param_array= array();
					foreach($param_array as $param_item){
						$new_extension = $this->process_extension($param_item, $change);
						array_push($new_param_array, $new_extension);
					}
					$new_param_text = implode(",",$new_param_array);
					Routine_action::where('id', '=', $action->id)->update(['param4' => $new_param_text]);
				}
				if($action->type=='emergency-call' && $action->param1!=''){
					$new_extension = $this->process_extension($action->param1, $change);
					Routine_action::where('id', '=', $action->id)->update(['param1' => $new_extension]);
				}
				if($action->type=='intercom-call' && $action->param1!=''){
					$new_extension = $this->process_extension($action->param1, $change);
					Routine_action::where('id', '=', $action->id)->update(['param1' => $new_extension]);
				}
				if($action->type=='intercom-call' && $action->param2!=''){
					$new_extension = $this->process_extension($action->param2, $change);
					Routine_action::where('id', '=', $action->id)->update(['param2' => $new_extension]);
				}
				if(($action->type=='output-contact-close' || $action->type=='output-contact-open') && $action->param1!=''){
					$new_extension = $this->process_extension($action->param1, $change);
					Routine_action::where('id', '=', $action->id)->update(['param1' => $new_extension]);
				}
				if($action->type=='page-exclusion' && $action->param2!=''){
					$param_array = explode(",",$action->param2);
					$new_param_array= array();
					foreach($param_array as $param_item){
						$new_extension = $this->process_extension($param_item, $change);
						array_push($new_param_array, $new_extension);
					}
					$new_param_text = implode(",",$new_param_array);
					Routine_action::where('id', '=', $action->id)->update(['param2' => $new_param_text]);
				}
				if($action->type=='urgent-call' && $action->param1!=''){
					$new_extension = $this->process_extension($action->param1, $change);
					Routine_action::where('id', '=', $action->id)->update(['param1' => $new_extension]);
				}
			}
			
		  // run script to update the config file for each Nyquist devices
			if(count($nyquistDevicesArray)>0){
				foreach($nyquistDevicesArray as $nyquist_extension){
					$script_path = '/usr/local/bin/create-nyquist-cfg add '. $nyquist_extension;
					$run_script = shell_exec($script_path);
				}
			}
		  
		  // update the dialing length 
		  System::where('id', '=', '1')->update(['dialing_length' => $dialing_length]);
		  

		  // run digit maps script
		  $script_path = '/usr/local/bin/update-phones --digitlength '. $dialing_length;
		  $run_script = shell_exec($script_path);
		  
		  return '1';
		
		} // end dialing length
		
		else {
			
			return '0';
			
		}
	}
		
	public function system_report(){
		
		// restricted by permission
		if(Gate::denies('view_facilities') || Gate::denies('view_systems') || Gate::denies('edit_systems')) {
			return 0;
		} 
		
		$system = System::first();
		
		// set time zone
        $tz = $system->time_zone;
        if($tz){
            date_default_timezone_set($tz);
        }
		
		$created = date('Y-m-d').'T'.date('H:i:s').'Z';
		
		$product_feature_settings = Product_feature::where('product_feature.name', 'like', 'settings')->get()->first();
		
		$spreadsheet_data = '<?xml version="1.0"?>'. '' . PHP_EOL;
        $spreadsheet_data .= '<?mso-application progid="Excel.Sheet"?>'. '' . PHP_EOL;
        $spreadsheet_data .= '<Workbook xmlns="urn:schemas-microsoft-com:office:spreadsheet"'. '' . PHP_EOL;
        $spreadsheet_data .= 'xmlns:o="urn:schemas-microsoft-com:office:office"'. '' . PHP_EOL;
        $spreadsheet_data .= 'xmlns:x="urn:schemas-microsoft-com:office:excel"'. '' . PHP_EOL;
        $spreadsheet_data .= 'xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet"'. '' . PHP_EOL;
        $spreadsheet_data .= 'xmlns:html="http://www.w3.org/TR/REC-html40">'. '' . PHP_EOL;
        $spreadsheet_data .= '<DocumentProperties xmlns="urn:schemas-microsoft-com:office:office">'. '' . PHP_EOL;
        $spreadsheet_data .= '<LastAuthor>Microsoft Office User</LastAuthor>'. '' . PHP_EOL;
        $spreadsheet_data .= '<Created>'.$created .'</Created>'. '' . PHP_EOL;
        $spreadsheet_data .= '<Version>16.00</Version>'. '' . PHP_EOL;
        $spreadsheet_data .= '</DocumentProperties>'. '' . PHP_EOL;
        $spreadsheet_data .= '<OfficeDocumentSettings xmlns="urn:schemas-microsoft-com:office:office">'. '' . PHP_EOL;
        $spreadsheet_data .= '<AllowPNG/>'. '' . PHP_EOL;
        $spreadsheet_data .= '</OfficeDocumentSettings>'. '' . PHP_EOL;
        $spreadsheet_data .= '<ExcelWorkbook xmlns="urn:schemas-microsoft-com:office:excel">'. '' . PHP_EOL;
        $spreadsheet_data .= '<WindowHeight>16700</WindowHeight>'. '' . PHP_EOL;
        $spreadsheet_data .= '<WindowWidth>28040</WindowWidth>'. '' . PHP_EOL;
        $spreadsheet_data .= '<WindowTopX>120</WindowTopX>'. '' . PHP_EOL;
        $spreadsheet_data .= '<WindowTopY>460</WindowTopY>'. '' . PHP_EOL;
        $spreadsheet_data .= '<ProtectStructure>False</ProtectStructure>'. '' . PHP_EOL;
        $spreadsheet_data .= '<ProtectWindows>False</ProtectWindows>'. '' . PHP_EOL;
        $spreadsheet_data .= '</ExcelWorkbook>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Styles><ss:Style ss:ID="1"><ss:Font ss:Bold="1"/></ss:Style></ss:Styles>'. '' . PHP_EOL;
		
		// Start System Parameters Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="System Parameters">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$systemHeaderArray = ['System Name', 'Day Start','Night Start','Emergency-All-Call Multicast RTP IP Address','Emergency-All-Call Multicast RTP Port','Emergency-All-Call Volume','All-Call Multicast RTP IP Address','All-Call Multicast RTP Port','All-Call Volume','Audio Distribution Multicast IP Address','Audio Distribution Multicast Port','Audio Distribution Volume','Default Volume','Network Time Server','Appliances Network Time Server Source','Time Zone','Disable Preannounce Tone','Disable Privacy Beep','DHCP Server Override','Emergency Tone','All Call Tone','Intercom Tone','Default Registration Password','Default Codecs Allowed','Valid Codec List','Admin Queue Timeout','Night Ring Enabled','Night Ring Admin','Night Ring All Stations','Night Ring Admin Group','Night Ring Zones','Server IP Address','Parking Lot','Record Monitoring','Emergency Link','Max Restricted Digits','DISA Password','Security DISA Password','CDR Storage Duration','Trunk Priority','Bump on Emergency','Bump on 911','Auth Code','Dialing Length','Call Assurance Audio','Remote Facility CoS','Facility Password','RTP Start Port','RTP End Port','Enable RTP Checksums','Enable ICE Support','STUN Server','TURN Server','TURN Username','TURN Password','Retention Recordings','Backup Retention System','Backup Retention Recordings','Backup Retention Voicemail','Ambient Noise Sensor Multicast IP Address','Ambient Noise Sensor Multicast Port','Allow Local Emergency-All-Call Page Interrupt','Allow Multi-Site-Emergency-All-Call Page Interrupt','System Password','Multi-Site-Emergency-All-Call Password','Multi-Site-All-Call Password','Facility-Page Password','Emergency-All-Call Password','All-Call Password','Emergency-Announcement Password','Announcement Password','Zone-Page Password','Alarm Password','Tone Password'];
	
		foreach($systemHeaderArray as $system_header_name){
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// system parameters data
		$systems = System::	
			leftJoin('tone', 'system.emergency_tone', '=', DB::raw('CONCAT(tone.file_location, "/pre/",  tone.file_name)'))
			->leftJoin('tone as tone2', 'system.all_call_tone', '=', DB::raw('CONCAT(tone2.file_location, "/pre/", tone2.file_name)'))
			->leftJoin('tone as tone3', 'system.intercom_tone', '=', DB::raw('CONCAT(tone3.file_location, "/pre/", tone3.file_name)'))
			->leftJoin('trunk_priority_enum', 'system.trunk_priority', '=', 'trunk_priority_enum.id')
			->leftJoin('cos', 'system.remote_facility_cos', '=', 'cos.id')
			->select('system.id as id', 'system.name as name', 'day_start', 'night_start', 'ip_multicast_rtp',  'ip_ntp_server','default_station_password', 'disable_preannounce_tone', 'dialing_length', 'emergency_tone', 'all_call_tone', 'privacy_beep',  'default_codecs_allowed', 'valid_codec_list', 'default_volume', 'intercom_tone', 'parking_lot', 'tone.file_name as emergency_tone_file_name', 'tone.name as emergency_tone_name','tone2.name as all_call_tone_name','tone2.file_name as all_call_tone_file_name', 'tone3.name as intercom_tone_name','tone3.file_name as intercom_tone_file_name','system.time_zone as time_zone', 'system.admin_queue_timeout as admin_queue_timeout','system.dhcp_override as dhcp_override', 'system.nightring_enabled as nightring_enabled', 'system.nightring_admin_extension as nightring_admin_extension', 'system.nightring_admin_group as nightring_admin_group','system.nightring_zonelist as nightring_zonelist','system.nightring_allstations as nightring_allstations','system.server_ipaddr as server_ipaddr','system.audiodist_multicast_ip as audiodist_multicast_ip','system.record_monitoring as record_monitoring','system.emergency_link as emergency_link','max_restricted_digits','call_log_length','trunk_priority','trunk_priority_enum.name as trunk_priority_name','bump_on_emergency','bump_on_911', 'auth_code','disa_password','security_disa_password','max_restricted_digits','call_assurance_audio','ip_multicast_port','audiodist_multicast_port','cos.name as remote_facility_cos_name','system.neighbor_secret as facility_secret','system.rtpstart as rtpstart', 'system.rtpend as rtpend','system.rtpchecksums as rtpchecksums','system.icesupport as icesupport','system.stunaddr as stunaddr','system.turnaddr as turnaddr', 'system.turnusername as turnusername','system.turnpassword as turnpassword','system.vlan_enabled as vlan_enabled','system.vlan_id as vlan_id','system.priority_802_1p as priority_802_1p','system.eallcall_volume as eallcall_volume','system.allcall_multicast_ip as allcall_multicast_ip','system.allcall_multicast_port as allcall_multicast_port','system.allcall_volume as allcall_volume','system.audiodist_volume as audiodist_volume','system.retention_recordings as retention_recordings','system.backup_retention_system as backup_retention_system','system.backup_retention_recordings as backup_retention_recordings','system.backup_retention_voicemail as backup_retention_voicemail','system.appliance_ntp_source as appliance_ntp_source','ans_multicast_ip','ans_multicast_port','allow_local_eallcall_page_interrupt','allow_multisite_eallcall_page_interrupt','system_password','pin_multisite_emerg_all_call','pin_multisite_all_call','pin_facility_page','pin_emerg_all_call','pin_all_call','pin_emerg_announcement','pin_announcement','pin_zone_page','pin_alarm','pin_tone')
            ->get();
			
			foreach($systems as $system){
				$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->day_start.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->night_start.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.long2ip($system->ip_multicast_rtp).'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->ip_multicast_port.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->eallcall_volume.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.long2ip($system->allcall_multicast_ip).'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->allcall_multicast_port.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->allcall_volume.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.long2ip($system->audiodist_multicast_ip).'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->audiodist_multicast_port.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->audiodist_volume.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->default_volume.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->ip_ntp_server.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->appliance_ntp_source.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->time_zone.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$disable_preannounce_tone = '';
				if($system->disable_preannounce_tone==1){ $disable_preannounce_tone = 'Yes'; } else { $disable_preannounce_tone = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$disable_preannounce_tone.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$privacy_beep = '';
				if($system->privacy_beep==1){ $privacy_beep = 'Yes'; } else { $privacy_beep = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$privacy_beep.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$dhcp_override = '';
				if($system->dhcp_override==1){ $dhcp_override = 'Yes'; } else { $dhcp_override = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$dhcp_override.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->emergency_tone_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->all_call_tone_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->intercom_tone_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->default_station_password.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->default_codecs_allowed.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->valid_codec_list.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->admin_queue_timeout.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$nightring_enabled = '';
				if($system->nightring_enabled==1){ $nightring_enabled = 'Yes'; } else { $nightring_enabled = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$nightring_enabled.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->nightring_admin_extension.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$nightring_allstations = '';
				if($system->nightring_allstations==1){ $nightring_allstations = 'Yes'; } else { $nightring_allstations = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$nightring_allstations.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->nightring_admin_group.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->nightring_zonelist.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.long2ip($system->server_ipaddr).'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->parking_lot.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$record_monitoring = '';
				if($system->record_monitoring==1){ $record_monitoring = 'Yes'; } else { $record_monitoring = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$record_monitoring.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->emergency_link.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->max_restricted_digits.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->disa_password.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->security_disa_password.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->call_log_length.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->trunk_priority_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$bump_on_emergency = '';
				if($system->bump_on_emergency==1){ $bump_on_emergency = 'Yes'; } else { $bump_on_emergency = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$bump_on_emergency.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$bump_on_911 = '';
				if($system->bump_on_911==1){ $bump_on_911 = 'Yes'; } else { $bump_on_911 = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$bump_on_911.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->auth_code.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->dialing_length.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->call_assurance_audio.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->remote_facility_cos_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->facility_secret.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->rtpstart.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->rtpend.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$rtpchecksums = '';
				if($system->rtpchecksums==1){ $rtpchecksums = 'Yes'; } else { $rtpchecksums = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$rtpchecksums.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$icesupport = '';
				if($system->icesupport==1){ $icesupport = 'Yes'; } else { $icesupport = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$icesupport.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->stunaddr.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->turnaddr.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->turnusername.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->turnpassword.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->retention_recordings.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->backup_retention_system.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->backup_retention_recordings.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->backup_retention_voicemail.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.long2ip($system->ans_multicast_ip).'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->ans_multicast_port.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$allow_local_eallcall_page_interrupt = '';
				if($system->allow_local_eallcall_page_interrupt==1){ $allow_local_eallcall_page_interrupt = 'Yes'; } else { $allow_local_eallcall_page_interrupt = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$allow_local_eallcall_page_interrupt.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$allow_multisite_eallcall_page_interrupt = '';
				if($system->allow_multisite_eallcall_page_interrupt==1){ $allow_multisite_eallcall_page_interrupt = 'Yes'; } else { $allow_multisite_eallcall_page_interrupt = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$allow_multisite_eallcall_page_interrupt.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->system_password.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->pin_multisite_emerg_all_call.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->pin_multisite_all_call.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->pin_facility_page.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->pin_emerg_all_call.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->pin_all_call.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->pin_emerg_announcement.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->pin_announcement.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->pin_zone_page.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->pin_alarm.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$system->pin_tone.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
					
				$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
			}
			
			$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
			$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
		// End System Parameters Worksheet	
			
		// Start Zones Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="Zones">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$zonesHeaderArray = ['Number','Name','Description','Icon','Preannounce Tone','Type','Type Description','Volume','Multicast IP Address','Multicast IP Port','Stations','Audio Distribution Volume'];
	
		foreach($zonesHeaderArray as $zone_header_name){
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$zone_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// zones data
		$pagingzones = Pagingzone::
		leftJoin('tone', 'pagingzones.preannounce_tone', '=',DB::raw('CONCAT(tone.file_location, "/pre/",  tone.file_name)'))
		->leftJoin('zone_types_enum', 'pagingzones.type', '=', 'zone_types_enum.id')
		->leftJoin('multicast_rtp', 'multicast_rtp.zone_id', '=', 'pagingzones.id')
		->select('pagingzones.id as pagingzone_id','zone_number','zone_extension','pagingzones.name as pagingzone_name','description','glyph_name','preannounce_tone','tone.name as preannounce_tone_name','volume', 'zone_types_enum.name as zone_type_name', 'pagingzones.type as type','zone_types_enum.help as zone_type_help','multicast_rtp.id as priority','multicast_rtp.multicast_ip_address as multicast_ip_address','multicast_rtp.multicast_ip_port as multicast_ip_port','audiodist_volume')
		->get();
			
			foreach($pagingzones as $zone){
				$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$zone->zone_number.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$zone->pagingzone_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$zone->description.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$zone->glyph_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$zone->preannounce_tone_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$zone->zone_type_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$zone->zone_type_help.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$volume = 0; 
                  if($zone->volume=='-50'){
                      $volume = 0;
                  } else if($zone->volume=='-30'){
                      $volume = 1;
                  } else if($zone->volume=='-10'){
                      $volume = 2;
                  } else if($zone->volume=='-3'){
                      $volume = 3;
                  } else if($zone->volume=='-1'){
                      $volume = 4;
                  } else if($zone->volume=='0'){
                      $volume = 5;
                  } else if($zone->volume=='1'){
                      $volume = 6;
                  } else if($zone->volume=='3'){
                      $volume = 7;
                  } else if($zone->volume=='5'){
                      $volume = 8;
                  } else if($zone->volume=='7'){
                      $volume = 9;
                  } else if($zone->volume=='10'){
                      $volume = 10;
                  }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$volume.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.long2ip($zone->multicast_ip_address).'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$zone->multicast_ip_port.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				
				$selected_stations = Zone_sublist::where('zone_number', '=', $zone->zone_number)->whereNotIn('station', ['dpma_endpoint'])->get();
				$stations = '';
				if(count($selected_stations)>0){
					foreach($selected_stations as $station){
					
						$stations = $stations . '' . $station->station . ', ';
					}
				$stations = substr($stations , 0, -2);
                  
				} else {
                    $stations = 'None';
                }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$stations.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$zone->audiodist_volume.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				
				$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
			}
			
			$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
			$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
		// End Zones Worksheet	
			
		// Start Stations Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="Stations">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$stationsHeaderArray = ['Extension','Name','Description','Type','Type Description','Device Type','MAC Address','Facility','Day CoS','Night CoS','Day Admin','Night Admin','Admin Group','Codecs Allowed','Force Name','Force Greeting','Call Recording','Outside Access','911 Route','Auth Code','Status','IP Address','Speaker Extension','Has Paging','Has Multicast Audio','Master Volume', 'VLAN Config','VLAN Id','VLAN Priority','Gateway','Gateway Port','Web Username','Web Password','Serial Number','Firmware','Talkback Gain','Sites','Maps','Queue Zone','Announcement Zone','Announcement Zone Configuration Type','External Relay Trigger'];
	
		foreach($stationsHeaderArray as $station_header_name){
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// stations data
		$stations = Station::
			leftJoin('system', 'station.facility', '=', 'system.id')
			->leftJoin('station_types_enum', 'station.type', '=', 'station_types_enum.id')
			->leftJoin('cos as cos1', 'station.day_cos', '=', 'cos1.id')
			->leftJoin('cos as cos2', 'station.night_cos', '=', 'cos2.id')
			->leftJoin('ps_endpoints', 'station.extension', '=', 'ps_endpoints.id')
			->leftJoin('admin_group', 'admin_group.id', '=', 'station.admin_group')
			->leftJoin('device_types_enum', 'station.device_type', '=', 'device_types_enum.id')
			->leftJoin('voicemail', 'station.extension', '=', 'voicemail.mailbox')
			->leftJoin('outside_access_types', 'station.outside_access', '=', 'outside_access_types.id')
			->leftJoin('gateway', 'gateway.id', '=', 'station.gateway_id')
			->select('station.id as id', 'station.type as type', 'station.type as type_id', 'station.extension as extension','station.day_cos as day_cos','station.night_cos as night_cos','station.day_admin as day_admin','station.night_admin as night_admin', 'system.id as facility_id', 'system.name as facility_name', 'station_types_enum.id as type_id','station_types_enum.name as type_name','station_types_enum.help as type_help', 'cos1.name as day_cos_name','cos2.name as night_cos_name', 'ps_endpoints.allow as codec_list','station.name as station_name', 'station.admin_group as admin_group', 'admin_group.name as admin_group_name', 'station.description as station_description', 'station.device_type as device_type', 'station.mac_address as mac_address','device_types_enum.name as device_type_name','voicemail.forcename as forcename','voicemail.forcegreetings as forcegreetings', 'station.has_call_recording as has_call_recording','outside_access_types.id as outside_access_type_id','outside_access_types.name as outside_access_type_name', 'station.911_route as col911_route','station.auth_code as auth_code','station.status as status','station.ip_address as ip_address','spkr_ext','has_paging','has_multicast_audio','station.mac_address as mac_address','station.master_volume as master_volume','station.vlan_config as vlan_config','station.vlan_id as vlan_id', 'station.priority_802_1p as priority_802_1p', 'gateway.name as gateway_name','station.gateway_port as gateway_port','station.web_username as web_username','station.web_password as web_password','station.serial_number as serial_number','station.fw_filename as fw_filename','station.talkback_gain as talkback_gain','station.schools_sites as schools_sites','station.maps as maps','station.queue_zone as queue_zone','announcements_zone','external_relay_trigger','announcements_zone_config_type')
            ->get();
			
			foreach($stations as $station){
				$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->extension.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->station_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->station_description.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->type_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->type_help.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->device_type_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->mac_address.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->facility_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->day_cos_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->night_cos_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->day_admin.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->night_admin.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->admin_group_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->codec_list.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$forcename = '';
				if($system->forcename==1){ $forcename = 'Yes'; } else { $forcename = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$forcename.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$forcegreetings = '';
				if($system->forcegreetings==1){ $forcegreetings = 'Yes'; } else { $forcegreetings = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$forcegreetings.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$has_call_recording = '';
				if($system->has_call_recording==1){ $has_call_recording = 'Yes'; } else { $has_call_recording = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$has_call_recording.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->outside_access_type_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->col911_route.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->auth_code.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->status.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->ip_address.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->spkr_ext.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$has_paging = '';
				if($station->has_paging==1){ $has_paging = 'Yes'; } else { $has_paging = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$has_paging.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$has_multicast_audio = '';
				if($station->has_multicast_audio==1){ $has_multicast_audio = 'Yes'; } else { $has_multicast_audio = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$has_multicast_audio.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->master_volume.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->vlan_config.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->vlan_id.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->priority_802_1p.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->gateway_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->gateway_port.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->web_username.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->web_password.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->serial_number.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->fw_filename.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->talkback_gain.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->schools_sites.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->maps.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->queue_zone.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->announcements_zone.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->external_relay_trigger.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station->announcements_zone_config_type.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				
				$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
			}
			
			$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
			$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
		// End Stations Worksheet
			
		// Start Admin Groups Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="Admin Groups">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$adminGroupsHeaderArray = ['Name','Description','Icon','Admin Stations'];
	
		foreach($adminGroupsHeaderArray as $admin_group_header_name){
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$admin_group_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// admin groups data
		$admin_groups = Admin_group::get();
			
			foreach($admin_groups as $admin_group){
				$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$admin_group->name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$admin_group->description.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$admin_group->glyph_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$queue_members = Queue_members::where('queue_name', '=', $admin_group->name)->get();
				$stations = '';
                    if(count($queue_members)>0){
                        	foreach($queue_members as $member){
                        		$stations = $stations . '' . $member->membername . ', ';
							}
                        	$stations = substr($stations , 0, -2);
                      } else {
                        	$stations = 'None';
                      }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$stations.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				
				$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
			}
			
			$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
			$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
			// End Admin Groups Worksheet
			
			
		// Start CoS Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="CoS Configuration">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$cosGroupsHeaderArray = ['Name','Enabled','Callin Level Name','Callin Level Help','Has Zone Paging','Has All Call Page','Has Emergency All Call','Has Interfacility Callpage','Has Program Distribution','Has Remote Pickup','Has Call Forwarding','Has Walking CoS','Has External Call Routing','Has Call Transfer','Has Manual Activate Tone','Has Call Anystation','Has Manage Recordings','Has Call Monitoring','Has Loc Monitoring','Has Conf Admin','Has Conf User','Has Voicemail','Has Call Recording','Has Activate Alarms','Has Disable Audio','Has Enable Audio','Has Callee Autoanswer','Has Multiserver Paging','Has Interfacility Features','Has Manage Output Contacts','Has Execute Routines'];
	
		foreach($cosGroupsHeaderArray as $cos_header_name){
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$cos_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// CoS data
		$cos_data = Cos::
			leftJoin('callin_level_enum', 'cos.callin_level', '=', 'callin_level_enum.id')
			->select('cos.id as id','cos.enabled as enabled','cos.name as name','cos.callin_level as callin_level','cos.has_zone_paging as has_zone_paging','cos.has_all_call_page as has_all_call_page','cos.has_emergency_all_call as has_emergency_all_call','cos.has_interfacility_callpage as has_interfacility_callpage','cos.has_program_distribution as has_program_distribution','cos.has_remote_pickup as has_remote_pickup','cos.has_bump_call as has_bump_call','cos.has_call_forwarding as has_call_forwarding','cos.has_walking_cos as has_walking_cos','cos.has_external_call_routing as has_external_call_routing','cos.has_call_transfer as has_call_transfer','cos.has_manual_activate_tone as has_manual_activate_tone', 'callin_level_enum.id as callin_level_id','callin_level_enum.name as callin_level_name','callin_level_enum.help as callin_level_help','has_call_anystation','has_manage_recordings','has_call_monitoring','has_loc_monitoring','has_conf_admin','has_conf_user','has_voicemail', 'has_call_recording', 'has_activate_alarms','has_disable_audio','has_enable_audio','has_callee_autoanswer','has_multiserver_paging','has_interfacility_features','has_manage_output_contacts','has_execute_routines')
            ->get();
			
			foreach($cos_data as $cos_item){
				$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$cos_item->name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$enabled = '';
				if($cos_item->enabled==1){ $enabled = 'Yes'; } else { $enabled = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$enabled.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$cos_item->callin_level_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$cos_item->callin_level_help.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$has_zone_paging = '';
				if($cos_item->has_zone_paging==1){ $has_zone_paging = 'Yes'; } else { $has_zone_paging = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$has_zone_paging.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$has_all_call_page = '';
				if($cos_item->has_all_call_page==1){ $has_all_call_page = 'Yes'; } else { $has_all_call_page = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$has_all_call_page.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$has_emergency_all_call = '';
				if($cos_item->has_emergency_all_call==1){ $has_emergency_all_call = 'Yes'; } else { $has_emergency_all_call = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$has_emergency_all_call.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$has_interfacility_callpage = '';
				if($cos_item->has_interfacility_callpage==1){ $has_interfacility_callpage = 'Yes'; } else { $has_interfacility_callpage = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$has_interfacility_callpage.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$has_program_distribution = '';
				if($cos_item->has_program_distribution==1){ $has_program_distribution = 'Yes'; } else { $has_program_distribution = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$has_program_distribution.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$has_remote_pickup = '';
				if($cos_item->has_remote_pickup==1){ $has_remote_pickup = 'Yes'; } else { $has_remote_pickup = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$has_remote_pickup.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$has_call_forwarding = '';
				if($cos_item->has_call_forwarding==1){ $has_call_forwarding = 'Yes'; } else { $has_call_forwarding = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$has_call_forwarding.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$has_walking_cos = '';
				if($cos_item->has_walking_cos==1){ $has_walking_cos = 'Yes'; } else { $has_walking_cos = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$has_walking_cos.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$has_external_call_routing = '';
				if($cos_item->has_external_call_routing==1){ $has_external_call_routing = 'Yes'; } else { $has_external_call_routing = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$has_external_call_routing.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$has_call_transfer = '';
				if($cos_item->has_call_transfer==1){ $has_call_transfer = 'Yes'; } else { $has_call_transfer = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$has_call_transfer.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$has_manual_activate_tone = '';
				if($cos_item->has_manual_activate_tone==1){ $has_manual_activate_tone = 'Yes'; } else { $has_manual_activate_tone = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$has_manual_activate_tone.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$has_call_anystation = '';
				if($cos_item->has_call_anystation==1){ $has_call_anystation = 'Yes'; } else { $has_call_anystation = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$has_call_anystation.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$has_manage_recordings = '';
				if($cos_item->has_manage_recordings==1){ $has_manage_recordings = 'Yes'; } else { $has_manage_recordings = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$has_manage_recordings.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$has_call_monitoring = '';
				if($cos_item->has_call_monitoring==1){ $has_call_monitoring = 'Yes'; } else { $has_call_monitoring = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$has_call_monitoring.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$has_loc_monitoring = '';
				if($cos_item->has_loc_monitoring==1){ $has_loc_monitoring = 'Yes'; } else { $has_loc_monitoring = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$has_loc_monitoring.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$has_conf_admin = '';
				if($cos_item->has_conf_admin==1){ $has_conf_admin = 'Yes'; } else { $has_conf_admin = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$has_conf_admin.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$has_conf_user = '';
				if($cos_item->has_conf_user==1){ $has_conf_user = 'Yes'; } else { $has_conf_user = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$has_conf_user.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$has_voicemail = '';
				if($cos_item->has_voicemail==1){ $has_voicemail = 'Yes'; } else { $has_voicemail = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$has_voicemail.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$has_call_recording = '';
				if($cos_item->has_call_recording==1){ $has_call_recording = 'Yes'; } else { $has_call_recording = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$has_call_recording.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$has_activate_alarms = '';
				if($cos_item->has_activate_alarms==1){ $has_activate_alarms = 'Yes'; } else { $has_activate_alarms = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$has_activate_alarms.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$has_disable_audio = '';
				if($cos_item->has_disable_audio==1){ $has_disable_audio = 'Yes'; } else { $has_disable_audio = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$has_disable_audio.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$has_enable_audio = '';
				if($cos_item->has_enable_audio==1){ $has_enable_audio = 'Yes'; } else { $has_enable_audio = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$has_enable_audio.'</ss:Data></ss:Cell>'. '' . PHP_EOL;	
				$has_callee_autoanswer = '';
				if($cos_item->has_callee_autoanswer==1){ $has_callee_autoanswer = 'Yes'; } else { $has_callee_autoanswer = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$has_callee_autoanswer.'</ss:Data></ss:Cell>'. '' . PHP_EOL;				
				$has_multiserver_paging = '';
				if($cos_item->has_multiserver_paging==1){ $has_multiserver_paging = 'Yes'; } else { $has_multiserver_paging = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$has_multiserver_paging.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$has_interfacility_features = '';
				if($cos_item->has_interfacility_features==1){ $has_interfacility_features = 'Yes'; } else { $has_interfacility_features = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$has_interfacility_features.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$has_manage_output_contacts = '';
				if($cos_item->has_manage_output_contacts==1){ $has_manage_output_contacts = 'Yes'; } else { $has_manage_output_contacts = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$has_manage_output_contacts.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$has_execute_routines = '';
				if($cos_item->has_execute_routines==1){ $has_execute_routines = 'Yes'; } else { $has_execute_routines = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$has_execute_routines.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				
				$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
			}
			
			$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
			$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
			// End CoS Worksheet
			
		// Start Users Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="Users">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$usersHeaderArray = ['Username','Email','First Name','Last Name','Extension','Valid Extensions','Role Name','Role Label','Role Description','Timeout'];
	
		foreach($usersHeaderArray as $user_header_name){
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$user_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// User data
		$users = User::
			leftJoin('role_user', 'users.id', '=', 'role_user.user_id')
			->leftJoin('roles', 'roles.id', '=', 'role_user.role_id')
			->select('users.id as user_id', 'username', 'first_name', 'last_name', 'email', 'extension', 'valid_extensions', 'timeout', 'role_user.role_id as role_id', 'roles.name as role_name','roles.label as role_label','roles.description as role_description')
			->get()->all();
			
			foreach($users as $user){
				$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$user->username.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$user->email.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$user->first_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$user->last_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$user->extension.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$user->valid_extensions.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$user->role_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$user->role_label.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$user->role_description.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$user->timeout.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				
				$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
			}
			
			$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
			$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
			// End Users Worksheet
			
		// Start Roles Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="Roles">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$rolesHeaderArray = ['Name','Label','Description'];
	
		foreach($rolesHeaderArray as $role_header_name){
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$role_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// Roles data
		 $roles = Role::get();
			
			foreach($roles as $role){
				$spreadsheet_data .= '<ss:Row ss:StyleID="1">';
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$role->name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$role->label.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$role->description.'</ss:Data></ss:Cell>'. '' . PHP_EOL;

				
				$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
			}
			
			$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
			$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
			// End Roles Worksheet
			
		// Start Role_User Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="Role_User">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$roleuserHeaderArray = ['Role','User'];
	
		foreach($roleuserHeaderArray as $roleuser_header_name){
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$roleuser_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// Role_User data
		 $role_users = Role_user::
		 	leftJoin('roles', 'roles.id', '=', 'role_user.role_id')
			->leftJoin('users', 'users.id', '=', 'role_user.user_id')
			->select('roles.name as role_name','users.username as username')
			->get();
			
			foreach($role_users as $role_user){
				$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$role_user->role_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$role_user->username.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				
				$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
			}
			
			$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
			$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
			// End Role_User Worksheet
			
		// Start Permission_role Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="Permission_Role">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$permissionroleHeaderArray = ['Permission','Role'];
	
		foreach($permissionroleHeaderArray as $permissionrole_header_name){
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$permissionrole_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// Permission_role data
		 $permission_roles = Permission_role::
		 	leftJoin('permissions', 'permissions.id', '=', 'permission_role.permission_id')
			->leftJoin('roles', 'roles.id', '=', 'permission_role.role_id')
			->select('permissions.name as permission_name','permissions.label as label','permissions.group as group','roles.name as role_name')
			->get();
			
			foreach($permission_roles as $permission_role){
				$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$permission_role->label.' '.$permission_role->group.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$permission_role->role_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				
				$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
			}
			
			$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
			$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
			// End Permission_role Worksheet
			
		// Start Announcements Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="Announcements">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$announcementsHeaderArray = ['Name','Type','Description','Date Created','Time Created','Creator Ext','Times To Play','Repeat Period','File Name','Text-To-Speech','Play to Zone','DTMF Code'];
	
		foreach($announcementsHeaderArray as $announcement_header_name){
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$announcement_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// Announcements data
		 $announcements = Announcement::
			leftJoin('announcement_types_enum', 'announcement_types_enum.id', '=', 'announcement.type')
			->select('announcement.id as announcement_id','file_name', 'date_created', 'time_created', 'description', 'creator_ext', 'announcement.name as announcement_name', 'announcement.type as announcement_type', 'announcement_types_enum.name as type_name', 'help','times_to_play','tts', 'repeat_period','play_to_zone','dtmf_code')
			->orderBy('announcement.id', 'asc')
			->get(); 
			
			foreach($announcements as $announcement){
				$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$announcement->announcement_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$announcement->type_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$announcement->description.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$announcement->date_created.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$announcement->time_created.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$announcement->creator_ext.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$times_to_play = '';
				if($announcement->times_to_play==0){ $times_to_play ='Continuous'; } else { $times_to_play = $announcement->times_to_play; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$times_to_play.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$announcement->repeat_period.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$announcement->file_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.strip_tags($announcement->tts).'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$play_to_zone = '';
				if($announcement->play_to_zone==0 || $announcement->play_to_zone==''){$play_to_zone='All Speakers';} else {$play_to_zone = $announcement->play_to_zone; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$play_to_zone.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$announcement->dtmf_code.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				
				$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
			}
			
			$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
			$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
			// End Announcements Worksheet
			
		// Start Playlists Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="Playlists">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$playlistsHeaderArray = ['Name','Description','Repeat','Shuffle'];
	
		foreach($playlistsHeaderArray as $playlist_header_name){
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$playlist_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// Playlists data
		 $playlists = Playlists::get();	
			
			foreach($playlists as $playlist){
				$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$playlist->name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$playlist->description.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$ccm_repeat = '';
				if($playlist->ccm_repeat==1){ $ccm_repeat = 'Yes'; } else { $ccm_repeat = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$ccm_repeat.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$ccm_shuffle = '';
				if($playlist->ccm_shuffle==1){ $ccm_shuffle = 'Yes'; } else { $ccm_shuffle = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$ccm_shuffle.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
				$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
			}
			
			$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
			$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
			// End Playlists Worksheet
			
		// Start Recordings Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="Recordings">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$recordingsHeaderArray = ['File Name','Call Type','Caller Ext','Called Ext','Date Time','Year','Month','Day','Hour','Minute','Second'];
	
		foreach($recordingsHeaderArray as $recording_header_name){
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$recording_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// Recordings data
		 $recordings = Recording::get();
			
			foreach($recordings as $recording){
				$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$recording->filename.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$recording->call_type.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$recording->caller_ext.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$recording->called_ext.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$recording->date_time.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$recording->year.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$recording->month.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$recording->day.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$recording->hour.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$recording->minute.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$recording->second.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
				$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
			}
			
			$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
			$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
			// End Recordings Worksheet
			
		// Start Songs Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="Songs">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$songsHeaderArray = ['Title','Artist','Album','Track Number','Year','Genre','Length','File Name','File Location','Suffix','DTMF Code'];
	
		foreach($songsHeaderArray as $song_header_name){
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$song_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// Songs data
		 $songs = Songs::get();
			
			foreach($songs as $song){
				$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$song->title.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$song->artist.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$song->album.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$song->track_number.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$song->year.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$song->genre.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$song->length.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$song->file_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$song->file_location.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$song->suffix.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$song->dial_number.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
				$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
			}
			
			$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
			$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
			// End Songs Worksheet
			
		// Start Song_playlist Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="Song_Playlist">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$songplaylistHeaderArray = ['Song','Playlist','Sort Order'];
	
		foreach($songplaylistHeaderArray as $songplaylist_header_name){
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$songplaylist_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// Songs data
		 $song_playlists = Song_playlist::
		 	leftJoin('songs', 'songs.id', '=', 'song_playlist.song_id')
			->leftJoin('playlists', 'playlists.id', '=', 'song_playlist.playlist_id')
			->select('songs.title as song_name','playlists.name as playlist_name','sort_order')
			->get();
			
			foreach($song_playlists as $song_playlist){
				$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$song_playlist->song_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$song_playlist->playlist_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$song_playlist->sort_order.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
				$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
			}
			
			$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
			$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
			// End Song_playlist Worksheet
			
		// Start Tones Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="Tones">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$tonesHeaderArray = ['Name','Type','DTMF Code','Length','Times To Play','Repeat Period','File Name','File Location','Suffix','Hide'];
	
		foreach($tonesHeaderArray as $tone_header_name){
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$tone_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// Tones data
		$tones = Tone::
		 	leftJoin('tone_types_enum', 'tone_types_enum.id', '=', 'tone.tone_type')
			->select('tone.id as tone_id','tone.name as tone_name', 'length', 'file_name', 'file_location', 'dial_number', 'suffix', 'repeat_period', 'tone_types_enum.id as tone_type_id', 'tone_types_enum.name as tone_type_name','times_to_play','hide')
            ->get();
			
			foreach($tones as $tone){
				$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$tone->tone_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$tone->tone_type_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$tone->dial_number.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$tone->length.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$times_to_play = '';
				if($tone->times_to_play==0){ $times_to_play ='Continuously'; } else { $times_to_play = $tone->times_to_play; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$times_to_play.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$tone->repeat_period.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$tone->file_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$tone->file_location.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$tone->suffix.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$hide = '';
				if($tone->hide==1){ $hide = 'Yes'; } else { $hide = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$hide.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				
				$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
			}
			
			$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
			$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
			// End Tones Worksheet
			
		// Start Schedule Announcements Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="Schedule Announcements">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$scheduleAnnouncementsHeaderArray = ['Name','File Name','Description','Creator Ext','Signal Date','Signal Time','Zones','Enable Recurrence','Recurrence Start Date','Recurrence End Date','Recurrence Data'];
	
		foreach($scheduleAnnouncementsHeaderArray as $schedule_announcement_header_name){
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_announcement_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// Schedule Announcements data
		$schedule_announcements = Schedule_announcements::
			leftJoin('announcement', 'announcement.id', '=', 'schedule_announcements.announcement_id')
			->select('schedule_announcements.id as schedule_announcements_id', 'name', 'file_name', 'description', 'schedule_announcements.creator_ext as creator_ext', 'announcement_id', 'signal_date', 'signal_time', 'zones','announcement.name as announcement_name','enable_recurrence','recurrence_start_date','recurrence_end_date','cron_minute','cron_hour','cron_day','cron_month','cron_day_of_week','second')
			->orderBy('signal_date', 'asc')
			->orderBy('signal_time', 'asc')
			->get();
			
			foreach($schedule_announcements as $schedule_announcement){
				$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_announcement->name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_announcement->file_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_announcement->description.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_announcement->creator_ext.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_announcement->signal_date.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_announcement->signal_time.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_announcement->zones.'</ss:Data></ss:Cell>';
				$enable_recurrence = '';
				if($schedule_announcement->enable_recurrence==1){ $enable_recurrence = 'Yes'; } else { $enable_recurrence = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$enable_recurrence.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_announcement->recurrence_start_date.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_announcement->recurrence_end_date.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				
					$final_text = '';
					$recurrence_second = $schedule_announcement->second;
					$recurrence_minute = str_replace(",",", ",$schedule_announcement->cron_minute);
					$recurrence_hour = '';
					$recurrence_day = '';
					$recurrence_month = '';
					$recurrence_dow = '';

					if($schedule_announcement->cron_hour=="*"){
						$recurrence_hour = "Every";
					} else if($schedule_announcement->cron_hour!=""){
						$hoursArray = explode(",", $schedule_announcement->cron_hour);
						foreach($hoursArray as $key => $cron_hour){
							$comma='';
							if($key>0){
								$comma = ', ';
							}
							$label = date("ga", mktime($cron_hour, 0, 0, 1, 1, 2016));
							$recurrence_hour = $recurrence_hour.''.$comma.''.$label;
						}
					}

					if($schedule_announcement->cron_day=="*"){
						$recurrence_day = "Every";
					} else if($schedule_announcement->cron_day!=""){
						$daysArray = explode(",", $schedule_announcement->cron_day);
						foreach($daysArray as $key => $cron_day){
							$comma='';
							if($key>0){
								$comma = ', ';
							}
							$label = date("jS", mktime(0, 0, 0, 1, $cron_day, 2016));
							$recurrence_day = $recurrence_day.''.$comma.''.$label;
						}
					}

					if($schedule_announcement->cron_month=="*"){
						$recurrence_month = "Every";
					} else if($schedule_announcement->cron_month!=""){
						$monthsArray = explode(",", $schedule_announcement->cron_month);
						foreach($monthsArray as $key => $cron_month){
							$comma='';
							if($key>0){
								$comma = ', ';
							}
							$label = date("F", mktime(0, 0, 0, $cron_month, 1, 2016));
							$recurrence_month = $recurrence_month.''.$comma.''.$label;
						}
					}

					if($schedule_announcement->cron_day_of_week=="*"){
						$recurrence_dow = "Every";
					} else if($schedule_announcement->cron_day_of_week!=""){
						$dowArray = explode(",", $schedule_announcement->cron_day_of_week);
						foreach($dowArray as $key => $cron_dow){
							$comma='';
							if($key>0){
								$comma = ', ';
							}
							$label = date("l", mktime(0, 0, 0, 2, $cron_dow, 2016));
							$recurrence_dow = $recurrence_dow.''.$comma.''.$label;
						}
					}

					if($schedule_announcement->recurrence_start_date=='0000-00-00'){
					} else { 
						$recurrence_start_date =  date_format(date_create($schedule_announcement->recurrence_start_date . ' 00:00:00'), 'M d, Y');
					} 
					if($schedule_announcement->recurrence_end_date=='0000-00-00'){

					} else if($schedule_announcement->recurrence_end_date=='9999-12-31'){
						$recurrence_end_date = 'No End Date';
					} else { 
						$recurrence_end_date = date_format(date_create($schedule_announcement->recurrence_end_date . ' 00:00:00'), 'M d, Y');
					}
					if($schedule_announcement->cron_minute=="*"){
						$recurrence_minute = "Every";
					}

					if($schedule_announcement->enable_recurrence==1){
						$final_text = 'Second: '.$recurrence_second.' - Minute: '.$recurrence_minute.' - Hour: '.$recurrence_hour.' - Day: '.$recurrence_day.' - Month: '.$recurrence_month.' - Day of Week: '.$recurrence_dow;
					}
				
				
				
				
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$final_text.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
				$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
			}
			
			$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
			$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
			// End Schedule Announcements Worksheet
			
		// Start Schedule Settings Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="'.$product_feature_settings->label_plural.'">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$scheduleSettingsHeaderArray = ['Name','Start Date','End Date','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday','Sunday','Color'];
	
		foreach($scheduleSettingsHeaderArray as $schedule_setting_header_name){
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_setting_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// Schedule Settings data
		$schedule_settings = Schedule_settings::
			leftJoin('schedules as monday_schedule', 'monday_schedule.id', '=', 'schedule_settings.monday')
			->leftJoin('schedules as tuesday_schedule', 'tuesday_schedule.id', '=', 'schedule_settings.tuesday')
			->leftJoin('schedules as wednesday_schedule', 'wednesday_schedule.id', '=', 'schedule_settings.wednesday')
			->leftJoin('schedules as thursday_schedule', 'thursday_schedule.id', '=', 'schedule_settings.thursday')
			->leftJoin('schedules as friday_schedule', 'friday_schedule.id', '=', 'schedule_settings.friday')
			->leftJoin('schedules as saturday_schedule', 'saturday_schedule.id', '=', 'schedule_settings.saturday')
			->leftJoin('schedules as sunday_schedule', 'sunday_schedule.id', '=', 'schedule_settings.sunday')
			->select('schedule_settings.id as schedule_settings_id', 'schedule_settings.start_date as start_date','schedule_settings.end_date as end_date','schedule_settings.name as name','schedule_settings.monday as monday', 'schedule_settings.tuesday as tuesday', 'schedule_settings.wednesday as wednesday', 'schedule_settings.thursday as thursday', 'schedule_settings.friday as friday', 'schedule_settings.saturday as saturday', 'schedule_settings.sunday as sunday', 'monday_schedule.name as monday_name', 'tuesday_schedule.name as tuesday_name','wednesday_schedule.name as wednesday_name','thursday_schedule.name as thursday_name','friday_schedule.name as friday_name','saturday_schedule.name as saturday_name','sunday_schedule.name as sunday_name','schedule_settings.color as color')
			->get();
			
			foreach($schedule_settings as $schedule_setting){
				$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_setting->name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_setting->start_date.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_setting->end_date.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_setting->monday_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_setting->tuesday_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_setting->wednesday_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_setting->thursday_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_setting->friday_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_setting->saturday_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_setting->sunday_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_setting->color.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				
				$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
			}
			
			$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
			$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
			// End Schedule Settings Worksheet
			
		// Start Schedules Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="Schedules">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$schedulesHeaderArray = ['Name','Description','Schedule Settings Name'];
	
		foreach($schedulesHeaderArray as $schedule_header_name){
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// Schedules data
		$schedules = Schedules::
			leftJoin('schedule_settings', 'schedules.schedule_settings_id', '=', 'schedule_settings.id')
			->select('schedules.id as schedule_id','schedules.name as schedule_name','schedules.description as schedule_description','schedule_settings.id as schedule_settings_id','schedule_settings.name as schedule_settings_name')
			->get()
			->all();
			
			foreach($schedules as $schedule){
				$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule->schedule_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule->schedule_description.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule->schedule_settings_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				
				$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
			}
			
			$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
			$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
			// End Schedules Worksheet
			
		// Start Schedule Exceptions Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="Schedule Exceptions">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$scheduleExceptionsHeaderArray = ['Date','Schedule Name','Schedule Settings Name'];
	
		foreach($scheduleExceptionsHeaderArray as $schedule_exception_header_name){
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_exception_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// Schedule Exceptions data
		$schedule_exceptions = Schedule_exceptions::
			leftJoin('schedule_settings', 'schedule_exceptions.schedule_settings_id', '=', 'schedule_settings.id')
			->leftJoin('schedules', 'schedule_exceptions.schedule_id', '=', 'schedules.id')
			->select('schedule_exceptions.id as schedule_exception_id','exception_date','schedules.id as schedule_id','schedules.name as schedule_name','schedule_settings.id as schedule_settings_id','schedule_settings.name as schedule_settings_name')
			->get()
			->all();
			
			foreach($schedule_exceptions as $schedule_exception){
				$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_exception->exception_date.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_exception->schedule_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_exception->schedule_settings_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				
				$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
			}
			
			$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
			$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
			// End Schedule Exceptions Worksheet
			
		// Start Schedule Events Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="Schedule Events">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$scheduleEventsHeaderArray = ['Name','Schedule Name','Tone Name','Signal Time','Zones','Playlists Id', 'Playlist Command', 'Input Extension', 'Input Channel', 'Input Command', 'Station List','Display Event Name'];
	
		foreach($scheduleEventsHeaderArray as $schedule_events_header_name){
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_events_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>';
		
		// Schedule Events data
		$schedule_events = Schedule_events::
			leftJoin('schedules', 'schedule_events.schedule_id', '=', 'schedules.id')
			->leftJoin('tone', 'schedule_events.tone_id', '=', 'tone.id')
			->select('schedule_events.id as schedule_event_id', 'schedule_events.name as schedule_event_name','schedule_events.schedule_id as schedule_id','schedules.name as schedule_name','tone.id as tone_id','tone.name as tone_name','signal_time','zones','stationlist', 'playlists_id', 'playlist_cmd', 'input_extension','input_channel','input_cmd','display_event_name')
			->get();
			
			foreach($schedule_events as $schedule_event){
				$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_event->schedule_event_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_event->schedule_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_event->tone_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_event->signal_time.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_event->zones.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_event->playlists_id.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_event->playlist_cmd.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_event->input_extension.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_event->input_channel.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_event->input_cmd.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$schedule_event->stationlist.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$display_event_name = '';
				if($schedule_event->display_event_name==1){ $display_event_name = 'Yes'; } else { $display_event_name = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$display_event_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				
				$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
			}
			
			$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
			$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
			// End Schedule Events Worksheet
			
		// Start Holidays Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="Holidays">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$holidaysHeaderArray = ['Name','Start Date','End Date'];
	
		foreach($holidaysHeaderArray as $holiday_header_name){
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$holiday_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// Holidays data
		$holidays = Holidays::get();
			
			foreach($holidays as $holiday){
				$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$holiday->name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$holiday->start_date.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$holiday->end_date.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				
				$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
			}
			
			$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
			$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
			// End Holidays Worksheet
			
		// Start Outside Lines Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="Outside Lines">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$outsidelinesHeaderArray = ['Facility','Enabled','Port Name','Extension','Status','Description','Port Type','Port Type Name','Access','Access Name','Admin Group','Admin Group Name','Dial Prefix','DID','Day Admin','Night Admin'];
	
		foreach($outsidelinesHeaderArray as $outsideline_header_name){
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$outsideline_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// Outside Lines data
		$outside_lines = Outside_line::
			leftJoin('outside_line_access_types', 'outside_line_access_types.id', '=', 'outside_line.access')
			->leftJoin('admin_group', 'admin_group.id', '=', 'outside_line.admin_group')
			->leftJoin('telephony_port_types', 'telephony_port_types.id', '=', 'outside_line.port_type')
			->orderBy('port_name','asc')
			->select('outside_line.id as id', 'facility', 'enabled', 'status', 'extension', 'port_name', 'outside_line.description as description', 'port_type', 'access', 'dial_prefix',  'did', 'day_admin', 'night_admin', 'admin_group','outside_line_access_types.name as access_name', 'admin_group.name as admin_group_name', 'telephony_port_types.name as port_type_name')
			->get();
			
			foreach($outside_lines as $outside_line){
				$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$outside_line->facility.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$enabled = '';
				if($outside_line->enabled==1){ $enabled = 'Yes'; } else { $enabled = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$enabled.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$outside_line->port_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$outside_line->extension.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$outside_line->status.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$outside_line->description.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$outside_line->port_type.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$outside_line->port_type_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$outside_line->access.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$outside_line->access_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$outside_line->admin_group.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$outside_line->admin_group_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$outside_line->dial_prefix.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$outside_line->did.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$outside_line->day_admin.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$outside_line->night_admin.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				
				$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
			}
			
			$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
			$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
			// End Outside Lines Worksheet
			
		// Start SIP Trunks  Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="SIP Trunks">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$siptrunksHeaderArray = ['Name','Description','Enabled','Status','Access','Access Name','Extension','DID','Username','Host','Dial Prefix','Local Area Code','Type','Type Name','Day Admin','Night Admin','Admin Group','Codecs Allowed','Has Call Recording','Custom Settings'];
	
		foreach($siptrunksHeaderArray as $outsideline_header_name){
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$outsideline_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// SIP Trunks  data
		$sip_trunks = Sip_trunk::
			leftJoin('admin_group', 'admin_group.id', '=', 'sip_trunk.admin_group')
			->leftJoin('telephony_port_types', 'telephony_port_types.id', '=', 'sip_trunk.type')
			->leftJoin('outside_line_access_types', 'outside_line_access_types.id', '=', 'sip_trunk.access')
			->select('sip_trunk.id as id', 'extension', 'status', 'dial_prefix', 'local_areacode', 'facility', 'sip_trunk.name as name', 'enabled', 'sip_trunk.description as description', 'username', 'host', 'type', 'access', 'did', 'day_admin', 'night_admin', 'admin_group', 'disallow', 'allow', 'context', 'dtmf_mode', 'has_call_recording', 'custom_settings',  'admin_group.name as admin_group_name', 'telephony_port_types.name as type_name', 'outside_line_access_types.name as access_type')
			->get();
			
			foreach($sip_trunks as $sip_trunk){
				$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$sip_trunk->name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$sip_trunk->description.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$enabled = '';
				if($sip_trunk->enabled==1){ $enabled = 'Yes'; } else { $enabled = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$enabled.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$sip_trunk->status.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$sip_trunk->access.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$sip_trunk->access_type.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$sip_trunk->extension.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$sip_trunk->did.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$sip_trunk->username.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$sip_trunk->host.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$sip_trunk->dial_prefix.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$sip_trunk->local_areacode.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$sip_trunk->type.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$sip_trunk->type_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$sip_trunk->day_admin.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$sip_trunk->night_admin.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$sip_trunk->admin_group_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$sip_trunk->allow.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$has_call_recording = '';
				if($sip_trunk->has_call_recording==1){ $has_call_recording = 'Yes'; } else { $has_call_recording = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$has_call_recording.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$sip_trunk->custom_settings.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				
				
				$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
			}
			
			$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
			$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
			// End SIP Trunks Worksheet
			
			// Start Facilities Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="Facilities">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$facilitiesHeaderArray = ['Page#','Name','Enabled','Host','Password','Status'];
	
		foreach($facilitiesHeaderArray as $facility_header_name){
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$facility_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// Facilities data
		$facilities = Server::get();
			
			foreach($facilities as $facility){
				$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$facility->id.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$facility->name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$enabled = '';
				if($facility->enabled==1){ $enabled = 'Yes'; } else { $enabled = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$enabled.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$facility->host.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$facility->secret.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$facility->status.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				
				$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
			}
			
			$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
			$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
			// End Facilities Worksheet
			
			// Start Paging Exclusions Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="Paging Exclusions">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$exclusionsHeaderArray = ['Extension','Name'];
	
		foreach($exclusionsHeaderArray as $exclusions_header_name){
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$exclusions_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// Paginging Exclusions data
		$paging_exclusions = Paging_exclusion::
			leftJoin('station', 'station.extension', '=', 'paging_exclusion.extension')
			->select('station.extension as extension', 'station.name as name')
			->get();
			
			foreach($paging_exclusions as $paging_exclusion){
				$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$paging_exclusion->extension.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$paging_exclusion->name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				
				$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
			}
			
			$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
			$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
			// End Paging Exclusions Worksheet
		
		
		// Start Bridge Devices Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="Bridge Devices">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$gatewaysHeaderArray = ['Name','Description','MAC Address','IP Address','Status','Enabled','Master Volume','Intercom Volume', 'Day CoS','Night CoS','Day Admin','Night Admin','911 Route','VLAN Config','VLAN Id','VLAN Priority','Web Username','Web Password','Serial Number'];
	
		foreach($gatewaysHeaderArray as $gateways_header_name){
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$gateways_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// Bridge Devices data
		$gateways = Gateway::
			leftJoin('cos as cos1', 'gateway.day_cos', '=', 'cos1.id')
			->leftJoin('cos as cos2', 'gateway.night_cos', '=', 'cos2.id')
		->select('gateway.name as name','gateway.description as description','gateway.mac_address as mac_address','gateway.ip_address as ip_address','gateway.status as status','gateway.enabled as enabled','gateway.master_volume as master_volume','gateway.intercom_volume as intercom_volume','cos1.name as day_cos','cos2.name as night_cos','gateway.day_admin as day_admin','gateway.night_admin as night_admin','gateway.911_route as nine_one_one_route','gateway.vlan_config as vlan_config', 'gateway.vlan_id as vlan_id','gateway.priority_802_1p as priority_802_1p','gateway.web_username as web_username','gateway.web_password as web_password','gateway.serial_number as serial_number')
			->get();
			
			foreach($gateways as $gateway){
				$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$gateway->name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$gateway->description.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$gateway->mac_address.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.long2ip($gateway->ip_address).'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$gateway->status.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$enabled = '';
				if($gateway->enabled==1){ $enabled = 'Yes'; } else { $enabled = 'No'; }
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$enabled.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$gateway->master_volume.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$gateway->intercom_volume.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$gateway->day_cos.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$gateway->night_cos.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$gateway->day_admin.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$gateway->night_admin.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$gateway->nine_one_one_route.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$gateway->vlan_config.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$gateway->vlan_id.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$gateway->priority_802_1p.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$gateway->web_username.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$gateway->web_password.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$gateway->serial_number.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
				
				$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
			}
			
			$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
			$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
			// End Bridge Devices Worksheet
		
		// IO Mixer Config Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="IO Mixer Config">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$mixerConfigHeaderArray = ['Extension','PTT Channel','PTT Type','PTT Zones','PTT Stream Source for Mixer Output'];
	
		foreach($mixerConfigHeaderArray as $mixer_config_header_name){
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$mixer_config_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// IO Mixer Config data
		$mixer_config = Mixer_config::get();

		foreach($mixer_config as $config){
			$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$config->extension.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$config->ptt_channel.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$config->ptt_type.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$config->ptt_zones.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$config->ptt_src_to_out.'</ss:Data></ss:Cell>'. '' . PHP_EOL;

			$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		}

		$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
		// End IO Mixer Config Worksheet
		
		// IO Controller Rules Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="IO Controller Rules">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$ctrlRuleHeaderArray = ['Enabled','Extension','Contact Number','Contact Type','Name','Description','Close Interval','Action In','Action In Id','Stop On','Action Out','Action Out Id','Zones','Close Extension','Close Contact','Duration','On Time','Days','Dashboard Type','Dashboard Title','Dashboard Scope','Dashboard Text','Dashboard Style','Email'];
	
		foreach($ctrlRuleHeaderArray as $ctrl_rule_header_name){
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$ctrl_rule_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// IO Controller Rules data
		$ctrl_rules = Ctrl_rule::get();
			
		foreach($ctrl_rules as $ctrl_rule){
			 $close_interval = $ctrl_rule->close_interval;
			   if($close_interval==-1){
				   $close_interval = 0;
			   } else {
				   $close_interval = abs($close_interval);
			   }
			$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
			$enabled = '';
			if($ctrl_rule->enabled==1){ $enabled = 'Yes'; } else { $enabled = 'No'; }
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$enabled.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$ctrl_rule->extension.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$ctrl_rule->contact_num.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$ctrl_rule->contact_type.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$ctrl_rule->name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$ctrl_rule->description.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$close_interval.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$ctrl_rule->action_in.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$ctrl_rule->action_in_id.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$ctrl_rule->stop_on.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$ctrl_rule->action_out.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$ctrl_rule->action_out_id.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$ctrl_rule->zones.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$ctrl_rule->close_ext.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$ctrl_rule->close_contact.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$ctrl_rule->duration.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$ctrl_rule->on_time.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$ctrl_rule->days.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$ctrl_rule->dashboard_type.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$ctrl_rule->dashboard_title.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$ctrl_rule->dashboard_scope.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$ctrl_rule->dashboard_text.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$ctrl_rule->dashboard_style.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$ctrl_rule->email.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		}

		$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
		// End IO Controller Rules Worksheet
		
		// IO Controller Schedule Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="IO Controller Schedule">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$controllerSchedulelHeaderArray = ['Enabled','Extension','Contact Number','State','Activity Time','Duration','Days','Description'];
	
		foreach($controllerSchedulelHeaderArray as $controller_schedule_header_name){
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$controller_schedule_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// IO Controller Schedule data
		$io_contact_sched= Io_contact_sched::get();
			
		foreach($io_contact_sched as $contact_sched){
			$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
			$enabled = '';
			if($contact_sched->enabled==1){ $enabled = 'Yes'; } else { $enabled = 'No'; }
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$enabled.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$contact_sched->extension.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$contact_sched->contact_num.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$contact_sched->state.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$contact_sched->activity_time.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$contact_sched->duration.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$contact_sched->days.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$contact_sched->description.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		}

		$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
		// End IO Controller Schedule Worksheet
		
		// Maps Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="Maps">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$mapsHeaderArray = ['Name','Image','Width','Height'];
	
		foreach($mapsHeaderArray as $maps_header_name){
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$maps_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// Maps data
		$maps= Maps::get();
			
		foreach($maps as $map){
			$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$map->name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$map->image.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$map->width.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$map->height.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		}

		$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
		// End Maps Worksheet
		
		// Zones_queue Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="Zones Queue">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$queueHeaderArray = ['Number','Name','Delay Between','Plays','Zones'];
	
		foreach($queueHeaderArray as $queue_header_name){
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$queue_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// Zones_queue data
		$zones_queues = Zones_queue::get();
			
		foreach($zones_queues as $zones_queue){
			$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$zones_queue->queue_num.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$zones_queue->name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$zones_queue->delay_btw_msgs.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$zones_queue->msg_repeats.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
			$zones_queue_subs = Zones_queue_subs::where('queue_num','=',$zones_queue->queue_num)->get();
			
			$zones_text = '';
			
			foreach($zones_queue_subs as $zones_queue_sub){
				$zones_text = $zones_text . '' . $zones_queue_sub->zone . ', ';
			}
		
			$zones_text = substr($zones_text , 0, -2);
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$zones_text.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		}

		$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
		// End Zones_queue Worksheet
		
		// Amplifier Devices Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="Amplifier Devices">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$amplifierHeaderArray = ['Name','Device Type','Mac Address','Serial Number','IP Address','Status','Description','Master Volume','Intercom Volume','VLAN Configuration','VLAN ID','VLAN Priority','Web Username','Firmware','Number of Stations'];
	
		foreach($amplifierHeaderArray as $amplifier_header_name){
			
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$amplifier_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// Amplifier Devices data
		$amplifiers = Amplifier::
		leftJoin('device_types_enum', 'amplifier.device_type', '=', 'device_types_enum.id')
		->select('amplifier.id as id', 'amplifier.device_type as device_type','device_types_enum.name as device_type_name','amplifier.name as name','amplifier.mac_address as mac_address','amplifier.ip_address as ip_address','amplifier.status as status','amplifier.description as description','amplifier.master_volume as master_volume','amplifier.intercom_volume as intercom_volume','amplifier.vlan_config as vlan_config','amplifier.vlan_id as vlan_id','amplifier.priority_802_1p as priority_802_1p','amplifier.web_username as web_username','amplifier.web_password as web_password','amplifier.serial_number as serial_number','amplifier.fw_filename as fw_filename','amplifier.number_of_stations as number_of_stations')
		->orderBy('amplifier.name', 'asc')
		->get();
			
		foreach($amplifiers as $amplifier){
			$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$amplifier->name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$amplifier->device_type_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$amplifier->mac_address.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$amplifier->serial_number.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.long2ip($amplifier->ip_address).'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$amplifier->status.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$amplifier->description.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$amplifier->master_volume.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$amplifier->intercom_volume.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$amplifier->vlan_config.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$amplifier->vlan_id.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$amplifier->priority_802_1p.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$amplifier->web_username.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$amplifier->fw_filename.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$amplifier->number_of_stations.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		}

		$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
		// End Amplifier Devices Worksheet
		
		// ANS Listeners Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="ANS Listeners">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$ansListenerArray = ['ANS Ext','Listener Ext'];
	
		foreach($ansListenerArray as $ans_header_name){
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$ans_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
	
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// ANS Listeners data
		$ans_listeners = Ans_listeners::get();
			
		foreach($ans_listeners as $ans_listener){
			$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$ans_listener->ans_ext.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$ans_listener->listener_ext.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		}

		$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
		// End ANS Listeners Worksheet
		
		// Start Product Licensing Information Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="Product Licensing Information">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$licensingInfoArray = ['Maximum Concurrent Calls Limit','Current Call Count','Maximum Station Limit','Current Station Count','Maximum Zone Limit','Current Zone Count','Maximum Intercom Calls','Queue Count','Maximum Page Stacking Queues'];
	
		foreach($licensingInfoArray as $licensing_info_header_name){
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$licensing_info_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// Get Licensing Data
		
		// run script for maximum concurrent calls limit
		$script_path1 = '/usr/local/bin/get-calls-info -m';
		$maximum_concurrent_calls_limit = shell_exec($script_path1);
		$maximum_concurrent_calls_limit = trim($maximum_concurrent_calls_limit);
		 
		// run script for current call count
		$script_path2 = '/usr/local/bin/get-calls-info -c';
		$current_call_count = shell_exec($script_path2);
		 
		 // Get limits from licinfo
		$script_path3 = '/usr/local/bin/licinfo -f';
		$licinfo_limits = shell_exec($script_path3);
		$lic_limits = explode(',',$licinfo_limits);

		if (count($lic_limits) > 1)
		{
			$maximum_intercom_calls = $lic_limits[0];
			$maximum_page_stacking_queues = $lic_limits[1];
			$station_limit = $lic_limits[2];
			$pagezone_limit = $lic_limits[3];
		}
		else
		{
			// run script for station limit
			$script_path4 = '/usr/local/bin/licinfo -s';
			$station_limit = shell_exec($script_path4);

			// run script for page zone limit
			$script_path5 = '/usr/local/bin/licinfo -z';
			$pagezone_limit = shell_exec($script_path5);
		
			// run script for maximum intercom calls allowed
			$script_path6 = '/usr/local/bin/licinfo -i';
			$maximum_intercom_calls = shell_exec($script_path6);

			// run script for Maximum Page Stacking Queues
			$script_path7 = '/usr/local/bin/licinfo -q';
			$maximum_page_stacking_queues = shell_exec($script_path7);
		}
		
		 // get current station count
		$current_station_count = Station::whereNotIn('device_type', [14, 15])->whereNotIn('type', [27,28])->where('id','!=','1')->count();
		
		// get current page zone count
		$current_pagezone_count = Pagingzone::count();
		
		// Queue Count
		$queue_count = Zones_queue::count();
		
		$c4000_check = Product_feature::where('label','like', '%C4000%')->count();
		
		if($station_limit=='0'){ $station_limit = 'Unlimited';};
		if($pagezone_limit=='0'){ $pagezone_limit = 'Unlimited';}
		if($maximum_intercom_calls=='0' && $c4000_check=='0'){ $maximum_intercom_calls = 'Unlimited';}
		
        $spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
        $spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$maximum_concurrent_calls_limit.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$current_call_count.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$station_limit.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$current_station_count.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$pagezone_limit.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$current_pagezone_count.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$maximum_intercom_calls.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$queue_count.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$maximum_page_stacking_queues.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
       
        $spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
		// End Product Licensing Information Worksheet
		
		// Start Weather ALert Filters Worksheet
		$spreadsheet_data .= '<ss:Worksheet ss:Name="Weather Alert Filters">'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
		
		$filtersArray = ['Event','Action Type','Enabled','Severity Extreme','Severity Severe','Severity Moderate','Severity Minor','Severity Unknown','Severity Notset','Certainty Observed','Certainty Likely','Certainty Possible','Certainty Unlikely','Certainty Unknown','Certainty Notset','Urgency Immediate','Urgency Expected','Urgency Future','Urgency Past','Urgency Notset','Urgency Unknown','Response Shelter','Response Evacuate','Response Prepare','Response Execute','Response Avoid','Response Monitor','Response Assess','Response Allclear','Response None','Response Notset'];
	
		foreach($filtersArray as $filters_header_name){
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$filters_header_name.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
		}
		$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		
		// Weather ALert Filters data
		$weather_alert_filters = Weather_alert_filter::get();
			
		foreach($weather_alert_filters as $filter){
			$spreadsheet_data .= '<ss:Row ss:StyleID="1">'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$filter->event.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$filter->action_type.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			$enabled = '';
			if($filter->enabled==1){ $enabled = 'Yes'; } else { $enabled = 'No'; }
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$enabled.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
			$severity_extreme = '';
			if($filter->severity_extreme==1){ $severity_extreme = 'Yes'; } else { $severity_extreme = 'No'; }
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$severity_extreme.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
			$severity_severe = '';
			if($filter->severity_severe==1){ $severity_severe = 'Yes'; } else { $severity_severe = 'No'; }
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$severity_severe.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
            $severity_moderate = '';
			if($filter->severity_moderate==1){ $severity_moderate = 'Yes'; } else { $severity_moderate = 'No'; }
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$severity_moderate.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
			$severity_minor = '';
			if($filter->severity_minor==1){ $severity_minor = 'Yes'; } else { $severity_minor = 'No'; }
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$severity_minor.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
			$severity_unknown = '';
			if($filter->severity_unknown==1){ $severity_unknown = 'Yes'; } else { $severity_unknown = 'No'; }
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$severity_unknown.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
			$severity_notset = '';
			if($filter->severity_notset==1){ $severity_notset = 'Yes'; } else { $severity_notset = 'No'; }
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$severity_notset.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
			$certainty_observed = '';
			if($filter->certainty_observed==1){ $certainty_observed = 'Yes'; } else { $certainty_observed = 'No'; }
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$certainty_observed.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
			$certainty_likely = '';
			if($filter->certainty_likely==1){ $certainty_likely = 'Yes'; } else { $certainty_likely = 'No'; }
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$certainty_likely.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
			$certainty_possible = '';
			if($filter->certainty_possible==1){ $certainty_possible = 'Yes'; } else { $certainty_possible = 'No'; }
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$certainty_possible.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
			$certainty_unlikely = '';
			if($filter->certainty_unlikely==1){ $certainty_unlikely = 'Yes'; } else { $certainty_unlikely = 'No'; }
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$certainty_unlikely.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
			$certainty_unknown = '';
			if($filter->certainty_unknown==1){ $certainty_unknown = 'Yes'; } else { $certainty_unknown = 'No'; }
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$certainty_unknown.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
			$certainty_notset = '';
			if($filter->certainty_notset==1){ $certainty_notset = 'Yes'; } else { $certainty_notset = 'No'; }
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$certainty_notset.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
			$urgency_immediate = '';
			if($filter->urgency_immediate==1){ $urgency_immediate = 'Yes'; } else { $urgency_immediate = 'No'; }
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$urgency_immediate.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
			$urgency_expected = '';
			if($filter->urgency_expected==1){ $urgency_expected = 'Yes'; } else { $urgency_expected = 'No'; }
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$urgency_expected.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
			$urgency_future = '';
			if($filter->urgency_future==1){ $urgency_future = 'Yes'; } else { $urgency_future = 'No'; }
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$urgency_future.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
			$urgency_past = '';
			if($filter->urgency_past==1){ $urgency_past = 'Yes'; } else { $urgency_past = 'No'; }
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$urgency_past.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
			$urgency_notset = '';
			if($filter->urgency_notset==1){ $urgency_notset = 'Yes'; } else { $urgency_notset = 'No'; }
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$urgency_notset.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
			$urgency_unknown = '';
			if($filter->urgency_unknown==1){ $urgency_unknown = 'Yes'; } else { $urgency_unknown = 'No'; }
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$urgency_unknown.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
			$response_shelter = '';
			if($filter->response_shelter==1){ $response_shelter = 'Yes'; } else { $response_shelter = 'No'; }
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$response_shelter.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
			$response_evacuate = '';
			if($filter->response_evacuate==1){ $response_evacuate = 'Yes'; } else { $response_evacuate = 'No'; }
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$response_evacuate.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
			$response_prepare = '';
			if($filter->response_prepare==1){ $response_prepare = 'Yes'; } else { $response_prepare = 'No'; }
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$response_prepare.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
			$response_execute = '';
			if($filter->response_execute==1){ $response_execute = 'Yes'; } else { $response_execute = 'No'; }
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$response_execute.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
			$response_avoid = '';
			if($filter->response_avoid==1){ $response_avoid = 'Yes'; } else { $response_avoid = 'No'; }
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$response_avoid.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
			$response_monitor = '';
			if($filter->response_monitor==1){ $response_monitor = 'Yes'; } else { $response_monitor = 'No'; }
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$response_monitor.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
			$response_assess = '';
			if($filter->response_assess==1){ $response_assess = 'Yes'; } else { $response_assess = 'No'; }
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$response_assess.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
			$response_allclear = '';
			if($filter->response_allclear==1){ $response_allclear = 'Yes'; } else { $response_allclear = 'No'; }
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$response_allclear.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
			$response_none = '';
			if($filter->response_none==1){ $response_none = 'Yes'; } else { $response_none = 'No'; }
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$response_none.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
			
			$response_notset = '';
			if($filter->response_notset==1){ $response_notset = 'Yes'; } else { $response_notset = 'No'; }
			$spreadsheet_data .= '<ss:Cell><ss:Data ss:Type="String">'.$response_notset.'</ss:Data></ss:Cell>'. '' . PHP_EOL;
					
			$spreadsheet_data .= '</ss:Row>'. '' . PHP_EOL;
		}
		$spreadsheet_data .= '</ss:Table>'. '' . PHP_EOL;
		$spreadsheet_data .= '</ss:Worksheet>'. '' . PHP_EOL;
		// End Weather ALert Filters Worksheet
		
		$spreadsheet_data .= '</ss:Workbook>'. '' . PHP_EOL;
		
		return $spreadsheet_data;
	}
	
	 public function license()
    {
		// restricted by permission
		if(Gate::denies('view_systems') || Gate::denies('edit_systems')  || Gate::denies('view_facilities')) {
			// send growl notification
			session()->flash('growl_notification.message','You no longer have permissions to view product license.');
			session()->flash('growl_notification.level','danger');
			return redirect('dashboard');
		} 
		
		// help topics
		$topicurl = '';
		$help = Help::where('mapid','like','system_license')->get()->first();
		$system_help = System_help::all();
		if(count($help)>0){
			$topicurl = $help->topicurl;
		}
		 
		$c4000_check = Product_feature::where('label','like', '%C4000%')->count();
		   
		return view('system.license', compact('topicurl','c4000_check','system_help'));
	}
	
	public function load_licensing_information($sleep){
		
		if($sleep==1){
			sleep(1);
		}
		
		// restricted by permission
		if(Gate::denies('view_systems') || Gate::denies('edit_systems')  || Gate::denies('view_facilities')) {
			// send growl notification
			session()->flash('growl_notification.message','You no longer have permissions to view product license.');
			session()->flash('growl_notification.level','danger');
			return redirect('dashboard');
		} 
		
		// run script for maximum concurrent calls limit
		$script_path1 = '/usr/local/bin/get-calls-info -m';
		$maximum_concurrent_calls_limit = shell_exec($script_path1);
		$maximum_concurrent_calls_limit = trim($maximum_concurrent_calls_limit);
		 
		// run script for current call count
		$script_path2 = '/usr/local/bin/get-calls-info -c';
		$current_call_count = shell_exec($script_path2);
		 
		 // Get limits from licinfo
		$script_path3 = '/usr/local/bin/licinfo -f';
		$licinfo_limits = shell_exec($script_path3);
		$lic_limits = explode(',',$licinfo_limits);

		if (count($lic_limits) > 1)
		{
			$maximum_intercom_calls = $lic_limits[0];
			$maximum_page_stacking_queues = $lic_limits[1];
			$station_limit = $lic_limits[2];
			$pagezone_limit = $lic_limits[3];
		}
		else
		{
			// run script for station limit
			$script_path4 = '/usr/local/bin/licinfo -s';
			$station_limit = shell_exec($script_path4);

			// run script for page zone limit
			$script_path5 = '/usr/local/bin/licinfo -z';
			$pagezone_limit = shell_exec($script_path5);
		
			// run script for maximum intercom calls allowed
			$script_path6 = '/usr/local/bin/licinfo -i';
			$maximum_intercom_calls = shell_exec($script_path6);

			// run script for Maximum Page Stacking Queues
			$script_path7 = '/usr/local/bin/licinfo -q';
			$maximum_page_stacking_queues = shell_exec($script_path7);
		}
		
		 // get current station count
		$current_station_count = Station::whereNotIn('device_type', [14, 15])->whereNotIn('type', [27,28])->where('id','!=','1')->count();
		
		// get current page zone count
		$current_pagezone_count = Pagingzone::count();
		
		// Queue Count
		$queue_count = Zones_queue::count();
		
		return $maximum_concurrent_calls_limit.'&'.$current_call_count.'&'.$station_limit.'&'.$current_station_count.'&'.$current_pagezone_count.'&'.$queue_count.'&'.$pagezone_limit.'&'.$maximum_intercom_calls.'&'.$maximum_page_stacking_queues;
	}
		
	 public function check_license_key($license_key)
    {
		// restricted by permission
		if(Gate::denies('view_systems') || Gate::denies('view_facilities')) {
			return redirect('dashboard');
		} 
		 $run_script;
		 $c4000_check = Product_feature::where('label','like', '%C4000%')->count();
		 preg_match("/(\d{4})-(\d{4})-(\d{4})-(\d{4})/", $license_key, $results);
		 preg_match("/([0-9A-Za-z]{4})-([0-9A-Za-z]{4})-([0-9A-Za-z]{4})-([0-9A-Za-z]{4})-([0-9A-Za-z]{4})/", $license_key, $results2);
		 if($c4000_check==0){ // E7000
			  // check format
			 if(count($results2)==6){
				 return 99; 
			 } else if(count($results)==5){
				 // run script
				$script_path = '/usr/local/bin/licinfo -u "'.$license_key.'"';
				$run_script = shell_exec($script_path);
				return $run_script;
			 } else {
				 return 99; 	 
			 }
		 } else { // C4000
			 // check format
			 if(count($results2)==6){
				 $license_key = strtoupper($license_key);
				 
				 if($license_key[0]=='N'){
					// run script
					$script_path = '/usr/local/bin/licinfo -A "'.$license_key.'"';
					$run_script = shell_exec($script_path);
					return $run_script;
				 }
				 if($license_key[0]=='P' && $license_key[1]=='C'){
					// run script
					$script_path = '/usr/local/bin/licinfo -u "'.$license_key.'"';
					$run_script = shell_exec($script_path);
					return $run_script;
				 }
				 if($license_key[0]=='F'){
					// run script
					$script_path = '/usr/local/bin/licinfo -u "'.$license_key.'"';
					$run_script = shell_exec($script_path);
					return $run_script;
				 }
			 } else {
				 return 99; 
			 }
		 }
	}
	
	 public function update_license()
    {
		// restricted by permission
		if(Gate::denies('view_systems') || Gate::denies('view_facilities')) {
			return redirect('dashboard');
		} 
		 
		$c4000_check = Product_feature::where('label','like', '%C4000%')->count();
		 
		 if($c4000_check ==0){ // E7000
			// run script
   	    	$script_path = '/usr/local/bin/licinfo -U';
	 		$run_script = shell_exec($script_path);
		 } else { // C4000
			// run script
   	    	$script_path = '/usr/local/bin/licinfo -A ""';
	 		$run_script = shell_exec($script_path);
		 }			
		return $run_script;
	}
	
	 public function release_license()
    {
		// restricted by permission
		if(Gate::denies('view_systems') || Gate::denies('view_facilities')) {
			return redirect('dashboard');
		} 
		
		// run script
   	    $script_path = '/usr/local/bin/licinfo -r';
	 	$run_script = shell_exec($script_path);
			
		return $run_script;
	}
	
	 public function get_current_activation_key()
    {
		// restricted by permission
		if(Gate::denies('view_systems') || Gate::denies('view_facilities')) {
			return redirect('dashboard');
		}
		 
		$c4000_check = Product_feature::where('label','like', '%C4000%')->count();
		
		// run script
   	    $script_path = '/usr/local/bin/licinfo -a';
	 	$run_script = shell_exec($script_path);
		 
		$activation_keys = '';
		 
		if($c4000_check==0){ // E7000
			$activation_keys = trim($run_script);
		} else { // C4000
			$activation_keys = trim($run_script);
			$activation_keys = str_replace(array("\n\r", "\n", "\r"), "<br>", $activation_keys);
			$activation_keys = '<pre style="width: 500px;">'.$activation_keys.'</pre>';
		}
		return  $activation_keys;
	}
	
	public function get_maintenance_expiration_date()
    {
		// restricted by permission
		if(Gate::denies('view_systems') || Gate::denies('view_facilities')) {
			return redirect('dashboard');
		}
		
		// run script
   	    $script_path = '/usr/local/bin/licinfo -d';
	 	$run_script = shell_exec($script_path);
		$run_script = trim($run_script);
			
		return $run_script;
	}
	
	public function get_license_expiration_date()
    {
		// restricted by permission
		if(Gate::denies('view_systems') || Gate::denies('view_facilities')) {
			return redirect('dashboard');
		}
		
		// run script
   	    $script_path = '/usr/local/bin/licinfo -e';
	 	$run_script = shell_exec($script_path);
			
		return $run_script;
	}
	
	 public function import_update()
    {	
		// restrict by permission
		if(Gate::denies('system_update') || Gate::denies('view_facilities') || Gate::denies('view_systems')) {
			// send growl notification
			session()->flash('growl_notification.message','You no longer have permissions to import system updates.');
			session()->flash('growl_notification.level','danger');
			return redirect('dashboard');
		}
		
		$clean_name = '';
		
		if (Input::hasFile('fileupload')){
			
		  $file = Input::file('fileupload');
		  $path = $file->getRealPath();
		  $size = $file->getSize();		
		  $mime = $file->getMimeType();
		  $name = $file->getClientOriginalName();
		  $extension = $file->getClientOriginalExtension();
			
		  // check for .tar OR .gz extension
		  $substring1 = substr($name ,-4);
		  $substring2 = substr($name ,-3);
		  if($substring1=='.tar' || $substring2=='.gz'){ 
		  } else {
			  // show modal
			  session()->flash('system_modal.message','The selected file must have a .tar or .gz extension.');
			  return redirect()->back()->withInput();
		  } 
		  
		  $clean_name = strtolower(str_replace([' ', '(', ')'], '', $name));
		  
		  $full_path = '/var/www/html/laravel/public/updates/'. $clean_name;
		  
		  // upload the file
		  $file->move('/var/www/html/laravel/public/updates/', $clean_name);
		  
		  // send growl notification
		  session()->flash('growl_notification.message','System update file uploaded.');
		  session()->flash('growl_notification.level','success');
		  return redirect('system/system_update');
		 
		} else {
			// show modal
			session()->flash('system_modal.message','File upload failed. Choose a file before uploading.');
		  	return redirect()->back()->withInput();
		}
	}
	
	 public function sort_menu()
    {
		// restrict by permission
		if(Gate::denies('view_systems') || Gate::denies('view_facilities') || Gate::denies('sort_menu')) {
			// send growl notification
			session()->flash('growl_notification.message','You no longer have permissions to sort the menu.');
			session()->flash('growl_notification.level','danger');
			return redirect('dashboard');
		} 
		
		$menu_items = Product_feature::
			where('parent', 'like' , 'facility')
			->where('is_enabled', '=' , '1')
			->where('has_navgroup', '=' , '1')
			->where('sort_order', '>' , '1')
			->orderBy('sort_order', 'asc')->get();
			
		$i=0;	
		$product_feature_ids = '';
		foreach($menu_items as $menu_item){
			if($i>0){
				$comma = ',';
			} else {
				$comma = '';
			}
			$product_feature_ids = $product_feature_ids . '' . $comma . ''. $menu_item->id;
			$i++;
		}
			
		// help topics
		$topicurl = '';
		$help = Help::where('mapid','like','system_sort_menu')->get()->first();
		if(count($help)>0){
			$topicurl = $help->topicurl;
		}
			
		return view('system.sort_menu', compact('menu_items','product_feature_ids','topicurl'));
		
	}
	
	public function update_menu($data)
    {
		// restrict by permission
		if(Gate::denies('view_systems') || Gate::denies('view_facilities') || Gate::denies('sort_menu')) {
			// send growl notification
			session()->flash('growl_notification.message','You no longer have permissions to sort the menu.');
			session()->flash('growl_notification.level','danger');
			return redirect('dashboard');
		} 
		
		$dataArray = explode(',', $data);
		
		// product_feature table changes
		$i=2;
		foreach($dataArray as $item){
			Product_feature::where('id', '=', $item)->update(['sort_order' => $i]);
			$i++;
			
			$product_feature = Product_feature::where('id', '=', $item)->first();
			$sub_menus = Product_feature::where('parent', 'like', $product_feature->name)->get();
			
			foreach($sub_menus as $sub_menu){
				Product_feature::where('id', '=', $sub_menu->id)->update(['sort_order' => $i]);
				$i++;
				
				$sub_menus2 = Product_feature::where('parent', 'like', $sub_menu->name)->get();
			
				foreach($sub_menus2 as $sub_menu2){
					Product_feature::where('id', '=', $sub_menu2->id)->update(['sort_order' => $i]);
					$i++;
					
				}
			}	
		}	
		
		// permissions table changes
		$j=3;
		foreach($dataArray as $item){
			
			$product_feature = Product_feature::where('id', '=', $item)->first();
			$permission = Permission::where('group', 'like', $product_feature->label_plural)->first();		
			Permission::where('group', 'like', $permission->group)->update(['sort_order' => $j]);
			$j++;
			
			$sub_menus = Permission::where('parent', 'like', $permission->group)->get();
			
			foreach($sub_menus as $sub_menu){
				
				Permission::where('group', 'like', $sub_menu->group)->update(['sort_order' => $j]);
				$j++;
				
				$sub_menus2 = Permission::where('parent', 'like', $sub_menu->group)->get();
				
				foreach($sub_menus2 as $sub_menu2){
				
					Permission::where('group', 'like', $sub_menu2->group)->update(['sort_order' => $j]);
					$j++;
				
				}
			}
		}
	}
	
	public function reset_menu()
    {
		// restrict by permission
		if(Gate::denies('view_systems') || Gate::denies('view_facilities') || Gate::denies('sort_menu')) {
			// send growl notification
			session()->flash('growl_notification.message','You no longer have permissions to reset the menu.');
			session()->flash('growl_notification.level','danger');
			return redirect('dashboard');
		} 
		
		// product feature sort order array
		$product_features =
		array(0,0,2,4,0,7,8,9,10,12,11,0,0,14,0,0,0,0,0,0,0,0,16,17,19,21,23,24,0,0,0,33,35,6,26,27,28,29,0,20,18,30,31,25,0,13,0,32,0,0,0,34,36,22,0,0,0,3,5,15,0,37,0,0,0,0,0,38);

		$i = 1;
		foreach($product_features as $product_feature){
			Product_feature::where('id', '=', $i)->update(['sort_order' => $product_feature]);
			$i++;
		}
		
		// permissions sort order array
		
		$e7000_check = Product_feature::where('label','like', '%E7000%')->get();
		$c4000_check = Product_feature::where('label','like', '%C4000%')->get();
		
		$permissions = array();
				
		if(count($e7000_check)>0){
			$permissions = array([1,7],[2,3],[3,1],[4,2],[5,6],[6,7],[7,8],[8,5],[9,11],[10,2],[11,12],[12,1],[13,3],[14,1],[15,1],[16,1],[17,2],[18,2],[19,2],[20,6],[21,6],[22,6],[23,7],[24,7],[25,7],[26,8],[27,8],[28,8],[29,5],[30,5],[31,5],[32,11],[33,11],[34,11],[35,12],[36,12],[37,12],[38,8],[39,6],[40,6],[41,6],[42,6],[43,3],[44,3],[45,3],[46,3],[47,1],[48,1],[49,4],[50,4],[51,4],[52,4],[53,5],[54,5],[55,10],[56,1],[57,1],[58,1],[59,1],[60,3],[61,3],[62,7],[63,7],[64,7],[65,7],[67,5],[68,1],[69,3],[70,4],[71,1],[72,14],[73,14],[74,15],[75,15],[76,15],[77,15],[78,16],[79,16],[80,5],[81,17],[82,17],[83,17],[84,17],[85,17],[86,17],[87,17],[88,4],[89,4],[90,4],[91,4],[92,2],[93,2],[94,2],[95,2],[96,2],[97,18],[98,3],[99,19],[100,19],[101,19],[102,3],[103,13],[104,13],[105,13],[106,13],[107,1],[108,1],[109,3],[110,9],[111,9],[112,9],[113,9],[114,9],[115,6],[116,2],[117,8],[118,20],[119,20],[120,20],[121,20],[122,0],[123,0],[124,0],[125,0],[126,6],[127,6],[128,6],[129,6],[130,7],[131,7],[132,7],[133,7],[134,8],[135,8],[136,8],[137,2],[138,2],[139,2],[140,2],[141,4],[142,9],[143,9],[144,9],[145,9],[146,9],[147,21],[148,21],[149,21],[150,21],[151,1],[152,1],[153,1],[154,1],[155,2],[156,2],[157,2],[158,2],[159,22],[160,21],[161,23],[162,23]);
		}
		
		if(count($c4000_check)>0){
			$permissions = array([1,7],[2,3],[3,1],[4,2],[5,6],[6,7],[7,8],[8,5],[9,11],[10,2],[11,12],[12,1],[13,3],[14,1],[15,1],[16,1],[17,2],[20,6],[21,6],[22,6],[23,7],[24,7],[25,7],[26,8],[27,8],[28,8],[29,5],[30,5],[31,5],[32,11],[33,11],[34,11],[35,12],[36,12],[37,12],[38,8],[39,6],[40,6],[41,6],[42,6],[43,3],[44,3],[45,3],[46,3],[47,1],[48,1],[49,4],[50,4],[51,4],[52,4],[53,5],[54,5],[55,10],[56,1],[57,1],[58,1],[59,1],[60,3],[61,3],[62,7],[63,7],[64,7],[65,7],[67,5],[68,1],[69,3],[70,4],[71,1],[72,14],[73,14],[74,15],[75,15],[76,15],[77,15],[78,16],[79,16],[80,5],[81,17],[82,17],[83,17],[84,17],[85,17],[86,17],[87,17],[88,4],[89,4],[90,4],[91,4],[92,2],[93,2],[94,2],[95,2],[96,2],[97,18],[98,3],[99,19],[100,19],[101,19],[102,3],[103,13],[104,13],[105,13],[106,13],[107,1],[108,1],[109,3],[115,6],[116,2],[117,8],[118,20],[119,20],[120,20],[121,20],[122,0],[123,0],[124,0],[125,0],[126,6],[127,6],[128,6],[129,6],[130,7],[131,7],[132,7],[133,7],[134,8],[135,8],[136,8],[137,2],[138,2],[139,2],[140,2],[141,4],[142,9],[143,9],[144,9],[145,9],[146,9],[147,21],[148,21],[149,21],[150,21],[151,1],[152,1],[153,1],[154,1],[155,2],[156,2],[157,2],[158,2],[159,22],[160,21],[161,23],[162,23]);
		}
		
		foreach($permissions as $permission){
			
			Permission::where('id', '=',$permission[0])->update(['sort_order' => $permission[1]]);
		}
		
		// send growl notification
		session()->flash('growl_notification.message','Menu reset.');
		session()->flash('growl_notification.level','success');
		return redirect('/system/sort_menu');	
	}
	
	public function restart_server($data)
    {
		// restricted by permission
		if(Gate::allows('restart_server')) {
			
		  if($data==1){
			  // run script - graceful restart
			  $script_path = '/usr/local/bin/run_server_cmd gracefulrestart';
			  $run_script = shell_exec($script_path);
		  }
		  if($data==2){
			  // run script - now restart
			  $script_path = '/usr/local/bin/run_server_cmd restart';
			  $run_script = shell_exec($script_path);
		  }
		  if($data==3){
			  // run script - force restart
			  $script_path = '/usr/local/bin/run_server_cmd kill';
			  $run_script = shell_exec($script_path);
		  }
		}
		
		return $data;
	}
	
	public function getDuplicateStations($data)
	{
		// restrict by permission
		if(Gate::denies('view_systems') || Gate::denies('view_facilities') || Gate::denies('edit_systems')) {
			return redirect('dashboard');
		} 
		
		$change = $data;
		$change2 = $change+1;
		$extensionsArray = array();
				
			$station_check = Station::where('extension', '!=', '1')->get();
			foreach($station_check as $record) {
				$extension = $record->extension;
	
				$extension = substr($extension, $change);
						  
			  $extensionsArray[] = $extension;
			  
			 }
			 $no_duplicates = array_unique($extensionsArray);
			 $duplicates = array_diff_assoc($extensionsArray, $no_duplicates);
			 
			 $stations = Station::
			 	leftJoin('station_types_enum', 'station_types_enum.id', '=', 'station.type')
				->select('station.name as name', 'station.extension as extension', 'station_types_enum.name as type_name', DB::raw('SUBSTRING(station.extension, '.$change2.') as new_extension'))
				->where('extension', '!=', '1')
				->orderBy('new_extension', 'asc')
				->orderBy('extension', 'asc')
				->get();
			 
			 $html = '<table class="table">
            		<thead>
              			<tr>
              				<th style="text-align:center">Old Extension</th>
							<th style="text-align:center"><span style="color:red">New Extension</span></th>
							<th style="text-align:center">Name</th>
							<th style="text-align:center">Type</th>
						</tr>
					</thead>
            		<tbody>';
					
					foreach($stations as $station) {
						$extension = substr($station->extension, $change);
						if(in_array($extension, $duplicates )){
							$html .= '<tr>
								<td style="text-align:center">'.$station->extension.'</td>
								<td style="text-align:center"><span style="color:red;font-weight: bold;">'.$station->new_extension.'</span></td>
								<td style="text-align:center">'.$station->name.'</td>
								<td style="text-align:center">'.$station->type_name.'</td>
							</tr>';
						}
					}
					$html .= '</tbody></table>';
						
			return $html;
		
	}
	
	public function getTrimErrorStations($data)
	{
		// restrict by permission
		if(Gate::denies('view_systems') || Gate::denies('view_facilities') || Gate::denies('edit_systems')) {
			return redirect('dashboard');
		} 
		
		$change = $data;
		$change2 = $change+1;
		$extensionsArray = array();
				
			$station_check = Station::where('extension', '!=', '1')->get();
			foreach($station_check as $record) {
				$extension = $record->extension;
	
				$extension = substr($extension, $change);
						  
			  $extensionsArray[] = $extension;
			  
			 }
			 $no_duplicates = array_unique($extensionsArray);
			 $duplicates = array_diff_assoc($extensionsArray, $no_duplicates);
			 
			 $stations = Station::
			 	leftJoin('station_types_enum', 'station_types_enum.id', '=', 'station.type')
				->select('station.name as name', 'station.extension as extension', 'station_types_enum.name as type_name', DB::raw('SUBSTRING(station.extension, '.$change2.') as new_extension'))
				->where('extension', '!=', '1')
				->orderBy('new_extension', 'asc')
				->orderBy('extension', 'asc')
				->get();
			 
			 $html = '<table class="table">
            		<thead>
              			<tr>
              				<th style="text-align:center">Old Extension</th>
							<th style="text-align:center"><span style="color:red">New Extension</span></th>
							<th style="text-align:center">Name</th>
							<th style="text-align:center">Type</th>
						</tr>
					</thead>
            		<tbody>';
					
					foreach($stations as $station) {
						$extension = substr($station->extension, $change);
						if(in_array($extension, [000,0000,00000,001,0001,00001])){
							$html .= '<tr>
								<td style="text-align:center">'.$station->extension.'</td>
								<td style="text-align:center"><span style="color:red;font-weight: bold;">'.$station->new_extension.'</span></td>
								<td style="text-align:center">'.$station->name.'</td>
								<td style="text-align:center">'.$station->type_name.'</td>
							</tr>';
						}
					}
					$html .= '</tbody></table>';
						
			return $html;
		
	}	
	public function saveIpAddresses($ip_address){
		
		// restrict by permission
		if(Gate::denies('view_systems') || Gate::denies('view_facilities') || Gate::denies('edit_systems')) {
			return redirect('dashboard');
		} 
		
		$ip_address_long = ip2long($ip_address);
		
		// update server_ipaddr
		System::where('id', '=', 1)->update(['server_ipaddr' => $ip_address_long]);
		
		// run script
		$script_path = 'sudo /usr/local/bin/change-server-ipaddr ' . $ip_address;
		$run_script = shell_exec($script_path);
		
		return $ip_address;
		
	}
	public function teamviewer_button($enabled){
			
		// restrict by permission
		if(Gate::denies('view_systems') || Gate::denies('view_facilities') || Gate::denies('edit_systems')) {
			return redirect('dashboard');
		} 
		
		// update the database
		if($enabled==0 || $enabled==1){
			System::where('id', '=', 1)->update(['teamviewer_enabled' => $enabled]);
		}
		
		// run script
		$script_path = '/usr/local/bin/run_server_cmd tvupdate';
		$run_script = shell_exec($script_path);
		
		return $enabled;
	}
	public function set_teamviewer_password($base64_password){
		
		// restrict by permission
		if(Gate::denies('view_systems') || Gate::denies('view_facilities') || Gate::denies('edit_systems')) {
			return redirect('dashboard');
		} 
		
		$password = str_replace("|", "/", $base64_password); // the "/" causes issues when passing in the url
		$password = base64_decode($password);
		
		// check for non alpha-numberic characters
		if(!preg_match("#^[a-zA-Z0-9]+$#", $password)){
			return 0;
		}
			
		if(strlen($password)>0){
			// run script
			$script_path = '/usr/local/bin/run_server_cmd tvpw ' . $password;
			$run_script = shell_exec($script_path);

			return 1;
		}
	}
	
	public function export_licenses(){
		
		// restrict by permission
		if(Gate::denies('view_systems') || Gate::denies('view_facilities') || Gate::denies('edit_systems')) {
			return 0;
		} 
		
		// run script 
		$hash = md5(date('Y-m-d H:i:s'));
		$script_path = 'sudo /usr/local/bin/export-keys /var/www/html/laravel/public/exports/license_keys_'.$hash.'.tar';
		$run_script = shell_exec($script_path);
		
		if($run_script==1){
			return 'license_keys_'.$hash.'.tar';

		} else {
			return '0';
		}
	}
	
	public function import_keys(Requests\SystemRequest $request)
    {	
		$clean_name = '';
		
		if (Input::hasFile('fileupload')){
			
		  $file = Input::file('fileupload');
		  $path = $file->getRealPath();
		  $size = $file->getSize();		
		  $mime = $file->getMimeType();
		  $name = $file->getClientOriginalName();
		  $extension = $file->getClientOriginalExtension();
			
		  // check for .tar OR .gz extension
		  $substring1 = substr($name ,-4);
		  if($substring1=='.tar'){ 
		  } else {
			  // send growl notification
			  session()->flash('growl_notification.message','The selected file must have a .tar extension.');
			  session()->flash('growl_notification.level','danger');
			  return redirect()->back()->withInput();
		  } 
			  
		  $clean_name = strtolower(str_replace(array(' ', '#', '"', '&', '(', ')', '%22', "'", ';'), '', $name));
		 
		  // upload the file
		  $file_path = '/var/www/html/laravel/public/exports/' . $clean_name;
		  $file->move('/var/www/html/laravel/public/exports', $clean_name);
				
		  // run script 
		  $script_path = '/usr/local/bin/import-keys ' . $file_path;
		  $run_script = shell_exec($script_path);
		  
		  if($run_script=='1'){
			  
			  // remove export file
			  if(file_exists($file_path))
			  {
				  unlink($file_path);
			  }
			  
			  	// send growl notification
				session()->flash('growl_notification.message','Import succeeded.');
				session()->flash('growl_notification.level','success');
		  	  	return redirect('system/license');
			  
		  } else {
			   // remove export file
			  if(file_exists($file_path))
			  {
				  unlink($file_path);
			  }
			  
			  	// send growl notification
				session()->flash('growl_notification.message','Import failed.');
				session()->flash('growl_notification.level','danger');
		  	  	return redirect()->back()->withInput(); 
		  }
		} else {
			// send growl notification
			session()->flash('growl_notification.message','Import failed. Choose a file before importing.');
			session()->flash('growl_notification.level','danger');
		  	return redirect()->back()->withInput();
		}
	}
	
	public function shutdown_server(){
		
		// restrict by permission
		if(Gate::denies('view_systems') || Gate::denies('view_facilities')) {
			return 0;
		} 
		
		// run script 
		$script_path = '/usr/local/bin/run_server_cmd sysshutdown dbogen1cnq';
		$run_script = shell_exec($script_path);
		
		return 1;
	}
	
	public function update_enable_routines_api($data){
		
		// restrict by permission
		if(Gate::denies('view_systems') ||  Gate::denies('edit_systems') || Gate::denies('view_facilities')) {
			return 999;
		} 
		
		if($data=='1' || $data=='0' ){
			
			$system = System::first();
			$enable_routines_api = $system->enable_routines_api;
			if($enable_routines_api!=$data){
				
				System::where('id', '=', 1)->update(['enable_routines_api' => $data]);
				
				return $data;
			} 
		} else {
			
			return 999;
		}
	}
	
	public function system_update(Request $request){
		
		 // restricted by permission
		if(Gate::denies('view_systems') || Gate::denies('edit_systems') || Gate::denies('view_facilities')) {
			// send growl notification
			session()->flash('growl_notification.message','You no longer have permissions to view system update.');
			session()->flash('growl_notification.level','danger');
			return redirect('dashboard');
		} 
		
		$product_feature = Product_feature::where('product_feature.class_name', 'like', 'system_update')->get()->first();
		
		$directory = '/var/www/html/laravel/public/updates';
		
		$files = array_diff(scandir($directory), array('..', '.'));
		
		// set ssu redirect
		$request->session()->forget('ssu_redirect');
		$request->session()->push('ssu_redirect', 'system/system_update');
		
		// run script 
		$script_path = 'sudo /usr/local/bin/nyquist-version';
		$version = shell_exec($script_path);
		
		// help topics
		$topicurl = '';
		$help = Help::where('mapid','like','software_update')->get()->first();
		if(count($help)>0){
			$topicurl = $help->topicurl;
		}
		
		return view('system.system_update',compact('product_feature','topicurl','files','version'));
		
	}
	
	public function check_for_updates(){
		
		 // restricted by permission
		if(Gate::denies('view_systems') || Gate::denies('edit_systems') || Gate::denies('view_facilities')) {
			// send growl notification
			session()->flash('growl_notification.message','You no longer have permissions to view check for system updates.');
			session()->flash('growl_notification.level','danger');
			return redirect('dashboard');
		} 
		
		// see if maintenance is valid
		// run script 
		$script_path = 'sudo /usr/local/bin/licinfo -M';
		$run_script = shell_exec($script_path);
			
		if($run_script=='0'){
			return 2;
		} else {
			// run script 
			$script_path = 'sudo /usr/local/bin/check-for-system-updates';
			$response = shell_exec($script_path);
		
			return $response;	
		}
	}
	
	public function download_system_updates(){
		
		 // restricted by permission
		if(Gate::denies('view_systems') || Gate::denies('edit_systems') || Gate::denies('view_facilities')) {
			// send growl notification
			session()->flash('growl_notification.message','You no longer have permissions to view check for system updates.');
			session()->flash('growl_notification.level','danger');
			return redirect('dashboard');
		} 
		
        // run script 
        $script_path = 'sudo /usr/local/bin/download-system-updates';
        $response = shell_exec($script_path);

        return $response;
	}
	
	public function view_release_notes($filename){
		
		 // restricted by permission
		if(Gate::denies('view_systems') || Gate::denies('edit_systems') || Gate::denies('view_facilities')) {
			return 999;
		} 
		
		$path = '';
		$version = '';
		
		if(strstr($filename,"patch")){
			$version = $filename;
			$version = str_replace('e7000-','',$version);
			$version = str_replace('c4000-','',$version);
			$version = str_replace('.tar.gz','',$version);
			
			$path = '/srv/tftp/Release-Notes-'.$version.'.txt';
		} else {
			$version = $filename;
			$version = str_replace('nyquist-e7000-','',$version);
			$version = str_replace('nyquist-c4000-','',$version);
			$version = str_replace('.tar.gz','',$version);
			$path = '/srv/tftp/Release-Notes-'.$version.'.txt';
		}
		
		// see if release notes exist
		$release_notes_text = '';
        
		if(file_exists($path) && is_readable($path)){
			
			$handle = fopen($path, "r");
            while (!feof($handle)) {
                $release_notes_text .= fgets($handle, 4096); // Read a line.
                $release_notes_text .= '<br/>';
            }
		}
		
		return $release_notes_text;
	}
	
	public function delete_system_update($filename){
		
		 // restricted by permission
		if(Gate::denies('view_systems') || Gate::denies('edit_systems') || Gate::denies('view_facilities')) {
			return 999;
		} 
		
		$update_path = '/var/www/html/laravel/public/updates/'.$filename;
		$release_notes_path = '';
		
		if(strstr($filename,"patch")){
			$version = $filename;
			$version = str_replace('e7000-','',$version);
			$version = str_replace('c4000-','',$version);
			$version = str_replace('.tar.gz','',$version);
			$release_notes_path = '/srv/tftp/Release-Notes-'.$version.'.txt';
		} else {
			$version = $filename;
			$version = str_replace('nyquist-e7000-','',$version);
			$version = str_replace('nyquist-c4000-','',$version);
			$version = str_replace('.tar.gz','',$version);
			$release_notes_path = '/srv/tftp/Release-Notes-'.$version.'.txt';
		}
		
		// remove update file
        if(file_exists($update_path))
        {
            unlink($update_path);
        }
		
		// remove release notes file
        if(file_exists($release_notes_path))
        {
            unlink($release_notes_path);
        }
		
		// send growl notification
		session()->flash('growl_notification.message','System update '.$filename.' deleted..');
		session()->flash('growl_notification.level','success');
		
		return 1;
	}
	
	public function run_system_update($filename){
		
		 // restricted by permission
		if(Gate::denies('view_systems') || Gate::denies('edit_systems') || Gate::denies('view_facilities')) {
			return 999;
		}
		
		// see if maintenance is valid
		// run script 
		$script_path = 'sudo /usr/local/bin/licinfo -M';
		$run_script = shell_exec($script_path);
			
		if($run_script=='0'){
			return 2;
		} else {
			// run script 
			$script_path = '/usr/local/bin/run_sysupdate ' . $filename;
			$response = shell_exec($script_path);
		
			return $response;
		}
	}
	
	public function check_internet_site_access(){
		
		// restricted by permission
		if(Gate::denies('view_systems') || Gate::denies('view_facilities')) {
			return 0;
		} 
		
		// run script 
		$script_path = '/usr/local/bin/check-site-access';
		$response = shell_exec($script_path);
		
		return $response;
	}
	public function check_server_status(){
		
		// restricted by permission
		if(Gate::denies('view_systems') || Gate::denies('view_facilities')) {
			return 0;
		} 
		
		// run script 
		$script_path = '/usr/local/bin/check-server-status';
		$response = shell_exec($script_path);
		
		return $response;
	}
}
